2025-07-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge sudo 1.9.17p2 from branch 'main' into sudo-1.9
	[d1b48c651]

	* configure, configure.ac:
	Fix check for which man page type to use with nroff

	Fixes a bug where configure would use *.man instead of *.mdoc on
	systems without mandoc. Bug #1077.
	[aa2498e46]

	* plugins/sudoers/log_client.c:
	client_msg_cb: make warning match the function that failed
	[f73162df3]

2025-07-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, configure, configure.ac:
	Sudo 1.9.17p2
	[f0e1a5ca3]

	* plugins/sudoers/match_command.c, plugins/sudoers/match_digest.c:
	digest_matches: plug fd leak on snprinf() failure
	[26a1a7529]

2025-07-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* etc/sudo-logsrvd.pp, etc/sudo-python.pp, etc/sudo.pp,
	scripts/mkpkg:
	Add a way to override pp_rpm_arch when building rpms

	This will be used to build x86_64_v2 packages for Alma Linux.
	[55d3c99c4]

	* configure, configure.ac:
	Fix check for which man page type to use with nroff

	Fixes a bug where configure would use *.man instead of *.mdoc on
	systems without mandoc.
	[2dc10cfbd]

	* plugins/sudoers/timestamp.c:
	ts_write: call lseek after fruncate on short write

	We need to make sure the file position is reset to the old EOF on
	error.
	[8e7e0e23f]

2025-07-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_ptrace.c:
	ptrace_readv_string: quiet sign-compare warning
	[fac2a49e7]

	* src/exec_ptrace.c:
	ptrace_readv_string: properly handle reads of more than one page

	When the "intercept" and "intercept_verify" options are enabled and
	either argv[] or envp[] contains a string larger than the page size
	(usually 4096), ptrace_readv_string() would fill the buffer with
	mutiple copies of the same string. Fixes GitHub issue #453.
	[2e93eabed]

2025-07-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	revoke_pty: use killpg() not kill() to send HUP to the process group

	Also make sure we never call killpg(-1, SIGHUP), which would send
	SIGHUP to process 1 (init). It is possible for cmnd_pid to be -1 in
	certain error conditions where sudo killed the command itself. This
	may explain GitHub issue #458.
	[fb208d383]

2025-07-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* etc/sudo-logsrvd.pp, etc/sudo-python.pp, etc/sudo.pp, scripts/pp:
	Don't assume RHEL major version is only a single digit

	Fixes handling of RHEL 10 and higher.
	[e5d953f33]

	* plugins/sudoers/visudo.c:
	visudo: create temporary file as mod 0600 not 0700

	This was due to a typo in the mode field when the temporary file was
	created. Noticed by Bjorn Baron of the sudo-rs project.
	[1c254b330]

2025-06-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* Makefile.in:
	We now build sudo releases from git, not mercurial
	[cb4e26734]

2025-06-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, configure, configure.ac:
	Sudo 1.9.17p1
	[a377770c6]

	* NEWS, configure, configure.ac:
	Sudo 1.9.17p1
	[23aff2b37]

2025-06-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo.man.in, docs/sudo.mdoc.in, docs/sudoers.man.in,
	docs/sudoers.mdoc.in, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y,
	plugins/sudoers/regress/sudoers/test24.toke.ok,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/regress/testsudoers/test26.out.ok,
	plugins/sudoers/visudo_cb.c, src/parse_args.c:
	Deprecate chroot support
	[7a6ee32a9]

2025-04-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/editor.c,
	plugins/sudoers/find_path.c, plugins/sudoers/goodpath.c,
	plugins/sudoers/match_command.c, plugins/sudoers/match_digest.c,
	plugins/sudoers/parse.h, plugins/sudoers/pivot.c,
	plugins/sudoers/pivot.h,
	plugins/sudoers/regress/editor/check_editor.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/resolve_cmnd.c, plugins/sudoers/stubs.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	Revert pivot_root and go back to prepending the new root directory.

	We cannot perform passwd/group lookups _after_ changing the root
	directory. This does mean that symbolic links in a path are not
	currently handled properly when matching chroot()ed commands.

	Fixes a local privilege escalation vulnerability where a user could
	craft their own nsswitch.conf file to load a shared library of their
	choosing and run arbitrary code. CVE-2025-32463

	Reported by Rich Mirch @ Stratascale Cyber Research Unit (CRU).
	[fffcc07c5]

2025-04-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.c:
	Only allow a remote host to be specified when listing privileges.

	This fixes a bug where a user with sudoers privileges on a different
	host could execute a command on the local host, even if the sudoers
	file would not otherwise allow this. CVE-2025-32462

	Reported by Rich Mirch @ Stratascale Cyber Research Unit (CRU).
	[f8ff956e1]

2025-06-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo.man.in, docs/sudo.mdoc.in, docs/sudoers.man.in,
	docs/sudoers.mdoc.in, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y,
	plugins/sudoers/regress/sudoers/test24.toke.ok,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/regress/testsudoers/test26.out.ok,
	plugins/sudoers/visudo_cb.c, src/parse_args.c:
	Deprecate chroot support
	[bc88e5cbd]

2025-04-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/editor.c,
	plugins/sudoers/find_path.c, plugins/sudoers/goodpath.c,
	plugins/sudoers/match_command.c, plugins/sudoers/match_digest.c,
	plugins/sudoers/parse.h, plugins/sudoers/pivot.c,
	plugins/sudoers/pivot.h,
	plugins/sudoers/regress/editor/check_editor.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/resolve_cmnd.c, plugins/sudoers/stubs.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	Revert pivot_root and go back to prepending the new root directory.

	We cannot perform passwd/group lookups _after_ changing the root
	directory. This does mean that symbolic links in a path are not
	currently handled properly when matching chroot()ed commands.

	Fixes a local privilege escalation vulnerability where a user could
	craft their own nsswitch.conf file to load a shared library of their
	choosing and run arbitrary code. CVE-2025-32463

	Reported by Rich Mirch @ Stratascale Cyber Research Unit (CRU).
	[fdafc2ceb]

2025-04-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.c:
	Only allow a remote host to be specified when listing privileges.

	This fixes a bug where a user with sudoers privileges on a different
	host could execute a command on the local host, even if the sudoers
	file would not otherwise allow this. CVE-2025-32462

	Reported by Rich Mirch @ Stratascale Cyber Research Unit (CRU).
	[d53036782]

2025-06-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST:
	Add missing tests
	[51c348810]

2025-06-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge sudo 1.9.17 from branch 'main' into sudo-1.9
	[84e7ca675]

2025-06-17  Rose  <gfunni234@gmail.com>

	* lib/iolog/iolog_write.c, plugins/python/regress/iohelpers.c,
	plugins/sudoers/sudo_printf.c, src/conversation.c:
	Properly check against errors against fwrite

	fwrite is not the same as write; you have to explicitly compare
	against the length to detect errors, and sometimes number of items
	is mistaken for length.
	[5fad16bda]

2025-06-12  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/CONTRIBUTING.md:
	No more mercurial repo, point to git.sudo.ws instead.
	[e6cf241b0]

2025-06-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	fix typo
	[fd6aa4932]

2025-06-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/po/ca.mo, plugins/sudoers/po/ca.po,
	plugins/sudoers/po/fur.mo, plugins/sudoers/po/fur.po,
	plugins/sudoers/po/hr.mo, plugins/sudoers/po/hr.po,
	plugins/sudoers/po/it.mo, plugins/sudoers/po/it.po,
	plugins/sudoers/po/pt.mo, plugins/sudoers/po/pt.po,
	plugins/sudoers/po/pt_BR.mo, plugins/sudoers/po/pt_BR.po,
	plugins/sudoers/po/sr.mo, plugins/sudoers/po/sr.po,
	plugins/sudoers/po/zh_TW.mo, plugins/sudoers/po/zh_TW.po, po/ca.mo,
	po/ca.po, po/fur.mo, po/fur.po, po/hr.mo, po/hr.po, po/it.mo,
	po/it.po, po/pt.mo, po/pt.po, po/pt_BR.mo, po/pt_BR.po, po/sr.mo,
	po/sr.po, po/yue.mo, po/zh_TW.mo, po/zh_TW.po:
	Updated translations from translationproject.org
	[04a811750]

	* plugins/sudoers/po/sudoers.pot, po/sudo.pot:
	Update .pot files for 1.9.17
	[d861a00a6]

	* NEWS, configure, configure.ac:
	Sudo 1.9.17
	[cb3355e9d]

	* MANIFEST:
	Add Cantonese translation from GitHub
	[60fff3a3d]

	* scripts/check_man.in:
	Fix typo
	[57f67f67f]

2025-03-13  cantonese-sra  <cantonese.sra@proton.me>

	* po/yue.mo, po/yue.po:
	yue translation
	[666d8c175]

2025-06-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/env.c:
	Fix typo
	[ee1383e31]

2025-06-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo.man.in, docs/sudo.mdoc.in, plugins/sudoers/env.c:
	Add SUDO_TTY environment variable if the user has a tty

	This can be used to find the user's original tty device when sudo
	runs the command in its own pty. GitHub issue #447.
	[afd01d856]

2025-06-04  Rose  <gfunni234@gmail.com>

	* lib/iolog/regress/iolog_path/check_iolog_path.c,
	logsrvd/iolog_writer.c:
	Restrict-qualify a few methods that are listed as such
	[a925829e6]

2025-05-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_util.h, lib/util/term.c, lib/util/util.exp.in,
	src/tgetpass.c:
	Use TCSAFLUSH not TCSADRAIN when disabling echo

	A long time ago this was changed from TCSAFLUSH to TCSADRAIN due to
	some systems having problems with TCSAFLUSH. That should no longer
	be a concern. Using TCSAFLUSH ensures that password input that has
	been received by the kernel, but not yet read by sudo, will be
	discarded and not echoed.
	[77fe6ae51]

2025-04-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/logging.c:
	log_failure: only display "command not found" if running a command

	If the user is not allowed to run a command, we try to give them a
	more useful message than "Sorry, user foo may not run sudo on bar."
	However, this should only be done when running, not listing, a
	command. Otherwise, it would be possible for a user with no sudo
	privileges to use "sudo -l /path/to/some/command" to determine
	whether an executable exists in a directory that they do not have
	search access to.
	[82ebb1eaa]

2025-03-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/passwd.c:
	Use constant-time string compare for plain text password check.

	Avoid potential password guessing based on timing attacks on the
	strcmp() function. Reported by Quarkslab.
	[111fd83fb]

2025-04-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/check.c:
	check_user: refactor the "running as self" check into its own
	function
	[a294a8be0]

	* plugins/sudoers/check.c:
	check_user: restrict the special case for running as the invoking
	user

	The intent is to allow the user to run a command or edit a file as
	themself without entering a password. It should not apply to listing
	a command via "sudo -l command".
	[28837b2af]

2025-04-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/cvtsudoers.man.in, docs/sudo.conf.man.in, docs/sudo.man.in,
	docs/sudo_logsrv.proto.man.in, docs/sudo_logsrvd.conf.man.in,
	docs/sudo_logsrvd.man.in, docs/sudo_plugin.man.in,
	docs/sudo_plugin_python.man.in, docs/sudo_sendlog.man.in,
	docs/sudoers.ldap.man.in, docs/sudoers.man.in,
	docs/sudoers_timestamp.man.in, docs/sudoreplay.man.in,
	docs/visudo.man.in:
	Regenerate man format manuals
	[9c98d0f4a]

	* docs/sudo.conf.mdoc.in, examples/sudo.conf.in:
	Sync "Path intercept" comment with default sudo.conf and man page
	[b876e3bbf]

2025-04-28  peppapig450  <peppapig450@pm.me>

	* docs/sudo_logsrv.proto.mdoc.in:
	Fix typo and update Protocol Buffers URL in sudo_logsrv.proto man
	page

	- Remove duplicate "The" in description of log_id field. - Update
	outdated Protocol Buffers link from
	https://developers.google.com/protocol-buffers/ to
	https://protobuf.dev, the new canonical URL.

	Signed-off-by: peppapig450 <peppapig450@pm.me>
	[d173674c2]

	* docs/sudoers.ldap.mdoc.in:
	Fix minor grammar errors in sudoers.ldap man page

	Signed-off-by: peppapig450 <peppapig450@pm.me>
	[334e23183]

	* docs/cvtsudoers.mdoc.in, docs/sudo.mdoc.in,
	docs/sudo_logsrv.proto.mdoc.in, docs/sudo_logsrvd.conf.mdoc.in,
	docs/sudo_logsrvd.mdoc.in, docs/sudo_plugin.mdoc.in,
	docs/sudo_plugin_python.mdoc.in, docs/sudo_sendlog.mdoc.in,
	docs/sudoers.ldap.mdoc.in, docs/sudoers.mdoc.in,
	docs/sudoers_timestamp.mdoc.in, docs/sudoreplay.mdoc.in,
	docs/visudo.mdoc.in:
	Fix typo: 'Please not report' → 'Please do not report' in
	documentation

	Signed-off-by: peppapig450 <peppapig450@pm.me>
	[aa5d4b2b4]

	* docs/sudo.conf.mdoc.in:
	Fix minor grammar and spelling issues in sudo.conf man page

	Signed-off-by: peppapig450 <peppapig450@pm.me>
	[2f4d6bfe2]

2025-03-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/iolog_writer.c, logsrvd/logsrvd_local.c,
	plugins/audit_json/audit_json.c:
	Free existing contents of struct eventlog before overwriting.

	In the unlikely event that there are duplicate keys in info_msgs,
	free the old string before overwriting with the new one.
	[ce0ec8ddc]

	* src/tgetpass.c:
	Use a pointer to end of buffer instead of tracking space left.

	Fixes a problem in feedback mode where an initial backspace would
	reduce the effective buffer size. GitHub issue #439
	[e8695d536]

2025-03-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .gitignore, .hgignore:
	Ignore scripts/check_man
	[627ae4b09]

2025-03-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* INSTALL.md, config.h.in, configure, configure.ac,
	plugins/sudoers/defaults.c:
	Make ignore_dot the default

	Add --disable-ignore-dot to disable it and deprecate
	--with-ignore-dot.
	[fce45b276]

2025-02-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_logsrv.proto.man.in, docs/sudo_logsrv.proto.mdoc.in,
	docs/sudo_logsrvd.conf.man.in, docs/sudo_logsrvd.conf.mdoc.in,
	docs/sudoers.man.in, docs/sudoers.mdoc.in, docs/sudoreplay.man.in,
	docs/sudoreplay.mdoc.in:
	Dash/hyphen related style fixes from check_man.
	[ff3c2185f]

	* scripts/check_man.in:
	Add hyphen/dash checks
	[eae70b05c]

2025-02-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, configure, configure.ac, docs/Makefile.in,
	scripts/check_man.in:
	Add check_man script to check for man page warnings.
	[c2e77b713]

2025-02-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_plugin_python.man.in, docs/sudo_plugin_python.mdoc.in:
	Sync sudo.DEBUG descriptions with comments in sudo_debug.h.
	[38c0bdd7a]

2025-02-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo.conf.man.in, docs/sudo.conf.man.in.sed,
	docs/sudo.man.in, docs/sudo.man.in.sed, docs/sudoers.man.in,
	docs/sudoers.man.in.sed:
	Sync sed scripts that add back troff conditionals.

	The sudo manuals contain conditional to avoid describing
	system-specific behavior on systems that don't support it. When we
	convert from mdoc to man format we lose those conditionals, these
	sed scripts add them back. Changes to the mdoc files can prevent the
	regexps from matching so they need to be updated periodically.
	[cf1b87c71]

2025-02-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/cvtsudoers.man.in, docs/cvtsudoers.mdoc.in,
	docs/sudo_plugin_python.man.in, docs/sudo_plugin_python.mdoc.in:
	Fix some style warnings from "mandoc -Tlint"
	[4d331e602]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Style fixes from Bjarni Ingi Gislason.
	[3ba525a34]

2025-02-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Most Defaults entries are applied in order.

	The exceptions are command-specific Defaults (which cannot be
	applied until the command's path is resolved) and a small number of
	"early" defaults that affect other entries.
	[b04386f63]

2025-02-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/Makefile.in, lib/util/mksiglist.c, lib/util/mksigname.c:
	Only use system includes for mksiglist and mksigname.

	These are standalone programs that run on the host system (which may
	differ from the target system) so we should not include config.h and
	sudo_compat.h.
	[1bdead1bb]

	* Makefile.in, lib/eventlog/Makefile.in, lib/fuzzstub/Makefile.in,
	lib/iolog/Makefile.in, lib/logsrv/Makefile.in,
	lib/protobuf-c/Makefile.in, lib/ssl_compat/Makefile.in,
	lib/util/Makefile.in, logsrvd/Makefile.in,
	plugins/audit_json/Makefile.in, plugins/group_file/Makefile.in,
	plugins/python/Makefile.in, plugins/sample/Makefile.in,
	plugins/sample_approval/Makefile.in, plugins/sudoers/Makefile.in,
	plugins/system_group/Makefile.in, src/Makefile.in:
	No longer need to define NSIG for cppcheck.

	There is now a configure check that defines it as needed.
	[b0d94331c]

2025-02-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_monitor.c, src/exec_nopty.c, src/exec_pty.c:
	Split the code to fill an exec closure into two functions.

	This lets us initialize the exec closure early and fill in the
	events later. It also makes things consistent with the exec_pty
	version.
	[1032030f8]

2025-02-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac, docs/Makefile.in:
	Run groff with warnings enabled for "make lint".
	[a4a999b5e]

	* lib/util/getentropy.c, src/sudo.c:
	Prefer POSIX getpgrp() to getpgid(0).

	We use getpgrp() in most place so prefer it for consistency with the
	rest of the code base.
	[257a078a8]

	* docs/sudo.man.in, docs/sudo_logsrv.proto.man.in,
	docs/sudoers.man.in, docs/visudo.man.in:
	regen
	[8feff96d3]

	* docs/visudo.mdoc.in:
	Make DIAGNOSTICS descriptions indent consistent with sudo.mdoc.in.
	[d3293c528]

2025-02-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo.mdoc.in, docs/visudo.mdoc.in:
	Avoid using ".It Li foo ..." in sudo manuals.

	The .Li macro is deprecated and makes no difference on terminal
	devices. Also avoid using items greater than 80 characters which
	will wrap incorrectly. Bug #1075.
	[dc0f16dbc]

	* docs/sudo.mdoc.in, docs/sudo_logsrv.proto.mdoc.in,
	docs/sudoers.mdoc.in:
	Fix warnings from groff -mandoc -t -K utf8 -rF0 -rHY=0 -ww -b -z

	Specify list offset and width in ens where applicable. Shorten the
	ttyname description in sudo_logsrv.proto.mdoc.in. Bug #1075.
	[aad69105d]

2025-02-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* etc/sudo-logsrvd.pp, etc/sudo-python.pp, etc/sudo.pp:
	Only package parent directories that match a non-default prefix

	For example, if sudo is installed into /opt/sudo we only want to
	package directories under /opt and not /var.
	[a9e112079]

	* plugins/sudoers/Makefile.in:
	regen
	[43f16c1d2]

	* MANIFEST:
	Add lib/util/login_max.c
	[4bb4c6a15]

2025-01-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	Initialize exec closure before calling
	sudo_fatal_callback_register()

	The pty_cleanup() function, which may be called via
	fatal()/fatalx(), expects that ec->details is set. If there is a
	fatal error after the cleanup hook is registered but before the exec
	closure it filled in, pty_cleanup() would dereference a NULL
	pointer. Reported by Bjorn Baron.
	[0be9f0f94]

2025-01-17  Mateusz Piotrowski  <0mp@FreeBSD.org>

	* src/exec_pty.c:
	Fix a typo in the description of exec_pty()
	[6fc816d90]

2025-01-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/ttyname_dev.c:
	Quiet a -Wconversion warning.
	[a5bca1b94]

2025-01-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/fuzzstub/fuzzstub.c, lib/iolog/iolog_nextid.c,
	lib/iolog/regress/iolog_filter/check_iolog_filter.c,
	lib/util/event.c, lib/util/regress/fuzz/fuzz_sudo_conf.c,
	logsrvd/logsrvd.c, logsrvd/logsrvd_local.c, logsrvd/logsrvd_relay.c,
	logsrvd/regress/fuzz/fuzz_logsrvd_conf.c, logsrvd/sendlog.c,
	plugins/sudoers/ldap.c, plugins/sudoers/log_client.c,
	plugins/sudoers/timestamp.c, plugins/sudoers/tsdump.c,
	plugins/sudoers/visudo.c, src/conversation.c, src/copy_file.c,
	src/exec_monitor.c, src/exec_ptrace.c, src/sudo_intercept_common.c,
	src/tgetpass.c, src/ttyname.c:
	Check for negative return value of read, write and lseek instead of
	-1

	The return values are used in ways that assume they are positive. In
	practice, it is not possible to have a negative return value other
	than -1 due to the size of the buffers being read from or written
	to. Also add overflow checks when updating the buffer len. Quiets
	several coverity warnings.
	[a27b989c9]

2025-01-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .github/workflows/main.yml:
	Switch to upload-sarif v3
	[6df96785f]

	* .github/workflows/codeql-analysis.yml:
	Update codeql GitHub actions to a non-deprecated version.
	[7cc0a0cc4]

	* .github/workflows/main.yml:
	Use upload-artifact@v4, v3 is deprecated.
	[c5b86f06e]

2025-01-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec.c, src/exec_nopty.c, src/exec_pty.c, src/sudo_exec.h:
	Check the controlling tty to determine if a tty belongs to the user.

	Previously, we compared the terminal device number returned by
	get_process_ttyname() with that of stdin, stdout and stderr. This
	causes problems on Linux if the user is logged in on the console,
	which is a virtual device that may correspond to one of several
	different terminal devices. In this specific case, there is a
	mismatch between the controlling terminal listed in /proc/self/stat
	(which corresponds to the underlying terminal device) and the device
	number of stdin, stdout and stderr (which is that of /dev/console).
	[fd3ff3a0b]

	* lib/util/login_max.c, plugins/sudoers/cvtsudoers_pwutil.c,
	plugins/sudoers/pwutil_impl.c:
	Move LOGIN_NAME_MAX compat define to login_max.c
	[a3cd820d2]

2025-01-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/toke_util.c:
	copy_string: use an end pointer to quiet a coverity warning

	Instead of modifying the len parameter and using it for bounds
	checking, compute the end of the source string and bound check on
	that instead. Also simplify the code slightly and enable debugging.
	[e3753309f]

	* plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	expand_include: initialize dst_size to 1 to quiet coverity warning

	This could only be an issue if the sudoers file was an empty string,
	which is not possible.
	[af4634a1c]

	* plugins/sudoers/match_digest.c:
	digest_matches: don't initialize digest_len to -1

	This was done to quiet a coverity warning but newer coverity now
	warns about this instead.
	[34a3c84de]

	* lib/util/setgroups.c:
	Check for sysconf() negative return value instead of -1

	Quiets a coverity warning.
	[0fdbb6e2e]

	* include/sudo_util.h, lib/util/Makefile.in, lib/util/gethostname.c,
	lib/util/login_max.c, lib/util/util.exp.in,
	plugins/sudoers/cvtsudoers_pwutil.c, plugins/sudoers/match.c,
	plugins/sudoers/pwutil_impl.c:
	Add sudo_login_name_max() and sudo_host_name_max()

	These convenience functions cache the value and handle any potenial
	errors from sysconf().
	[405070d48]

	* config.h.in, configure, configure.ac, include/sudo_util.h:
	Add an OFF_T_MAX define

	This will be used for integer overflow checks when copying files.
	[7c075c100]

2025-01-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* LICENSE.md:
	Update copyright year
	[30729312c]

2025-01-15  Ignacy Gawędzki  <ignacy.gawedzki@green-communications.fr>

	* src/ttyname.c:
	Fix getting ppid in get_process_ttyname for Linux.

	The ppid field in /proc/self/stat is the fourth and not the third.
	The latter is the process state (S, R, etc.).

	Signed-off-by: Ignacy Gawędzki
	<ignacy.gawedzki@green-communications.fr>
	[5794e511d]

2025-01-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/def_data.c, plugins/sudoers/def_data.in,
	plugins/sudoers/defaults.c:
	Format T_TIMESPEC as "%d.%d" instead of "%.1f"

	This fixes the display of the timeout values in the "sudo -V" output
	on systems without a C99-compliant snprintf(). The snprintf()
	replacement sudo ships with does not support floating point.
	[01b1410d6]

2024-12-22  vayers  <violetlastname@gmail.com>

	* plugins/sudoers/sudoers.in:
	Replace tab with space

	A line in the sudoers file contains a tab where a space seems to be
	more appropriate.
	[7c121ff83]

2025-01-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac:
	Newer macOS deprecates -force_flat_namespace for -flat_namespace

	The linker warns about -force-flat_namespace and uses
	-flat_namespace instead. Check for -flat_namespace if
	-force-flat_namespace is not found.
	[103af8cb2]

	* scripts/build_pkgs:
	build_pkgs: adapt to work with a git repo
	[46831d6ef]

	* scripts/log2cl.pl:
	Remove unused -b option
	[b52ef1fbb]

2025-01-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* aclocal.m4, configure, m4/libtool.m4, m4/ltoptions.m4,
	m4/ltsugar.m4, m4/ltversion.m4, m4/lt~obsolete.m4,
	scripts/ltmain.sh:
	Update to libtool 2.5.3
	[355c82a1d]

2025-01-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* scripts/log2cl.pl:
	Add markdown mode for use with the sudo web site.
	[e13163ce0]

2024-12-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* scripts/log2cl.pl:
	Use Text::Wrap::fill() for ChangeLog body, not wrap().
	[a3c1cbd88]

2024-12-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_sendlog.man.in, docs/sudo_sendlog.mdoc.in:
	Sort entries in the "SEE ALSO" section.
	[e670d2a85]

	* docs/sudo.man.in, docs/sudo.mdoc.in, src/tgetpass.c:
	If sudo is run without a tty via ssh, suggest using "ssh -t"

	The current warning message mentions using sudo's -S option but this
	will cause the password to be echoed without a terminal. In most
	cases, the user just needs to run ssh with the -t option.
	[516f72960]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.h,
	plugins/sudoers/gram.y:
	The "ALL" command should not override a previous NOSETENV tag in a
	rule.

	Command tags are inherited from previous Cmnds in a Cmnd_Spec_List.
	There is a special case of the SETENV tag for the "ALL" command,
	where SETENV is implied if no explicit SETENV or NOSETENV tag is
	specified. The code to inherit the SETENV tag didn't take into
	account that an implied value for SETENV should also be overridden
	by an explicit SETENV or NOSETENV tag in the previous Cmnd in the
	Cmnd_Spec_List.
	[4dbb07c19]

2024-12-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* Makefile.in, lib/eventlog/Makefile.in, lib/fuzzstub/Makefile.in,
	lib/iolog/Makefile.in, lib/logsrv/Makefile.in,
	lib/protobuf-c/Makefile.in, lib/ssl_compat/Makefile.in,
	lib/util/Makefile.in, logsrvd/Makefile.in,
	plugins/audit_json/Makefile.in, plugins/group_file/Makefile.in,
	plugins/python/Makefile.in, plugins/sample/Makefile.in,
	plugins/sample_approval/Makefile.in, plugins/sudoers/Makefile.in,
	plugins/system_group/Makefile.in, src/Makefile.in:
	Don't need to undef _POSIX_HOST_NAME_MAX, it is not used.
	[de3b179a0]

2024-11-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* etc/codespell.ignore, src/exec_ptrace.h:
	Quiet codespell 2.3.0 complaints.
	[3226c60e6]

2024-11-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_compat.h, lib/util/ttyname_dev.c,
	plugins/sudoers/policy.c, plugins/sudoers/timestamp.c,
	src/regress/ttyname/check_ttyname.c, src/sudo.c, src/ttyname.c:
	Use NODEV macro instead of explicit (dev_t)-1.

	Also fix an assignment of dev_t to -1 that should be NODEV. Bug
	#1074.
	[d5028a00c]

2024-11-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_16p2 for changeset 3c721fa0ff0c
	[015a0d717]

	* :
	Merge sudo 1.9.16p2 from tip.
	[172cbd968]

	* NEWS, configure, configure.ac:
	Sudo 1.9.16p2
	[73cbe4e7e]

2024-11-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoreplay.c:
	Work around a bug in UBSan that is causing CI failures.

	https://gcc.gnu.org/bugzilla/show_bug.cgi?id=116834
	[f8987fc0b]

2024-11-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_pwutil.c,
	plugins/sudoers/pwutil_impl.c:
	Avoid multiple calls to sysonf() via the MAX macro.

	The expansion of MAX would result in multiple calls to sysconf(). It
	is less error-prone to store the result of sysconf() in a long.
	[da20ccec0]

	* lib/util/setgroups.c, plugins/sudoers/sudo_printf.c,
	src/conversation.c:
	Add some casts to quiet -Wconversion
	[3d85f2e98]

2024-11-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_plugin.h, plugins/sudoers/policy.c, src/hooks.c:
	Cast hook functions to sudo_hook_fn_t to fix C23 compile error.

	The sudo plugin API defines sudo_hook_fn_t as a function with
	unspecified arguments. This is no longer supported in C23 so use a
	variadic function for sudo_hook_fn_t instead. Moving to a union may
	be a better long-term fix. GitHub issue #420.
	[9613ef944]

	* lib/util/regress/parse_gids/parse_gids_test.c:
	Use NULL, not false, in the terminating entry of test_data[].
	[4c99e29bb]

	* plugins/sudoers/cvtsudoers_ldif.c:
	Pass NULL, not false, to sudoers_format_default_line().
	[9c63ff0e1]

	* lib/util/ttyname_dev.c:
	sudo_ttyname_dev: On Linux try to use /proc/self/fd/{0,1,2} if
	possible.

	If one of std{in,out,err} matches the specified device, try to
	resolve it to a path by using /proc/self/fd/{0,1,2}. This avoids
	searching all of /dev and works in a chroot where /proc is mounted
	but /dev/pts is not. GitHub issue #421.
	[b7efb8ab5]

2024-11-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/sudo.c, src/ttyname.c:
	get_process_ttyname: always return the terminal device if we find
	one.

	If sudo cannot map the device number to a device file, set name to
	the empty string. The caller now checks for an empty name and only
	passes the tty path to the plugin if it is non-empty. This allows
	sudo to run without warnings in a chroot() jail where the terminal
	device files are not present. GitHub issue #421.
	[7e8f00688]

2024-11-12  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_16p1 for changeset d6059bdf2a76
	[1fbc14667]

	* :
	Merge sudo 1.9.16p1 from tip.
	[7b41190db]

	* NEWS, configure, configure.ac:
	Sudo 1.9.16p1
	[abc0baffc]

2024-11-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/pam.c:
	pam_get_item() takes a void ** arg, not const void **, on Solaris
	[0f41cd717]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Shell-style substitution is not supported in env_file.

	Also document that comments are supported.
	[8b5375716]

2024-10-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/logging.c:
	Do not send mail for "sudo -nv" or "sudo -nl"

	This avoids sending mail for users running "sudo -nv" or "sudo -nl"
	even when mail_badpass or mail_always are enabled. We already avoid
	logging in that case but mailing was not disabled when that change
	was made. Bug #1072.
	[116115229]

2024-10-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, README.LDAP.md, docs/Makefile.in, docs/SECURITY.md,
	docs/TROUBLESHOOTING.md, docs/UPGRADE.md:
	Run igor on other docs too, not just man pages
	[9d49f861c]

	* INSTALL.md, LICENSE.md, docs/CONTRIBUTING.md, docs/UPGRADE.md:
	Remove trailing whitespace
	[5180dd802]

2024-10-28  Ikko Eltociear Ashimine  <eltociear@gmail.com>

	* NEWS:
	docs: update NEWS

	minor fix
	[28df79a24]

2024-10-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/pam.c:
	sudo_pam_verify: move PAM_USER after getpass_error check

	Move it into the PAM_SUCCESS case of the switch *pam_status switch.
	[17aa7688c]

	* plugins/sudoers/auth/pam.c:
	Fix indentation
	[52c73b8f5]

2024-10-02  Marco Trevisan (Treviño)  <mail@3v1n0.net>

	* plugins/sudoers/auth/pam.c:
	plugins/pam: Check the user didn't change during PAM transaction

	PAM modules can change the user during their execution, in such
	case, sudo would still use the user that has been provided giving
	potentially access to another user with the credentials of another
	one.

	So prevent this to happen, by ensuring that the final PAM user is
	matching the one which started the transaction
	[a68e821ef]

2024-09-28  Célestin Matte  <dev@cmatte.me>

	* plugins/sudoers/sudoers.in:
	Fix typo in sudoer file comment
	[05b5de538]

2024-09-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* INSTALL.md:
	Document "--with-secure-path-value=no"
	[f6e1a87be]

2024-08-17  Rose  <gfunni234@gmail.com>

	* plugins/sudoers/strvec_join.c, plugins/sudoers/sudoers.h:
	Put restrict qualifers in strvec_join function pointer
	[77672d83c]

2024-09-17  Andy Fiddaman  <illumos@fiddaman.net>

	* configure.ac, plugins/sudoers/sudoers.in:
	Allow --secure-path-value=no

	This adds support for --with-secure-path-value=no to allow packagers
	to ship the sudoers configuration file with the secure path line
	commented out if required.
	[131e7e2de]

2024-09-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .github/workflows/main.yml:
	Update CIFuzz GitHub action
	[ae5cf31a9]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y:
	alias_error: display the file and line info for the duplicate alias

	Having the file and line of the previous alias definition should
	make it easier to fix duplicate alias errors.
	[0cbddb693]

2024-09-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/ttyname.c:
	On AIX, psinfo.pr_ttydev is 0 when a process has no terminal. On
	most other systems, psinfo.pr_ttydev is -1 for processes with no
	associated terminal. GitHub issue #408
	[d001abc8e]

2024-09-10  Ferdinand Bachmann  <ferdinand.bachmann@yrlf.at>

	* plugins/sudoers/sudoers.in:
	Add pam_silent setting to sudoers example config
	[ce36f01de]

2024-09-09  Ferdinand Bachmann  <ferdinand.bachmann@yrlf.at>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Fix version typo for pam_silent option in sudoers man page
	[915935ab6]

2024-09-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/eventlog/eventlog.c, logsrvd/logsrvd_local.c,
	plugins/sudoers/logging.c:
	Fix the date written used by the exit record in sudo-format log
	files

	The change to always get the current time when building a struct
	evlog in sudoers broke the data and time written for exit records.
	This only affected file-based logs, not syslog. GitHub issue #405.
	[22b320645]

2024-09-04  Arjen Lentz  <arjenlentz@users.noreply.github.com>

	* src/exec_ptrace.c:
	Fixed typo in exec_ptrace.c
	[f47c88065]

2024-09-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac:
	Better test for cross-compiling when checking for C99 snprintf

	We want to avoid calling AX_FUNC_SNPRINTF entirely if
	cross-compiling since it is not possible to undo the setting of
	PREFER_PORTABLE_SNPRINTF. The previous attempt to do this failed to
	take into account that PREFER_PORTABLE_SNPRINTF would still be
	defined. GitHub issue #969
	[3e12cacc0]

2024-08-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_16 for changeset 28c38a84aced
	[483e5e87c]

	* :
	Merge sudo 1.9.16 from tip.
	[c1a614060]

2024-08-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/policy.c:
	Make a ttydev parse error non-fatal for now

	This is new for sudo 1.9.16 so we don't want to break sudo if there
	ends up being a bug in formatting dev_t from the front-end.
	[4751a4d2d]

2024-08-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_plugin.man.in, docs/sudo_plugin.mdoc.in:
	Document that ttydev is formatted as a long long.
	[6a5a8f58e]

	* config.h.in, configure, configure.ac,
	src/regress/ttyname/check_ttyname.c, src/sudo.c:
	Format ttydev as (signed) long long, not unsigned.

	Now that we parse ttydev as a long long it makes more sense to
	format it the same way. This completely avoids the sign extension
	issue on systems where dev_t is signed.
	[cc8c43c4d]

2024-08-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/sudo.c:
	Fix sign compare warning

	Store the result of asprintf() in an int, not size_t.
	[6b90acbfb]

	* config.h.in, configure, configure.ac,
	src/regress/ttyname/check_ttyname.c, src/sudo.c:
	Fix formatting of ttydev on systems with signed 32-bit dev_t

	If dev_t is 32-bit and signed, formatting as an unsigned long long
	may result in a bogus value due to sign extension.
	[46274e725]

	* src/regress/ttyname/check_ttyname.c:
	get_process_ttyname() now returns a dev_t, not a string.
	[f3aa3f1f2]

2024-08-13  Rose  <gfunni234@gmail.com>

	* include/compat/glob.h, lib/util/glob.c:
	Restrict-qualify glob and its functions

	glob is restrict-qualified in the standard
	[e9e0096a1]

	* include/sudo_util.h, lib/util/hexchar.c:
	Restrict-qualify sudo_hexchar_v1

	sudo_hexchar_v1 requires an array of at least size-2, and is not
	aliased.
	[82eac2b41]

2024-08-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/policy.c:
	Use sudo_strtonum() instead of strtoull().

	Fixes building on systems that lack strtoull(). While dev_t is
	unsigned on most systems, we can still use sudo_strtonum() here as
	long as we allow the full range of values [LLONG_MIN,LLONG_MAX]. We
	don't use strtoul() here since some 32-bit systems have 64-bit
	dev_t.
	[827fa8b76]

2024-08-13  Rose  <gfunni234@gmail.com>

	* include/sudo_util.h, lib/util/uuid.c:
	Use static declaration for array sizes to uuid functions
	[cba5d2a5c]

2024-08-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_compat.h:
	Include time.h if missing utimensat() or futimens().

	Now that we declare these as taking a timespec array we cannot get
	away with a simple forward declaration.
	[6f8dfd968]

2024-08-13  Rose  <gfunni234@gmail.com>

	* include/sudo_util.h, lib/util/multiarch.c:
	Restrict-qualify stat_multiarch
	[e7483ae8e]

	* src/load_plugins.c:
	Replace sudo_stat_plugin with sudo_qualify_plugin, as
	sudo_stat_plugin does not exist

	sudo_qualify_plugin was probably meant instead.
	[7269ee2be]

2024-08-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/parser/check_base64.c:
	Sync base64_encode and base64_decode prototypes with parse.h.
	[e3fd614e7]

2024-08-12  Rose Silicon  <gfunni234@gmail.com>

	* plugins/sudoers/parse.h:
	Restrict-qualify dst in base64_decode

	Definition restrict qualifies but not declaration in header.
	[60b6f3002]

2024-08-12  Rose  <gfunni234@gmail.com>

	* include/sudo_compat.h, lib/util/fstatat.c, lib/util/gmtime_r.c,
	lib/util/inet_pton.c, lib/util/localtime_r.c, lib/util/utimens.c:
	Use the full definition of the emulated function that is missing
	[f96e6d134]

	* include/sudo_util.h, lib/util/uuid.c:
	Use restrict to optimize sudo_uuid_to_string_v1
	[787a64f51]

	* plugins/sudoers/b64_decode.c, plugins/sudoers/b64_encode.c,
	plugins/sudoers/parse.h:
	Add restrict qualifiers to base64_decode and base64_encode
	[818aae38c]

	* include/sudo_iolog.h, plugins/sudoers/iolog_path_escapes.c:
	Restrict-qualify iolog_path_escapes like we do with check_iolog_path

	Also add it to the function pointer definition to act as a hint to
	use restrict in the various copy functions.
	[85d08e96b]

	* include/sudo_util.h, lib/util/uuid.c:
	sudo_uuid_to_string_v1's first argument should be const

	uuid is not modified.
	[36cea6e5f]

2024-08-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.c:
	Use FD_CLOEXEC instead of just 1
	[1381a69f5]

2024-07-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Mention --with-secure-path-value configure option
	[f6064b04c]

	* INSTALL.md, configure, configure.ac:
	Add --with-secure-path-value option

	This can be used by package maintainers to set the value of
	secure_path that is substituted into the default sudoers file.
	[e24737eac]

	* configure, configure.ac, docs/sudoers.man.in,
	docs/sudoers.mdoc.in:
	Rename secure_path_set -> secure_path_status
	[986fdec53]

	* docs/sudo_logsrvd.man.in, docs/sudo_sendlog.man.in,
	docs/sudoers.man.in:
	regen
	[a5f5ceecf]

2024-07-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/po/fr.mo, plugins/sudoers/po/fr.po, po/fr.mo,
	po/fr.po:
	Updated translations from translationproject.org
	[cb2457410]

2024-07-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_logsrvd.mdoc.in, docs/sudo_sendlog.mdoc.in,
	docs/sudoers.mdoc.in:
	Add sudo_logsrv.proto manual cross-reference.
	[200af679d]

2024-07-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Late changes for 1.9.16
	[9837fa141]

2024-07-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac:
	If cross-compiling with a C99 compiler, assume snprintf is
	compliant.

	This is a better default than assuming it is not compliant (the
	previous behavior) when cross-compiling. These days it is rare for
	sudo to be built on pre-C99 systems. GitHub issue #969
	[920710b18]

2024-06-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.ldap.man.in, docs/sudoers.ldap.mdoc.in:
	Reference schema.IBM_LDAP.
	[fc051ceff]

	* MANIFEST, plugins/sudoers/po/cs.mo, plugins/sudoers/po/cs.po,
	plugins/sudoers/po/de.mo, plugins/sudoers/po/de.po,
	plugins/sudoers/po/eo.mo, plugins/sudoers/po/eo.po,
	plugins/sudoers/po/hr.mo, plugins/sudoers/po/hr.po,
	plugins/sudoers/po/id.mo, plugins/sudoers/po/id.po,
	plugins/sudoers/po/ja.mo, plugins/sudoers/po/ja.po,
	plugins/sudoers/po/ko.mo, plugins/sudoers/po/ko.po,
	plugins/sudoers/po/pl.mo, plugins/sudoers/po/pl.po,
	plugins/sudoers/po/ro.mo, plugins/sudoers/po/ro.po,
	plugins/sudoers/po/ru.mo, plugins/sudoers/po/ru.po,
	plugins/sudoers/po/uk.mo, plugins/sudoers/po/uk.po,
	plugins/sudoers/po/zh_CN.mo, plugins/sudoers/po/zh_CN.po, po/cs.mo,
	po/cs.po, po/de.mo, po/de.po, po/eo.mo, po/eo.po, po/hr.mo,
	po/hr.po, po/id.mo, po/id.po, po/ja.mo, po/ja.po, po/ko.mo,
	po/ko.po, po/pl.mo, po/pl.po, po/ro.mo, po/ro.po, po/ru.mo,
	po/ru.po, po/sv.mo, po/sv.po, po/uk.mo, po/uk.po, po/zh_CN.mo,
	po/zh_CN.po:
	Updated translations from translationproject.org
	[b2af245b3]

	* MANIFEST, README.LDAP.md, docs/schema.IBM_LDAP:
	Add schema for IBM Directory Server in LDIF format.

	GitHub issue #384
	[e97060d2f]

2024-06-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Remove an errant line that should have been removed.
	[e92467723]

2024-06-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Mention changes to the default sudoers file.
	[e94feadff]

2024-06-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Improve the description of secure_path.
	[06799eddf]

2024-06-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* INSTALL.md, configure, configure.ac, docs/sudoers.mdoc.in,
	plugins/sudoers/sudoers.in:
	Enable secure_path in default sudoers file.

	It is still disabled by default in the sudo binary.
	[e0e24456b]

	* configure, configure.ac, plugins/sudoers/sudoers.in:
	Preserve SUDO_EDITOR, EDITOR, and VISUAL for visudo.
	[1db145355]

2024-06-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/po/sudoers.pot, po/sudo.pot:
	Update .pot files for 1.9.16
	[14a8d9c09]

	* NEWS, configure, configure.ac:
	Sudo 1.9.16
	[eec523aab]

	* INSTALL.md, configure, configure.ac:
	Compile in support for insults by default.

	Insults are still disabled by default but can be enabled in the
	sudoers file. To completely disable insult support, use the
	--without-insults configure option.
	[50ae48a4b]

2024-06-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/regress/cvtsudoers/test41.out.ok,
	plugins/sudoers/regress/cvtsudoers/test41.sh:
	Treat unresolvable User_Alias/Host_Alias as non-aliases in JSON
	output.

	This matches the behavior of the sudoers parser. There is no way to
	tell for sure if an upper case word is an alias or a user or host
	name. An unresolvable command alias is never a command since it
	doesn't start with a '/'. GitHub issue #381
	[e9d65e67a]

	* lib/util/json.c:
	Set need_comma when closing an array or object.

	This fixes an issue where an empty array or object would not have a
	comma after it. GitHub issue #381
	[4e1c58753]

2024-05-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/Makefile.in:
	Add comment that the .mdoc files are generated from .mdoc.in
	[648ce410f]

	* docs/cvtsudoers.man.in, docs/cvtsudoers.mdoc.in,
	docs/sudo.conf.man.in, docs/sudo.conf.mdoc.in, docs/sudo.man.in,
	docs/sudo.mdoc.in, docs/sudo_logsrv.proto.man.in,
	docs/sudo_logsrv.proto.mdoc.in, docs/sudo_logsrvd.conf.man.in,
	docs/sudo_logsrvd.conf.mdoc.in, docs/sudo_logsrvd.man.in,
	docs/sudo_logsrvd.mdoc.in, docs/sudo_plugin.man.in,
	docs/sudo_plugin.mdoc.in, docs/sudo_plugin_python.man.in,
	docs/sudo_plugin_python.mdoc.in, docs/sudo_sendlog.man.in,
	docs/sudo_sendlog.mdoc.in, docs/sudoers.ldap.man.in,
	docs/sudoers.ldap.mdoc.in, docs/sudoers.man.in,
	docs/sudoers.mdoc.in, docs/sudoers_timestamp.man.in,
	docs/sudoers_timestamp.mdoc.in, docs/sudoreplay.man.in,
	docs/sudoreplay.mdoc.in, docs/visudo.man.in, docs/visudo.mdoc.in:
	Sync BUGS section with the bugs section of README.md.

	Also mention how to report security issues based on SECURITY.md.
	GitHub issue #377.
	[74d64bc89]

2024-05-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/sudoers/test24.in,
	plugins/sudoers/regress/sudoers/test24.json.ok,
	plugins/sudoers/regress/sudoers/test24.ldif.ok,
	plugins/sudoers/regress/sudoers/test24.ldif2sudo.ok,
	plugins/sudoers/regress/sudoers/test24.out.ok,
	plugins/sudoers/regress/sudoers/test24.toke.ok,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	Allow the path in Chdir_Spec | Chroot_Spec to be double-quoted.

	The other values of an Option_Spec could already be quoted but path
	names are treated specially.
	[7c74a971d]

2024-05-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/cvtsudoers.man.in, docs/sudo.conf.man.in, docs/sudo.man.in,
	docs/sudo_logsrv.proto.man.in, docs/sudo_logsrvd.conf.man.in,
	docs/sudo_logsrvd.man.in, docs/sudo_plugin.man.in,
	docs/sudo_plugin_python.man.in, docs/sudo_sendlog.man.in,
	docs/sudoers.ldap.man.in, docs/sudoers.man.in,
	docs/sudoers_timestamp.man.in, docs/sudoreplay.man.in,
	docs/visudo.man.in:
	regen
	[58fec2f0c]

	* docs/Makefile.in:
	Include the name of the original .mdoc.in file in the .man.in file.

	This should make it more obvious which is the authoritative file.
	[54ac175d3]

2024-05-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_monitor.c, src/exec_pty.c, src/sudo.h:
	When revoking the pty, kill the foreground process from the parent
	sudo.

	There's no need to send messages back and forth to the monitor when
	the main process can just do it. GitHub issue #367.
	[62e4d29f8]

	* scripts/pp:
	Fix a syntax error in the systemd sudo-logsrvd.postinst script:
	sudo-logsrvd.postinst: 120: [: -eq: unexpected operator
	[52772ae6e]

	* scripts/mkpkg:
	Fix check for libaudit package on Debian-based systems.

	Newer systems only have /usr/lib with /lib as a symbolic link.
	[52586b0db]

2024-05-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/schema.ActiveDirectory:
	Add double quotes around #schemaNamingContext in example.

	GitHub issue #376
	[ee56176b1]

2024-05-15  Robert Manner  <robert.manner@quest.com>

	* logsrvd/logsrvd.c, logsrvd/tls_client.c,
	plugins/sudoers/log_client.c:
	logsrvd,plugins/sudoers: add debug log on TLS verification error
	[ba29f54d9]

2024-05-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/lookup.c:
	apply_cmndspec: plug potential memory leak

	If apply_cmndspec() is called where the cmndspec defines an apparmor
	profile or Solaris privileges, and then is called again with a
	cmndspec that does not have those set we would leak the original
	value.
	[f2a979f40]

	* plugins/sudoers/policy.c, src/parse_args.c, src/sudo.h:
	We do not pass apparmor_profile from the front-end to the policy.

	There is no command line option to specify a profile, it is only
	passed from the policy to the front-end.
	[43ffe34ab]

2024-05-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/fuzz/fuzz_sudoers.dict:
	Sync fuzz_sudoers dictionary with def_data.in.
	[720a1450e]

	* plugins/sudoers/lookup.c:
	apply_cmndspec: plug apparmor_profile leak

	Also override existing Solaris privs if specified.
	[718df95e1]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y:
	free_cmndspec: plug apparmor_profile leak
	[07d6aa247]

2024-05-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/regress/testhelpers.c:
	Python 3.12 backtraces use '~' in addition to '^' when underlining.
	GitHub issue #374
	[89918caf5]

2024-05-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/sudoers/test31.in,
	plugins/sudoers/regress/sudoers/test31.json.ok,
	plugins/sudoers/regress/sudoers/test31.ldif.ok,
	plugins/sudoers/regress/sudoers/test31.ldif2sudo.ok,
	plugins/sudoers/regress/sudoers/test31.out.ok,
	plugins/sudoers/regress/sudoers/test31.toke.ok:
	Add test for parsing SELinux, AppArmor and Solaris privileges.
	[2e6c90cde]

	* plugins/sudoers/check.c, plugins/sudoers/cvtsudoers_csv.c,
	plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/cvtsudoers_ldif.c,
	plugins/sudoers/cvtsudoers_merge.c, plugins/sudoers/display.c,
	plugins/sudoers/fmtsudoers.c, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/ldap_util.c,
	plugins/sudoers/lookup.c, plugins/sudoers/parse.h,
	plugins/sudoers/policy.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/sudoers_ctx_free.c, plugins/sudoers/toke.c,
	plugins/sudoers/toke.l:
	Unifdef parser support for SELinux, AppArmor and Solaris privileges.
	[389c8550c]

2024-04-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/display.c, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/ldap_util.c:
	Add some missing AppArmor bits.

	o Display ApparmorProfile in "long list" format. o Propagate
	apparmor_profile setting to commands in a list. o Support
	apparmor_profile in an LDAP sudoOption.
	[38b98b417]

	* src/exec_monitor.c:
	Quiet compiler warning on Solaris 10
	[ef52db46f]

	* configure, configure.ac, plugins/sudoers/regress/harness.in:
	Check JSON output with jq if present.
	[4d47acf69]

	* plugins/sudoers/cvtsudoers_json.c:
	Format SELinux, AppArmor and Solaris privileges as Options.

	Previously these were output as separate arrays without an enclosing
	object. GitHub issue #373
	[7c2204d34]

2024-04-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_logsrvd.mdoc.in, docs/sudo_plugin.mdoc.in,
	docs/sudoers.mdoc.in, docs/sudoers_timestamp.mdoc.in,
	etc/codespell.exclude, lib/util/lbuf.c, logsrvd/logsrvd_journal.c,
	plugins/sudoers/parse_ldif.c, src/exec_intercept.c:
	Pass "make spell" with updated codespell.
	[27963e39f]

	* src/exec_monitor.c:
	mon_handle_revoke: only send SIGHUP to the foreground process group.

	There's no need to signal both the foreground process group and the
	command itself (if different). This matches the behavior of the
	session leader exiting, which is what we want to simulate.
	[195b7c2bc]

2024-04-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_monitor.c, src/exec_pty.c, src/sudo.h:
	Avoid using ioctl(TIOCNOTTY) in the monitor.

	We don't need to revoke the terminal in the monitor, just signal the
	foreground process group. This is more portable and has the same
	effect as ioctl(TIOCNOTTY) would on Linux. Since we now signal the
	command from the monitor, there is no reason to forward SIGHUP from
	the kernel. GitHub issue #367.
	[a2d01a957]

	* plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/regress/sudoers/test24.json.ok:
	Fix copy and paste error in the fix for GitHub issue #369 Fixes
	GitHub issue #371
	[e770c857f]

2024-04-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_monitor.c, src/exec_pty.c, src/sudo.h:
	If user's tty goes away, tell monitor to revoke the tty in its
	session.

	Previously, we would simply close the pty leader in the main sudo
	process. This had the effect of revoking the pty, but the foreground
	process would not necessarily receive SIGHUP. By using TIOCNOTTY in
	the monitor, the running command has a better chance of getting
	SIGHUP. Once the monitor has revoked the pty, the main sudo process
	will close the pty leader, invalidating the pty. GitHub issue #367.
	[41978a56e]

2024-04-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/cvtsudoers.man.in, docs/cvtsudoers.mdoc.in:
	Commands with multiple digests of the same type are stored in an
	array.
	[37f8a8453]

2024-04-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/regress/sudoers/test14.json.ok:
	Store mulitple command digests of the same type as an array.

	Otherwise, we end up with duplicated keys in the object. GitHub
	issue #370
	[c42922069]

2024-04-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/sudo_auth.c, plugins/sudoers/ins_2001.h,
	plugins/sudoers/ins_classic.h, plugins/sudoers/ins_csops.h,
	plugins/sudoers/ins_goons.h, plugins/sudoers/ins_python.h:
	Call gettext() on insults when displayed, not when declared.
	[78699a8f7]

2024-04-01  alberic89  <alberic89@gmx.com>

	* plugins/sudoers/ins_2001.h, plugins/sudoers/ins_classic.h,
	plugins/sudoers/ins_csops.h, plugins/sudoers/ins_goons.h,
	plugins/sudoers/ins_python.h:
	Make insults translatable
	[8666c66ff]

2024-04-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/regress/sudoers/test24.json.ok:
	When converting CWD and CHROOT tags, store them as objects. Fixes
	GitHub issue #369
	[26ce75110]

2024-04-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in,
	plugins/sudoers/auth/pam.c, plugins/sudoers/def_data.c,
	plugins/sudoers/def_data.h, plugins/sudoers/def_data.in,
	plugins/sudoers/defaults.c:
	Add pam_silent sudoers option. Inspired by PR #368 GitHub issue #216
	[ecdf0c80f]

2024-03-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* INSTALL.md, config.h.in, configure, configure.ac,
	plugins/sudoers/ins_classic.h, plugins/sudoers/ins_csops.h:
	Remove offensive insults that were disabled by default anyway. Bug
	#1058
	[f0823c70c]

2024-03-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_eventlog.h, lib/eventlog/eventlog.c,
	logsrvd/logsrvd_conf.c, plugins/sudoers/logging.c,
	plugins/sudoers/sudoers.c:
	Remove EVLOG_JSON, callers must use EVLOG_JSON_COMPACT or
	EVLOG_JSON_PRETTY
	[b6175b78a]

	* docs/sudo_logsrvd.conf.man.in, docs/sudo_logsrvd.conf.mdoc.in,
	docs/sudoers.man.in, docs/sudoers.mdoc.in, include/sudo_eventlog.h,
	lib/eventlog/eventlog.c, logsrvd/logsrvd_conf.c,
	plugins/sudoers/def_data.c, plugins/sudoers/def_data.h,
	plugins/sudoers/def_data.in, plugins/sudoers/logging.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/sudoers_cb.c:
	Add "json_pretty" log format, currently the same as "json".

	In a future version, "json" will be an alias for "json_compact"
	instead. GitHub issue #357.
	[46e31a74d]

2024-03-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_logsrvd.conf.man.in, docs/sudo_logsrvd.conf.mdoc.in,
	docs/sudoers.man.in, docs/sudoers.mdoc.in, include/sudo_eventlog.h,
	lib/eventlog/eventlog.c, logsrvd/logsrvd_conf.c,
	plugins/sudoers/def_data.c, plugins/sudoers/def_data.h,
	plugins/sudoers/def_data.in, plugins/sudoers/logging.c,
	plugins/sudoers/sudoers_cb.c:
	Add json_compact log type for compact/minified JSON.

	The "json_compact" log type logs one event per line in
	compact/minified JSON format. GitHub issue #357.
	[1debad3be]

	* plugins/sudoers/logging.c:
	Fix typo
	[b3ade1c5f]

	* docs/sudo.man.in, docs/sudo.mdoc.in, plugins/sudoers/env.c:
	Set SUDO_HOME to the invoking user's home directory. GitHub issue
	#358
	[602a58e86]

2024-03-02  Martin  <spleefer90@gmail.com>

	* etc/sudo-logsrvd.pp:
	sudo-logsrvd.pp: Remove syslog.target (non-existent upstream since
	11~ years ago)

	Remove syslog.target from service file, this target hasn't existed
	for over a decade.

	https://github.com/systemd/systemd/blob/6aa8d43ade72e24c9426e604f7fc
	4b7582b9db7c/NEWS#L72-L73
	[836d2b556]

2024-02-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/Makefile.in:
	Explicitly link check_symbols with zlib.

	Fixes a test failure on some systems when using sudo's built-in
	zlib.
	[72cee2fa2]

2024-02-22  Fabrice Fontaine  <fontaine.fabrice@gmail.com>

	* m4/openssl.m4:
	m4/openssl.m4: fix cross-compilation with wolfssl

	Do not append -I/usr/include/wolfssl when cross-compiling

	Signed-off-by: Fabrice Fontaine <fontaine.fabrice@gmail.com>
	[f66ebfa0f]

2024-02-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/eventlog/Makefile.in, lib/fuzzstub/Makefile.in,
	lib/iolog/Makefile.in, lib/protobuf-c/Makefile.in,
	lib/ssl_compat/Makefile.in, lib/util/Makefile.in,
	logsrvd/Makefile.in, plugins/audit_json/Makefile.in,
	plugins/group_file/Makefile.in, plugins/python/Makefile.in,
	plugins/sample/Makefile.in, plugins/sample_approval/Makefile.in,
	plugins/sudoers/Makefile.in, plugins/system_group/Makefile.in,
	src/Makefile.in:
	Regenerate dependencies
	[81acb2bd7]

	* lib/eventlog/Makefile.in, lib/fuzzstub/Makefile.in,
	lib/iolog/Makefile.in, lib/logsrv/Makefile.in,
	lib/protobuf-c/Makefile.in, lib/ssl_compat/Makefile.in,
	lib/util/Makefile.in, logsrvd/Makefile.in,
	plugins/audit_json/Makefile.in, plugins/group_file/Makefile.in,
	plugins/python/Makefile.in, plugins/sample/Makefile.in,
	plugins/sample_approval/Makefile.in, plugins/sudoers/Makefile.in,
	plugins/system_group/Makefile.in, src/Makefile.in:
	Use $(CPP) instead if $(CC) -E when buiding .i files from .c.
	[3944ab1fb]

	* Makefile.in:
	Add missing subdirs to depend target.
	[2a61e4b07]

	* lib/util/Makefile.in, scripts/mkdep.pl:
	Using $< in a non-suffix rule context is a GNU make extension.
	[9b073f312]

2024-02-17  Yann E. MORIN  <yann.morin.1998@free.fr>

	* lib/util/Makefile.in:
	lib/utils: detect failure to generate signals list and names

	Currently, we generate the signal list and names by running cpp on
	our header, and piping the result into sed.

	However, when cpp fails [0], we do not catch that failure, as the
	error code of the LHS of a pipe is lost, with the pipe returning the
	RHS-most return code.

	Fix that by introducing two new intermediate rules, each to generate
	the preprocessed .i files, and use those as dependencies and input
	to the rule that generates the headers. Those two .i files will be
	cleaned up by the existing *.i glob.

	[0] a failure happens on recent hosts, due to inconsistency with
	time64_t and large-file support (lines elided and wrapped for
	readability):

	/usr/bin/cpp [...] ./sys_signame.h \ | /usr/bin/sed -e '1,/^int
	sudo_end_of_headers;/d' -e '/^#/d' > mksigname.h In file included
	from /usr/include/features.h:394, from /usr/include/sys/types.h:25,
	from ./sys_signame.h:4: /usr/include/features-time64.h:26:5: error:
	#error "_TIME_BITS=64 is allowed only with _FILE_OFFSET_BITS=64" 26
	| # error "_TIME_BITS=64 is allowed only with _FILE_OFFSET_BITS=64"
	| ^~~~~ /usr/bin/gcc [...] ./mksigname.c -o mksigname In file
	included from /usr/include/features.h:394, from
	/usr/include/bits/libc-header-start.h:33, from
	/usr/include/stdlib.h:26, from ./mksigname.c:27:
	/usr/include/features-time64.h:26:5: error: #error "_TIME_BITS=64 is
	allowed only with _FILE_OFFSET_BITS=64" 26 | # error "_TIME_BITS=64
	is allowed only with _FILE_OFFSET_BITS=64" | ^~~~~ make[2]: ***
	[Makefile:263: mksigname] Error 1

	In that case, we were lucky that the subsequent gcc call also
	failed, and for the same reason. That time64_t and lfs issue should
	be fixed (at least investigated), but that does not mean we should
	not be more robust when parsing the header either.

	Signed-off-by: Yann E. MORIN <yann.morin.1998@free.fr>
	[6ec958f27]

2024-02-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure:
	Regen with autoconf 2.72
	[f3ebf31aa]

	* configure.ac:
	Check if ac_cv_sys_file_offset_bits is "64", not "yes"

	This is used for determining whether to set _TIME_BITS with autoconf
	versions before 2.72.
	[bafdcc3d4]

2024-02-17  Yann E. MORIN  <yann.morin.1998@free.fr>

	* src/exec_ptrace.c:
	src/exec_ptrace: fix build without precess_vm_readv()

	Commit 32f4b98f6b4a (sudo frontend: silence most -Wconversion
	warnings.) broke the build on C libraries that miss
	process_vm_readv(), like uClibc-ng.

	Indeed, the ssize_t nwritten is declared guarded by
	HAVE_PROCESS_VM_READV, but is then re-assigned and used a few lines
	below, outside any guard.

	Fix that by always declaring the object, as it is always needed.

	Signed-off-by: Yann E. MORIN <yann.morin.1998@free.fr>
	[5bbfaa8e6]

2024-01-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/HISTORY.md:
	Quest no longer sponsors sudo development.
	[f69031da2]

2024-01-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	Correct a misleading debug message.
	[0a39814e4]

	* LICENSE.md, lib/zlib/deflate.c, lib/zlib/deflate.h,
	lib/zlib/gzguts.h, lib/zlib/gzlib.c, lib/zlib/inflate.c,
	lib/zlib/inftrees.c, lib/zlib/inftrees.h, lib/zlib/trees.c,
	lib/zlib/zconf.h.in, lib/zlib/zlib.h, lib/zlib/zutil.h:
	Update embedded copy of zlib to version 1.3.1.
	[eb4506f43]

2024-01-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* etc/sudo-logsrvd.pp, etc/sudo-python.pp, etc/sudo.pp:
	Update copyright data in the package files.
	[3899f2ef9]

2024-01-12  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/glob.c, plugins/sudoers/tsdump.c:
	Prefer putchar over fputc where possible

	putchar is easier to understand than fputc and printf and does less
	work than those two do.
	[725d3fdc2]

2024-01-13  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* plugins/sudoers/iolog_path_escapes.c:
	Add restrict qualifiers to strlcpy_no_slash

	It's just strlcpy except it replaces '/' with '_'.
	[7fc7d6953]

2024-01-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/logging.c:
	Only log "a password is required" for "sudo -n" if a command is
	specified. This means that it is not logged for "sudo -nv" and "sudo
	-nl". We only log this message when sudo's -n flag is specified (and
	not when the user presses ^C at the password prompt) so that there
	is a record of failed non-interactive commands.
	[67e328d6f]

2024-01-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Document side-effects of enabling the use_pty option.
	[b39dc7c5f]

	* plugins/sudoers/sudoers.in:
	Update "!use_pty" example to only disable it for non-root users.

	Also add a commented out entry for "exec_background" which can also
	be used to prevent sudo from consuming tty input. Related to GitHub
	issue #338
	[ff3dbe60b]

2024-01-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/regress/mktemp/mktemp_test.c:
	Add check for sysconf(_SC_PAGESIZE) failure.
	[00452471b]

	* src/sudo_edit.c:
	sudo_edit_mktemp: remove useless cast
	[f52fa574c]

2023-12-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* LICENSE.md:
	Welcome to 2024
	[22b01501e]

	* LICENSE.md:
	Bump zlib copyright date for version 1.3
	[c15e0aeea]

2023-12-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* scripts/mkpkg:
	Restore the ability to override default configure settings.

	The user-specified options must go last...
	[69a024304]

2023-12-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_15p5 for changeset 4418cfdc5b2a
	[a0a68f22c]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p5
	[00b2bd358]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p5
	[fc9369cb4]

2023-12-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* scripts/mkpkg:
	Handle Debian GNU Hurd
	[b5a3513fb]

	* plugins/sudoers/cvtsudoers_pwutil.c,
	plugins/sudoers/pwutil_impl.c:
	Properly handle sysconf(_SC_LOGIN_NAME_MAX) returning -1 on failure.

	The cast to size_t needs to be outside the MAX() macro or the -1
	will get cast to unsigned.
	[ada47ee10]

	* plugins/sudoers/cvtsudoers_pwutil.c,
	plugins/sudoers/pwutil_impl.c:
	Properly handle sysconf(_SC_LOGIN_NAME_MAX) returning -1 on failure.

	The cast to size_t needs to be outside the MAX() macro or the -1
	will get cast to unsigned.
	[e4057faca]

2023-12-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* config.h.in, configure, configure.ac, plugins/sudoers/timestamp.c:
	Automatically migrate lecture file path from name-based to
	uid-based.

	GitHub issue #342.
	[63ebe354c]

	* config.h.in, configure, configure.ac, plugins/sudoers/timestamp.c:
	Automatically migrate lecture file path from name-based to
	uid-based.

	GitHub issue #342.
	[ad4dc22d5]

2023-12-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/iolog/regress/iolog_path/check_iolog_path.c:
	Add missing checks for strdup() failure.
	[63f2c54b8]

2023-12-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/ldap_conf.c:
	Disable netgroup_query when netgroup_base is not set.

	The logic was inverted when support for netgroup_query was added.
	This supercedes PR #341.
	[286c8ddc5]

	* plugins/sudoers/ldap_conf.c:
	Disable netgroup_query when netgroup_base is not set.

	The logic was inverted when support for netgroup_query was added.
	This supercedes PR #341.
	[5fbf7a362]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	In the NOEXEC example make it clear that "shanty" is a host. Bug
	#1064
	[0e8b722e8]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	In the NOEXEC example make it clear that "shanty" is a host. Bug
	#1064
	[6d4ffe674]

2023-12-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/eventlog/eventlog.c:
	closefrom_nodebug: skip fds < 0

	This can only happen if lowfd < 0, which is never the case. Quiets a
	static analyzer warning.
	[10fd66ac9]

2023-12-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/defaults.c:
	Fix printing of warning when a Defaults setting is missing a value.

	This is a bug in parse_default_entry() introduced in sudo 1.8.19
	when support for using the default syslog facility was added at the
	wrong place in a switch().
	[318e0eff3]

	* plugins/sudoers/defaults.c:
	Fix printing of warning when a Defaults setting is missing a value.

	This is a bug in parse_default_entry() introduced in sudo 1.8.19
	when support for using the default syslog facility was added at the
	wrong place in a switch().
	[701914816]

2023-12-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/defaults.c, plugins/sudoers/defaults.h:
	Sprinkle some more const in defaults.c.
	[f67a7e623]

	* plugins/sudoers/defaults.c:
	Fix evaluation of a tuple used in "true" boolean context.

	Previously, a tuple in boolean context was always treated as a
	negated entry, which doesn't match the documentation. We assume that
	there are at least two tuple entries where the first maps to boolean
	false and the second maps to boolean true.
	[ae7dc397b]

	* plugins/sudoers/defaults.c:
	Fix evaluation of a tuple used in "true" boolean context.

	Previously, a tuple in boolean context was always treated as a
	negated entry, which doesn't match the documentation. We assume that
	there are at least two tuple entries where the first maps to boolean
	false and the second maps to boolean true.
	[2df637b26]

	* .hgtags:
	Added tag SUDO_1_9_15p4 for changeset cc9d22d261de
	[80a2794b0]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p4
	[680352b91]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p4
	[2535c5ae1]

	* plugins/sudoers/lookup.c:
	sudoers_lookup_pseudo: init match to UNSPEC for
	sudo_nss_can_continue().

	Otherwise, processing will stop after the first sudoers nsswitch
	service specification where [SUCCESS=return] is present.
	[fbc4c50d4]

	* plugins/sudoers/lookup.c:
	sudoers_lookup_pseudo: init match to UNSPEC for
	sudo_nss_can_continue().

	Otherwise, processing will stop after the first sudoers nsswitch
	service specification where [SUCCESS=return] is present.
	[5f6e0a41d]

2023-12-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_15p3 for changeset 20d368229c6a
	[319ada9ab]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p3
	[c9198ef4d]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p3
	[a1bb5e5c1]

2023-12-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/policy.c:
	Pass back Solaris privs as "runas_privs" and "runas_limitprivs".

	The "runas_" prefix got inadvertantly removed in the big
	sudoers_context refactor.
	[de242c573]

	* plugins/sudoers/policy.c:
	Pass back Solaris privs as "runas_privs" and "runas_limitprivs".

	The "runas_" prefix got inadvertantly removed in the big
	sudoers_context refactor.
	[f149dd2c8]

2023-12-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_util.h, lib/util/term.c, lib/util/ttysize.c,
	lib/util/util.exp.in, src/sudo.h, src/ttyname.c:
	sudo_term_is_raw: only try to lock the fd if it is a tty

	This moves sudo_isatty() to libsudo_util so sudo_term_is_raw() can
	use it. Fixes GitHub issue #335
	[1e03cbd0b]

	* include/sudo_util.h, lib/util/term.c, lib/util/ttysize.c,
	lib/util/util.exp.in, src/sudo.h, src/ttyname.c:
	sudo_term_is_raw: only try to lock the fd if it is a tty

	This moves sudo_isatty() to libsudo_util so sudo_term_is_raw() can
	use it. Fixes GitHub issue #335
	[2fc78071c]

2023-12-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoreplay.c:
	setup_terminal: fix an editing error introduced in 1.9.15.
	[d17e28ad6]

	* plugins/sudoers/sudoreplay.c:
	setup_terminal: fix an editing error introduced in 1.9.15.
	[6ef5310e0]

2023-12-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match_command.c:
	command_matches_regex: retry with canonicalized path if possible

	If ctx->user.cmnd doesn't match, use ctx->user.cmnd_dir (if present)
	to construct a canonicalized path and match on that.
	[0c2de39da]

2023-12-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match_command.c:
	command_matches_fnmatch: retry with canonicalized path if possible

	If ctx->user.cmnd doesn't match, use ctx->user.cmnd_dir (if present)
	to construct a canonicalized path and match on that.
	[44f0908e7]

	* lib/util/gethostname.c:
	If sysconf(_SC_HOST_NAME_MAX) returns 0, just use 255.

	This should not actually be possible.
	[24f443981]

	* plugins/sudoers/sethost.c:
	Fall back to "localhost" if gethostname() fails.

	GitHub issue #332
	[b16d194bb]

	* plugins/sudoers/sethost.c:
	Fall back to "localhost" if gethostname() fails.

	GitHub issue #332
	[8faf43249]

	* plugins/sudoers/match_command.c:
	command_matches_glob: fix comparison of canonicalized parent
	directories

	Bug #1062
	[3cbcb308c]

	* plugins/sudoers/match_command.c:
	command_matches_glob: fix comparison of canonicalized parent
	directories

	Bug #1062
	[8dd296776]

2023-12-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_csv.c:
	Add missing print_member_list_csv() return value check.
	[9c3eb2fec]

	* plugins/sudoers/tsdump.c:
	Check sudoers_debug_register() return value.
	[79ed29c4a]

2023-11-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, scripts/config.guess, scripts/config.sub:
	Regenerate with the autoconf 2.72d snapshot.
	[c3ac12297]

2023-11-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/def_data.c, plugins/sudoers/def_data.h,
	plugins/sudoers/def_data.in:
	Add cmddenial_message to def_data.in
	[77700a4b7]

2023-11-28  THE-Spellchecker  <THE-Spellchecker@outlook.com>

	* INSTALL.md, docs/UPGRADE.md, lib/util/event.c, lib/util/fatal.c,
	lib/util/fnmatch.c, lib/util/lbuf.c, lib/util/snprintf.c,
	lib/util/sudo_dso.c, plugins/python/example_io_plugin.py,
	plugins/python/example_policy_plugin.py,
	plugins/sample/sample_plugin.c, plugins/sudoers/auth/fwtk.c,
	plugins/sudoers/def_data.c, plugins/sudoers/def_data.in,
	plugins/sudoers/ldap.c, plugins/sudoers/lookup.c,
	plugins/sudoers/parse.h, plugins/sudoers/parse_ldif.c,
	plugins/sudoers/policy.c, plugins/sudoers/pwutil.h,
	plugins/sudoers/set_perms.c, plugins/sudoers/sssd.c,
	plugins/sudoers/sudoers.c, src/exec.c, src/exec_monitor.c,
	src/exec_ptrace.c, src/exec_pty.c:
	Typographical and Grammatical fixes
	[5eba4b48c]

2023-11-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Reword the description of cmddenial_message.
	[b4ae559c8]

	* docs/sudoreplay.man.in:
	Regenerate from sudoreplay.mdoc.in
	[6b6e0aed0]

2023-11-20  Guillaume Destuynder  <gdestuynder@google.com>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in,
	plugins/sudoers/def_data.c, plugins/sudoers/def_data.h,
	plugins/sudoers/logging.c,
	plugins/sudoers/regress/sudoers/test26.in,
	plugins/sudoers/regress/sudoers/test26.json.ok,
	plugins/sudoers/regress/sudoers/test26.ldif.ok,
	plugins/sudoers/regress/sudoers/test26.ldif2sudo.ok,
	plugins/sudoers/regress/sudoers/test26.out.ok,
	plugins/sudoers/regress/sudoers/test26.toke.ok:
	Add support for a custom message when the command execution is
	denied.
	[a4cbfecda]

2023-11-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/ttyname_dev.c:
	No need to include sys/param.h here.
	[55db82908]

	* plugins/sudoers/tsdump.c:
	tsdump: quiet compiler warnings on some platforms.

	Quiet a -Wshadow warning from gcc. Cast major() and minor() to
	unsigned int when printing.
	[522f1b634]

	* plugins/sudoers/tsdump.c:
	tsdump: display both the terminal path and device number.

	If no terminal device can be found, print "major, minor" device
	numbers instead.
	[288593875]

	* docs/sudoers_timestamp.man.in, docs/sudoers_timestamp.mdoc.in:
	Sync time stamp defines with sudoers timestamp.h

	The types and flags are now explicitly unsigned.
	[7d7dfbfd4]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in,
	docs/sudoers_timestamp.man.in, docs/sudoers_timestamp.mdoc.in:
	Mention the tsdump utility
	[0c958e185]

	* plugins/sudoers/Makefile.in:
	Build tsdump by default so it does not suffer bit rot.
	[66c9a636d]

	* include/sudo_debug.h:
	Add sudo_debug_exit_dev_t stub for fuzzing.
	[67ed8fbe5]

	* lib/util/chacha_private.h, lib/util/inet_pton.c:
	Avoid using the u_int type, which is not portable.
	[be911b77d]

	* plugins/sudoers/tsdump.c:
	tsdump: update to use a uid-based path by default

	This matches the changes in sudo 1.9.15 to the sudoers policy
	module.
	[5ff6f4965]

2023-11-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	*
	plugins/python/regress/testdata/check_multiple_approval_plugin_and_a
	rguments.stdout:
	Update for plugin version 1.22.
	[ce74f50b4]

	* docs/sudo_plugin.man.in, docs/sudo_plugin.mdoc.in,
	include/sudo_plugin.h:
	Document ttydev and bump plugin version to 1.22
	[61dbfe092]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/timestamp.c:
	Add ttydev to sudoers_user_context and use for timestamp file.

	GitHub issue #329
	[a85494b5c]

	* include/sudo_debug.h, src/sudo.c, src/sudo.h, src/ttyname.c:
	Pass tty device number from front-end to policy module.

	GitHub issue #329
	[3dfbf9316]

2023-11-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_eventlog.h, lib/eventlog/eventlog.c,
	lib/eventlog/parse_json.c, lib/iolog/iolog_legacy.c,
	lib/iolog/iolog_loginfo.c, logsrvd/iolog_writer.c,
	logsrvd/logsrvd_local.c, logsrvd/sendlog.c, plugins/sudoers/audit.c,
	plugins/sudoers/iolog.c, plugins/sudoers/logging.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/sudoreplay.c:
	Rename submit_time -> event_time in struct eventlog.
	[b9275b7ea]

	* plugins/sudoers/audit.c, plugins/sudoers/logging.c:
	We can use evlog.submit_time in the call to eventlog_alert().

	This is set to the current wallclock time by sudoers_to_eventlog().
	[0e53d5fdd]

	* plugins/sudoers/logging.c, plugins/sudoers/policy.c,
	plugins/sudoers/sudoers.h:
	Replace submit_time in struct sudoers_context with start_time.

	We need to track the (monotonic) command start time to be able to
	generate an accurate run time. Instead of setting submit time when
	the policy initializes (and using that time for logging purposes),
	set evlog->submit_time to the current wallclock time when we need to
	perform logging. This is more consistent with how sudo logging was
	performed in the past. Fixes GitHub issues #327.
	[39ea3176c]

	* plugins/sudoers/audit.c, plugins/sudoers/iolog.c,
	plugins/sudoers/log_client.c, plugins/sudoers/log_client.h,
	plugins/sudoers/logging.c:
	log_server_open: always pass in awake time, not wallclock time.

	The timespec passed to log_server_open() should be from
	sudo_gettime_awake() since it is used to build the command run time.
	[432b08555]

	* plugins/sudoers/log_client.c, plugins/sudoers/log_client.h,
	plugins/sudoers/logging.c:
	log_server_alert: use fmt_alert_message not fmt_reject_message

	Only affects intercepted commands.
	[6965e1b0a]

	* plugins/sudoers/audit.c, plugins/sudoers/log_client.c,
	plugins/sudoers/logging.c, plugins/sudoers/logging.h:
	log_server_alert: struct timespec argument was not actually used

	The struct timespec argument is used to initialize the command start
	time, which is not used for an alert message.
	[13dec64f3]

2023-11-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_csv.c:
	cvtsudoers_csv.c: remove most sudo_fatal() calls.

	Errors are now propagated up the call stack.
	[47a43c540]

	* plugins/sudoers/cvtsudoers_ldif.c:
	No need for sudo_fatalx() here, just pass back an error.
	[dd5f7a450]

	* plugins/sudoers/cvtsudoers_ldif.c:
	cvtsudoers_ldif: display warning on write error
	[2c06aa321]

	* plugins/sudoers/cvtsudoers_merge.c:
	cvtsudoers_merge.c: remove sudo_fatal() calls.

	Errors are now propagated up the call stack.
	[7e4632691]

2023-11-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_merge.c:
	Make new_member() return NULL on failure and adjust callers.
	[8cfd4467f]

	* plugins/sudoers/cvtsudoers_ldif.c:
	Pass return values back instead of using sudo_fatal().
	[564d8ac01]

	* plugins/sudoers/cvtsudoers_ldif.c:
	Add printf_attribute_ldif() to printf-format an LDIF attribute.

	This replaces multiple sequences of asprintf() and
	print_attribute_ldif().
	[d28884b1c]

2023-11-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers_json.c:
	cvtsudoers_json.c: check sudo_json_* return values.

	Previously, we set memfatal to true in sudo_json_init() instead.
	This also gets rid of a number of sudo_fatalx() calls.
	[12e55dcd7]

	* plugins/audit_json/audit_json.c:
	add_timestamp: check sudo_json_* return values.
	[1a68935ae]

	* plugins/sudoers/alias.c, plugins/sudoers/check_aliases.c,
	plugins/sudoers/cvtsudoers.c, plugins/sudoers/cvtsudoers_csv.c,
	plugins/sudoers/parse.h, plugins/sudoers/testsudoers.c:
	alias_apply: change return type to bool

	We can use the rbapply() return value to detect failure.
	[a2998a670]

	* src/sudo.c:
	Always disable core dumps when sudo sends itself a fatal signal.

	When a command exits due to a fatal signal, sudo will re-send that
	signal to itself so the shell does not ignore keyboard-generated
	signals. However, now that sudo disables core dumps by default for
	the command, we cannot rely on WCOREDUMP() telling us whether or not
	the signal will lead to a core dump. It is safest to always disable
	core dumps before sending the signal to ourself.
	[4795e4b36]

	* src/sudo.c:
	Always disable core dumps when sudo sends itself a fatal signal.

	When a command exits due to a fatal signal, sudo will re-send that
	signal to itself so the shell does not ignore keyboard-generated
	signals. However, now that sudo disables core dumps by default for
	the command, we cannot rely on WCOREDUMP() telling us whether or not
	the signal will lead to a core dump. It is safest to always disable
	core dumps before sending the signal to ourself.
	[ab49adb92]

	* .hgtags:
	Added tag SUDO_1_9_15p2 for changeset 4d03c1608a23
	[79bf0960d]

2023-11-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge sudo 1.9.15p2 from tip.
	[22298e15e]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p2
	[62895ea44]

	* scripts/pp:
	Update PolyPkg from upstream.
	[0f40753d4]

	* lib/util/term.c:
	sudo_term_restore: don't check c_cflag on systems with TCSASOFT.

	If TCSASOFT is present, tcsetattr() will ignore c_cflag. Fixes a bug
	where sudo_term_restore() would refuse to change the terminal
	settings back if the PARENB control flag was set. GitHub issue #326.
	[a6ac589cc]

	* scripts/mkpkg:
	Quote $osversion since it may include whitespace.
	[0497bde98]

2023-11-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.h:
	Use C99 designated struct initializers.

	This is less error-prone and would have avoided GitHub issue #325.
	[e0d912d1d]

	* .hgtags:
	Added tag SUDO_1_9_15p1 for changeset d23f72517e07
	[70e1e9826]

	* :
	Merge sudo 1.9.15p1 from tip.
	[29c5a12af]

	* NEWS, configure, configure.ac:
	Sudo 1.9.15p1
	[45aeeddcb]

	* plugins/sudoers/sudoers.h:
	Correct the order of the strings in SUDOERS_CONTEXT_INITIALIZER.

	Fixes GitHub issue #325, a bug introduced in sudo 1.9.15.
	[87c193f3f]

2023-11-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	In the sudo 1.9.14p3 section, "Python python" should be "Python
	plugin".
	[d45071af4]

	* .hgtags:
	Added tag SUDO_1_9_15 for changeset 277833c12efb
	[839758ebe]

	* :
	Merge sudo 1.9.15 from tip.
	[f7ae17d3d]

	* NEWS:
	Sudo now logs the submitenv in the JSON logs.
	[747c34059]

	* docs/sudo.conf.man.in, docs/sudo.conf.mdoc.in,
	docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Document special cases for AIX-style shared libraries.

	The shared object is a member of an archive file that is specified
	in parentheses.
	[3686c9fdd]

2023-11-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo.conf.man.in, docs/sudo.conf.mdoc.in:
	Add sudoers plugin Debug example and x-ref sudoers man page for
	details.
	[e77247927]

	* docs/sudo.conf.man.in, docs/sudo.conf.mdoc.in:
	The HP-UX getgrouplist() code has been disabled due to bugs.
	[ec6906f63]

2023-11-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/sudo_conf.c:
	sudo_conf_debug_files: special handling of DSO members for AIX

	When matching debug files for AIX-style DSOs like
	sudoers.a(sudoers.so) we want to match on the full name, the name
	without the member and on the member itself. This makes it possible
	to use the existing examples in the sudo.conf fiile on AIX.
	[097bec06b]

	* plugins/sudoers/pwutil.c:
	sudo_set_grlist and sudo_set_gidlist: set auth registry based on
	username

	Previously we used the global registry but since we have the user's
	passwd info we should use that when storing the group and gid lists.
	[24351bdad]

2023-11-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/parse_ldif.c:
	role_to_sudoers: only try to reuse a privilege if one is present
	[2ffcda8e1]

	* plugins/sudoers/defaults.c:
	store_plugin: avoid potential NULL deref in boolean context

	Coverity CID 330466
	[1a11be4d9]

	* plugins/sudoers/sudoreplay.c, src/conversation.c:
	Avoid passing sudo_term_is_raw() -1 for the fd.

	Coverity CID 330472 Coverity CID 330468
	[4833ac0f0]

	* logsrvd/sendlog.c:
	fmt_info_messages: bump info_msgs_size for submitenv
	[3b891c136]

	* NEWS:
	Better log message when rejecting a setid command in intercept mode.
	[77c258290]

	* plugins/sudoers/logging.c, plugins/sudoers/lookup.c,
	plugins/sudoers/match_command.c, plugins/sudoers/parse.h,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h:
	Move the check for running setid commands in intercept mode to
	later.

	Checking for setid commands in intercept mode after command matching
	allows us to log a proper error message. Previously, we simply
	ignored setid commands when matching and the only indication of why
	was in the debug logs.
	[886f1414e]

	* plugins/sudoers/timestamp.c:
	timestamp_open: add some debugging
	[45e3c0dd1]

2023-10-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/sia.c:
	sudo_sia_begin_session: add missing struct sudoers_context * arg.
	[3297ffa26]

	* plugins/sudoers/auth/kerb5.c:
	verify_krb_v5_tgt: auth name must be const to match struct
	sudo_auth.
	[747114f33]

	* .circleci/config.yml:
	Disable PAM before enabling Kerberos V.
	[9ef52151e]

	* .circleci/config.yml, docker/debian/latest/Dockerfile,
	docker/debian/testing/Dockerfile, docker/fedora/latest/Dockerfile,
	docker/fedora/rawhide/Dockerfile, docker/ubuntu/devel/Dockerfile,
	docker/ubuntu/latest/Dockerfile, docker/ubuntu/rolling/Dockerfile:
	Add Kerberos V build and test to CI.
	[7ed7b4536]

2023-10-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/po/cs.mo, plugins/sudoers/po/cs.po,
	plugins/sudoers/po/ko.mo, plugins/sudoers/po/ko.po:
	Updated translations from translationproject.org
	[145faa3fe]

2023-10-31  Renato Botelho  <garga@FreeBSD.org>

	* plugins/sudoers/auth/kerb5.c:
	Add missing sudoers_context to verify_krb_v5_tgt()

	Commit 244017495421 added ctx variable to log_warningx() call but
	that variable was not declared in that context, breaking the build.
	[75e829b74]

2023-10-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Mention new Indonesian translation and sudo_logsrvd fd limit change.
	[5f3a6b4f6]

2023-10-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/logsrvd.c:
	Set the open file descriptor limit to the maximum allowed value.

	Each connection can require up to 9 descriptors.
	[31bcdec23]

2023-10-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/po/de.mo, plugins/sudoers/po/de.po,
	plugins/sudoers/po/eo.mo, plugins/sudoers/po/eo.po,
	plugins/sudoers/po/fr.mo, plugins/sudoers/po/fr.po,
	plugins/sudoers/po/hr.mo, plugins/sudoers/po/hr.po,
	plugins/sudoers/po/ja.mo, plugins/sudoers/po/ja.po,
	plugins/sudoers/po/pl.mo, plugins/sudoers/po/pl.po,
	plugins/sudoers/po/ro.mo, plugins/sudoers/po/ro.po,
	plugins/sudoers/po/ru.mo, plugins/sudoers/po/ru.po,
	plugins/sudoers/po/sr.mo, plugins/sudoers/po/sr.po,
	plugins/sudoers/po/sv.mo, plugins/sudoers/po/sv.po,
	plugins/sudoers/po/uk.mo, plugins/sudoers/po/uk.po,
	plugins/sudoers/po/zh_TW.mo, plugins/sudoers/po/zh_TW.po, po/hr.mo,
	po/hr.po, po/ja.mo, po/ja.po, po/sr.mo, po/sr.po, po/zh_CN.mo,
	po/zh_CN.po:
	Updated translations from translationproject.org
	[bf722e18b]

	* docs/CONTRIBUTORS.md:
	Add Andika Triwidada
	[86f1d52a0]

	* MANIFEST, po/id.mo, po/id.po:
	New Indonesian translation from translationproject.org
	[9a2a882d1]

2023-10-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Mention GitHub issue #318
	[0fbb17de5]

	* plugins/sudoers/env.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Avoid a double-free in fuzz_policy caused by the early
	env_init(NULL).

	This adds an env_free() function to explicitly free both the old and
	new copies of the environment. It is really only needed by
	fuzz_policy, which calls the policy module multiple times.
	[392ae0f03]

	* include/sudo_eventlog.h, lib/eventlog/eventlog.c,
	lib/eventlog/eventlog_free.c, lib/eventlog/parse_json.c,
	logsrvd/iolog_writer.c, logsrvd/sendlog.c, plugins/sudoers/iolog.c,
	plugins/sudoers/log_client.c, plugins/sudoers/logging.c,
	plugins/sudoers/logging.h:
	Store submitenv in eventlog and pass it to sudo_logsrvd.
	[3bbc7c8f8]

2023-10-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_eventlog.h, lib/eventlog/eventlog.c,
	lib/eventlog/eventlog_free.c, lib/eventlog/parse_json.c,
	lib/iolog/iolog_loginfo.c, logsrvd/iolog_writer.c,
	logsrvd/sendlog.c, plugins/sudoers/iolog.c,
	plugins/sudoers/log_client.c, plugins/sudoers/logging.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/sudoreplay.c:
	struct eventlog: rename argv/env to runargv/runenv.

	This matches the JSON logs.
	[726b646b4]

	* plugins/sudoers/logging.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	struct sudoers_user_context: rename env_vars to env_add
	[c7a61a943]

	* plugins/sudoers/audit.c, plugins/sudoers/logging.c:
	Only log the run environment for commands that are allowed.

	It may not be available otherwise and unless the command is being
	run it has no real meaning.
	[2b87749f8]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c:
	Free the private copy of the environment in sudoers_check_cmnd().

	This reverts 5118eb5797fb, which had the side-effect of the PAM
	session code running with the run environment instead of the
	invoking user's environment. Issue #318
	[077826292]

2023-10-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/iolog/iolog_swapids.c:
	iolog_swapids: short circuit if effective ids match iolog ids.
	[8486976b9]

	* lib/iolog/iolog_mkdirs.c, logsrvd/iolog_writer.c:
	logsrvd: display error string in message if iolog_mkpath() fails
	[09a426437]

	* plugins/sudoers/po/sudoers.pot, po/sudo.pot:
	Update .pot files for 1.9.15
	[29f796742]

2023-10-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.in:
	Add example for disabling intercept/log_subcmds for certain
	commands.
	[e3edd7a09]

	* lib/util/mksiglist.c, lib/util/mksigname.c:
	Use NSIG instead of nitems(array) for the loop bound.

	This matches the sudo_sys_siglist[] and sudo_sys_signame[]
	declarations.
	[78edde5ea]

	* plugins/sudoers/tsdump.c:
	tsdump: fix compiler warnings
	[385d506d3]

2023-10-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/eventlog/regress/logwrap/check_wrap.c, lib/util/mksiglist.c,
	lib/util/mksigname.c, logsrvd/sendlog.c,
	plugins/python/regress/iohelpers.c, plugins/sudoers/tsdump.c:
	Avoid using %zu or %zd with printf() and fprintf().

	This prevents problems on systems where the system printf(3) is not
	C99-compliant. We use our own snprintf() on such systems so that is
	safe.
	[14d514e5a]

	* plugins/sudoers/sudo_printf.c, src/conversation.c:
	Use vsnprintf() instead of vfprintf() for sudo_printf() to avoid
	problems on systems where the system printf(3) is not C99-compliant.
	We use our own snprintf() on such systems.
	[58d6554a7]

	* include/sudo_compat.h, lib/util/getdelim.c, lib/util/realpath.c,
	lib/util/regress/getdelim/getdelim_test.c, plugins/sudoers/toke.c,
	plugins/sudoers/toke.l:
	strlcpy_expand_host, sudo_getdelim, sudo_realpath: add restrict
	qualifier
	[cf9fc5317]

	* NEWS:
	Fixed GitHub issue #312.
	[29ddd2679]

2023-10-16  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* plugins/sudoers/prompt.c, plugins/sudoers/strlcpy_unesc.c,
	plugins/sudoers/sudoers.h:
	Add restrict to strlcpy and expand_prompt
	[97f805242]

2023-10-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/term.c:
	Better handling of multiple sudo processes modifying terminal
	settings. 1. Lock the terminal before tcgetattr/tcsetattr 2. Don't
	restore terminal settings if changed by another process 3. Don't set
	terminal to raw mode if it is already raw GitHub issue #312
	[fabb6264f]

	* src/exec_pty.c:
	Add a little extra debugging info.
	[2f80865e7]

2023-05-05  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* plugins/sudoers/sudoers_hooks.c:
	Redundant cast removal in sudoers_hooks

	def_sudoers_locale is already a char*
	[b2a44430b]

2023-07-18  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/eventlog/regress/logwrap/check_wrap.c, lib/util/glob.c,
	lib/util/mksiglist.c, lib/util/mksigname.c,
	lib/util/regress/glob/globtest.c, logsrvd/sendlog.c,
	plugins/group_file/plugin_test.c,
	plugins/python/regress/check_python_examples.c,
	plugins/sudoers/getdate.c, plugins/sudoers/getdate.y,
	plugins/sudoers/sudoreplay.c, plugins/sudoers/tsdump.c:
	Prefer fputs over fprintf where possible

	fprintf does extra work and meant for formatting strings.
	[e095069d2]

2023-10-15  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/regress/hexchar/hexchar_test.c,
	lib/util/regress/parse_gids/parse_gids_test.c, lib/util/sudo_conf.c:
	Swap calloc arguments to use them properly.
	[a4cbd7fe7]

2023-10-13  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* include/sudo_util.h, src/exec_ptrace.h:
	Specify 1U over 1 for bitmaps
	[dd8426f9c]

2023-10-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_ptrace.c:
	ptrace_intercept_execve: make flags unsigned to match
	command_details
	[873e0de07]

2023-10-12  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/sudo_auth.h, plugins/sudoers/parse.h,
	plugins/sudoers/sudoers.h:
	Fix spelling: resistent -> resistant
	[2d437c793]

2023-10-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .gitignore, .hgignore:
	Add plugins/sudoers/tsgetusershell.c to ignore files.
	[98c2eeafd]

2023-10-02  Alexander F. Rødseth  <alexander.fet.rodseth@schibsted.com>

	* plugins/sudoers/visudo.c:
	Add Orbiton ("o") to the list of editors that supports +lineno
	[07426f8a1]

	* plugins/sudoers/visudo.c:
	Sort the list of editors that supports +lineno
	[356ea96ef]

2023-10-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/mkdefaults:
	Fix compatibility with older versions of (new) awk.

	Do not rely on awk supporting "-f -" to read the program from stdin.
	Avoid using POSIX character classes in regular expressions.
	[9a715b694]

2023-09-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Mention potential problems with log_subcmds and intercept.
	[3141f63b2]

	* src/sudo.c:
	Add more user info to the list of objects to be garbage-collected at
	exit.
	[f6561bc97]

2023-09-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/pyhelpers.c, plugins/python/pyhelpers.h:
	Use long, not long long, when getting/setting numeric attributes.

	We use int or long, not long long, in the Python plugin.
	[344e0daec]

	* lib/eventlog/parse_json.c, lib/iolog/iolog_legacy.c,
	lib/iolog/iolog_timing.c, logsrvd/iolog_writer.c,
	logsrvd/logsrvd_conf.c, logsrvd/logsrvd_journal.c,
	logsrvd/logsrvd_local.c, logsrvd/sendlog.c,
	plugins/sudoers/defaults.c, plugins/sudoers/iolog.c,
	plugins/sudoers/log_client.c:
	Add casts when storing values in a struct timespec.

	Fixes -Wconversion warnings on some 32-bit systems where time_t is
	still 32-bit.
	[1398289fa]

	* plugins/sudoers/file.c:
	sudo_file_open: initialize parser before calling open_sudoers().

	Otherwise, the parser_conf settings in the context passed to
	sudo_file_open() will not be honored by open_sudoers(). Affected
	settings include ignore_perms, sudoers mode, uid and gid.
	[9cc57f493]

2023-09-27  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/roundup.c:
	Use U, not UL, for 32-bit platforms

	size_t is an unsigned int on 32-bit platforms, not an unsigned long.
	[b2f8c5666]

2023-09-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match_digest.c:
	digest_matches: actually use fd2 in place of fd as needed.
	[837f400ac]

	* plugins/sudoers/match_digest.c:
	digest_matches: if fd argument is -1, try to open path before
	failing
	[ff2d8464c]

	* plugins/sudoers/regress/cvtsudoers/test31.sh,
	plugins/sudoers/regress/cvtsudoers/test32.sh,
	plugins/sudoers/regress/cvtsudoers/test35.sh,
	plugins/sudoers/regress/cvtsudoers/test36.sh,
	plugins/sudoers/regress/cvtsudoers/test39.sh,
	plugins/sudoers/regress/testsudoers/test20.sh,
	plugins/sudoers/regress/testsudoers/test21.sh,
	plugins/sudoers/regress/testsudoers/test22.sh,
	plugins/sudoers/regress/testsudoers/test23.sh,
	plugins/sudoers/regress/testsudoers/test24.sh,
	plugins/sudoers/regress/testsudoers/test25.sh,
	plugins/sudoers/regress/testsudoers/test26.sh,
	plugins/sudoers/regress/testsudoers/test27.sh,
	plugins/sudoers/regress/testsudoers/test28.sh,
	plugins/sudoers/regress/testsudoers/test29.sh,
	plugins/sudoers/regress/testsudoers/test30.sh,
	plugins/sudoers/regress/testsudoers/test31.sh:
	Add missing execute bit on some test scripts.
	[4d4279d0c]

2023-09-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.h:
	max_groups in sudoers_plugin_settings is no longer used.
	[29feb41da]

	* include/sudo_conf.h, include/sudo_debug.h, include/sudo_event.h,
	include/sudo_eventlog.h, include/sudo_fatal.h, include/sudo_json.h,
	include/sudo_util.h, lib/eventlog/eventlog.c,
	lib/eventlog/eventlog_conf.c, lib/eventlog/eventlog_free.c,
	lib/eventlog/logwrap.c, lib/eventlog/parse_json.c,
	lib/eventlog/parse_json.h,
	lib/eventlog/regress/eventlog_store/store_json_test.c,
	lib/eventlog/regress/eventlog_store/store_sudo_test.c,
	lib/eventlog/regress/logwrap/check_wrap.c,
	lib/eventlog/regress/parse_json/check_parse_json.c,
	lib/fuzzstub/fuzzstub.c, lib/iolog/host_port.c,
	lib/iolog/hostcheck.c, lib/iolog/iolog_clearerr.c,
	lib/iolog/iolog_close.c, lib/iolog/iolog_conf.c,
	lib/iolog/iolog_eof.c, lib/iolog/iolog_filter.c,
	lib/iolog/iolog_flush.c, lib/iolog/iolog_gets.c,
	lib/iolog/iolog_json.c, lib/iolog/iolog_legacy.c,
	lib/iolog/iolog_loginfo.c, lib/iolog/iolog_mkdirs.c,
	lib/iolog/iolog_mkdtemp.c, lib/iolog/iolog_mkpath.c,
	lib/iolog/iolog_nextid.c, lib/iolog/iolog_open.c,
	lib/iolog/iolog_openat.c, lib/iolog/iolog_path.c,
	lib/iolog/iolog_read.c, lib/iolog/iolog_seek.c,
	lib/iolog/iolog_swapids.c, lib/iolog/iolog_timing.c,
	lib/iolog/iolog_util.c, lib/iolog/iolog_write.c,
	lib/iolog/regress/fuzz/fuzz_iolog_json.c,
	lib/iolog/regress/fuzz/fuzz_iolog_legacy.c,
	lib/iolog/regress/fuzz/fuzz_iolog_timing.c,
	lib/iolog/regress/host_port/host_port_test.c,
	lib/iolog/regress/iolog_filter/check_iolog_filter.c,
	lib/iolog/regress/iolog_mkpath/check_iolog_mkpath.c,
	lib/iolog/regress/iolog_path/check_iolog_path.c,
	lib/iolog/regress/iolog_timing/check_iolog_timing.c,
	lib/logsrv/log_server.pb-c.c, lib/protobuf-c/protobuf-c.c,
	lib/ssl_compat/ssl_compat.c, lib/util/aix.c, lib/util/arc4random.c,
	lib/util/arc4random_buf.c, lib/util/arc4random_uniform.c,
	lib/util/basename.c, lib/util/cfmakeraw.c, lib/util/closefrom.c,
	lib/util/digest.c, lib/util/digest_gcrypt.c,
	lib/util/digest_openssl.c, lib/util/dup3.c, lib/util/event.c,
	lib/util/event_poll.c, lib/util/event_select.c,
	lib/util/explicit_bzero.c, lib/util/fatal.c, lib/util/fchmodat.c,
	lib/util/fchownat.c, lib/util/fnmatch.c, lib/util/freezero.c,
	lib/util/fstatat.c, lib/util/getaddrinfo.c, lib/util/getdelim.c,
	lib/util/getentropy.c, lib/util/getgrouplist.c,
	lib/util/gethostname.c, lib/util/getopt_long.c, lib/util/gettime.c,
	lib/util/getusershell.c, lib/util/gidlist.c, lib/util/glob.c,
	lib/util/gmtime_r.c, lib/util/hexchar.c, lib/util/inet_ntop.c,
	lib/util/inet_pton.c, lib/util/isblank.c, lib/util/json.c,
	lib/util/key_val.c, lib/util/lbuf.c, lib/util/localtime_r.c,
	lib/util/locking.c, lib/util/logfac.c, lib/util/logpri.c,
	lib/util/memrchr.c, lib/util/mkdir_parents.c, lib/util/mkdirat.c,
	lib/util/mksiglist.c, lib/util/mksigname.c, lib/util/mktemp.c,
	lib/util/mmap_alloc.c, lib/util/multiarch.c, lib/util/nanosleep.c,
	lib/util/openat.c, lib/util/parseln.c, lib/util/pipe2.c,
	lib/util/pread.c, lib/util/progname.c, lib/util/pw_dup.c,
	lib/util/pwrite.c, lib/util/rcstr.c, lib/util/reallocarray.c,
	lib/util/regex.c, lib/util/regress/closefrom/closefrom_test.c,
	lib/util/regress/digest/digest_test.c,
	lib/util/regress/fnmatch/fnm_test.c,
	lib/util/regress/fuzz/fuzz_sudo_conf.c,
	lib/util/regress/getdelim/getdelim_test.c,
	lib/util/regress/getgrouplist/getgids.c,
	lib/util/regress/getgrouplist/getgrouplist_test.c,
	lib/util/regress/glob/globtest.c,
	lib/util/regress/hexchar/hexchar_test.c,
	lib/util/regress/json/json_test.c,
	lib/util/regress/mktemp/mktemp_test.c,
	lib/util/regress/multiarch/multiarch_test.c,
	lib/util/regress/open_parent_dir/open_parent_dir_test.c,
	lib/util/regress/parse_gids/parse_gids_test.c,
	lib/util/regress/progname/progname_test.c,
	lib/util/regress/regex/regex_test.c,
	lib/util/regress/strsig/strsig_test.c,
	lib/util/regress/strsplit/strsplit_test.c,
	lib/util/regress/strtofoo/strtobool_test.c,
	lib/util/regress/strtofoo/strtoid_test.c,
	lib/util/regress/strtofoo/strtomode_test.c,
	lib/util/regress/strtofoo/strtonum_test.c,
	lib/util/regress/sudo_conf/conf_test.c,
	lib/util/regress/sudo_parseln/parseln_test.c,
	lib/util/regress/tailq/hltq_test.c,
	lib/util/regress/uuid/uuid_test.c, lib/util/roundup.c,
	lib/util/secure_path.c, lib/util/setgroups.c, lib/util/sha2.c,
	lib/util/sig2str.c, lib/util/snprintf.c, lib/util/str2sig.c,
	lib/util/strlcat.c, lib/util/strlcpy.c, lib/util/strndup.c,
	lib/util/strnlen.c, lib/util/strsignal.c, lib/util/strsplit.c,
	lib/util/strtobool.c, lib/util/strtoid.c, lib/util/strtomode.c,
	lib/util/strtonum.c, lib/util/sudo_conf.c, lib/util/sudo_debug.c,
	lib/util/sudo_dso.c, lib/util/sys_siglist.h, lib/util/sys_signame.h,
	lib/util/term.c, lib/util/timegm.c, lib/util/ttyname_dev.c,
	lib/util/ttysize.c, lib/util/unlinkat.c, lib/util/utimens.c,
	lib/util/uuid.c, logsrvd/iolog_writer.c, logsrvd/logsrv_util.c,
	logsrvd/logsrvd.c, logsrvd/logsrvd.h, logsrvd/logsrvd_conf.c,
	logsrvd/logsrvd_journal.c, logsrvd/logsrvd_local.c,
	logsrvd/logsrvd_queue.c, logsrvd/logsrvd_relay.c,
	logsrvd/regress/fuzz/fuzz_logsrvd_conf.c,
	logsrvd/regress/logsrvd_conf/logsrvd_conf_test.c, logsrvd/sendlog.c,
	logsrvd/sendlog.h, logsrvd/tls_client.c, logsrvd/tls_common.h,
	logsrvd/tls_init.c, plugins/audit_json/audit_json.c,
	plugins/group_file/getgrent.c, plugins/group_file/group_file.c,
	plugins/group_file/plugin_test.c, plugins/python/pyhelpers.c,
	plugins/python/pyhelpers.h, plugins/python/python_plugin_common.c,
	plugins/python/regress/check_python_examples.c,
	plugins/python/regress/iohelpers.h,
	plugins/python/regress/testhelpers.h,
	plugins/python/sudo_python_debug.c,
	plugins/python/sudo_python_debug.h, plugins/sample/sample_plugin.c,
	plugins/sample_approval/sample_approval.c, plugins/sudoers/alias.c,
	plugins/sudoers/audit.c, plugins/sudoers/auth/afs.c,
	plugins/sudoers/auth/aix_auth.c, plugins/sudoers/auth/bsdauth.c,
	plugins/sudoers/auth/dce.c, plugins/sudoers/auth/fwtk.c,
	plugins/sudoers/auth/kerb5.c, plugins/sudoers/auth/pam.c,
	plugins/sudoers/auth/passwd.c, plugins/sudoers/auth/rfc1938.c,
	plugins/sudoers/auth/secureware.c, plugins/sudoers/auth/securid5.c,
	plugins/sudoers/auth/sia.c, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/b64_decode.c, plugins/sudoers/b64_encode.c,
	plugins/sudoers/boottime.c, plugins/sudoers/bsm_audit.c,
	plugins/sudoers/canon_path.c, plugins/sudoers/check.c,
	plugins/sudoers/check_aliases.c, plugins/sudoers/check_util.c,
	plugins/sudoers/cvtsudoers.c, plugins/sudoers/cvtsudoers.h,
	plugins/sudoers/cvtsudoers_csv.c, plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/cvtsudoers_ldif.c,
	plugins/sudoers/cvtsudoers_merge.c,
	plugins/sudoers/cvtsudoers_pwutil.c, plugins/sudoers/defaults.c,
	plugins/sudoers/defaults.h, plugins/sudoers/digestname.c,
	plugins/sudoers/display.c, plugins/sudoers/editor.c,
	plugins/sudoers/env.c, plugins/sudoers/env_pattern.c,
	plugins/sudoers/exptilde.c, plugins/sudoers/file.c,
	plugins/sudoers/filedigest.c, plugins/sudoers/find_path.c,
	plugins/sudoers/fmtsudoers.c, plugins/sudoers/fmtsudoers_cvt.c,
	plugins/sudoers/gc.c, plugins/sudoers/gentime.c,
	plugins/sudoers/getdate.c, plugins/sudoers/getdate.y,
	plugins/sudoers/getspwuid.c, plugins/sudoers/goodpath.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/group_plugin.c, plugins/sudoers/insults.h,
	plugins/sudoers/interfaces.c, plugins/sudoers/iolog.c,
	plugins/sudoers/iolog_path_escapes.c, plugins/sudoers/ldap.c,
	plugins/sudoers/ldap_conf.c, plugins/sudoers/ldap_innetgr.c,
	plugins/sudoers/ldap_util.c, plugins/sudoers/linux_audit.c,
	plugins/sudoers/locale.c, plugins/sudoers/log_client.c,
	plugins/sudoers/log_client.h, plugins/sudoers/logging.c,
	plugins/sudoers/lookup.c, plugins/sudoers/match.c,
	plugins/sudoers/match_addr.c, plugins/sudoers/match_command.c,
	plugins/sudoers/match_digest.c, plugins/sudoers/parse.h,
	plugins/sudoers/parse_ldif.c, plugins/sudoers/parser_warnx.c,
	plugins/sudoers/pivot.c, plugins/sudoers/policy.c,
	plugins/sudoers/prompt.c, plugins/sudoers/pwutil.c,
	plugins/sudoers/pwutil_impl.c, plugins/sudoers/redblack.c,
	plugins/sudoers/regress/check_symbols/check_symbols.c,
	plugins/sudoers/regress/editor/check_editor.c,
	plugins/sudoers/regress/env_match/check_env_pattern.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/regress/parser/check_addr.c,
	plugins/sudoers/regress/parser/check_base64.c,
	plugins/sudoers/regress/parser/check_digest.c,
	plugins/sudoers/regress/parser/check_fill.c,
	plugins/sudoers/regress/parser/check_gentime.c,
	plugins/sudoers/regress/serialize_list/check_serialize_list.c,
	plugins/sudoers/regress/starttime/check_starttime.c,
	plugins/sudoers/regress/unescape/check_unesc.c,
	plugins/sudoers/resolve_cmnd.c, plugins/sudoers/serialize_list.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/sethost.c,
	plugins/sudoers/solaris_audit.c, plugins/sudoers/sssd.c,
	plugins/sudoers/starttime.c, plugins/sudoers/strlcpy_unesc.c,
	plugins/sudoers/strlist.c, plugins/sudoers/strvec_join.c,
	plugins/sudoers/stubs.c, plugins/sudoers/sudo_nss.c,
	plugins/sudoers/sudo_printf.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/sudoers_cb.c,
	plugins/sudoers/sudoers_ctx_free.c, plugins/sudoers/sudoers_debug.c,
	plugins/sudoers/sudoers_debug.h, plugins/sudoers/sudoers_hooks.c,
	plugins/sudoers/sudoreplay.c, plugins/sudoers/testsudoers.c,
	plugins/sudoers/testsudoers_pwutil.c,
	plugins/sudoers/testsudoers_pwutil.h, plugins/sudoers/timeout.c,
	plugins/sudoers/timestamp.c, plugins/sudoers/timestr.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l,
	plugins/sudoers/toke_util.c, plugins/sudoers/tsdump.c,
	plugins/sudoers/tsgetgrpw.c, plugins/sudoers/unesc_str.c,
	plugins/sudoers/visudo.c, plugins/sudoers/visudo_cb.c,
	plugins/system_group/system_group.c, src/apparmor.c,
	src/conversation.c, src/copy_file.c, src/edit_open.c,
	src/env_hooks.c, src/exec.c, src/exec_common.c,
	src/exec_intercept.c, src/exec_iolog.c, src/exec_monitor.c,
	src/exec_nopty.c, src/exec_preload.c, src/exec_ptrace.c,
	src/exec_pty.c, src/get_pty.c, src/hooks.c, src/intercept.pb-c.c,
	src/limits.c, src/load_plugins.c, src/openbsd.c, src/parse_args.c,
	src/preload.c, src/preserve_fds.c,
	src/regress/net_ifs/check_net_ifs.c,
	src/regress/noexec/check_noexec.c,
	src/regress/ttyname/check_ttyname.c, src/selinux.c, src/sesh.c,
	src/signal.c, src/solaris.c, src/sudo.c, src/sudo.h,
	src/sudo_edit.c, src/sudo_intercept.c, src/sudo_intercept_common.c,
	src/sudo_noexec.c, src/suspend_parent.c, src/tgetpass.c,
	src/ttyname.c, src/utmp.c:
	Use #include <foo.h> instead of #include "foo.h" in most cases.

	We rely on the include path to find many of these headers. It
	especially doesn't make sense to use #include "foo.h" for headers in
	the top-level include directory.
	[e343e0754]

	* .circleci/config.yml:
	Bump xcode to 14.2.0
	[884b02596]

2023-09-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/defaults.c, plugins/sudoers/defaults.h,
	plugins/sudoers/mkdefaults:
	Add support for "plugin" defaults type.
	[1c13b8a62]

	* plugins/sudoers/mkdefaults:
	Support multiple input files.
	[c1708f0cf]

2023-09-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_monitor.c, src/exec_pty.c:
	No need to loop reading from/writing to a blocking socketpair.

	This removes some infinite loops that can cause static analyzer
	warnings. The fds are not in non-blocking mode and we use
	restartable system calls so there is no need to loop.
	[171abbe11]

	* plugins/sudoers/check.c:
	check_user: fix return value for intercept mode

	Also use early return on error to quiet a PVS-Studio warning.
	[1c7d757b7]

2023-09-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	Set ec->term_raw to false even if sudo_term_restore() fails.

	Either the fd is not a terminal or we don't have the controlling
	terminal. Either way, we can't know the current status of the
	terminal and will need to set to raw mode again (if possible). Also
	make sure to set ec->term_raw to false if sudo_term_raw() fails.
	[988d7f60f]

2023-09-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* pathnames.h.in, plugins/sudoers/env.c, plugins/sudoers/sudoers.c:
	Only define _PATH_ENVIRONMENT on systems where we use
	/etc/environment.
	[f2d267bfb]

	* config.h.in, configure, configure.ac:
	Sudo assumes that a uid_t can be cast to unsigned int without
	problems.

	Add a configure check and error out if sizeof(uid_t) > 4.
	[0c6745692]

	* docs/UPGRADE.md:
	Mention the time stamp and lecture file name changes in 1.9.15.
	[f4acc4366]

2023-08-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, configure, configure.ac:
	sudo 1.9.15
	[37ee2946a]

2023-09-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in,
	plugins/sudoers/iolog_path_escapes.c, plugins/sudoers/toke.c,
	plugins/sudoers/toke.l:
	Replace '/' with '_' in paths using the user, group or host name.
	[d9da92951]

2023-09-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in,
	docs/sudoers_timestamp.man.in, docs/sudoers_timestamp.mdoc.in,
	plugins/sudoers/check.c, plugins/sudoers/timestamp.c,
	plugins/sudoers/timestamp.h:
	Use the user-ID instead of user-name for the timestamp and lecture
	file.

	This avoids problems if the user name itself contains a path
	separator.
	[7363ad7b3]

2023-09-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* config.h.in, configure, configure.ac, m4/sudo.m4,
	plugins/sudoers/cvtsudoers_pwutil.c, plugins/sudoers/env.c,
	plugins/sudoers/iolog.c, plugins/sudoers/ldap.c,
	plugins/sudoers/policy.c, src/sudo.c, src/sudo_edit.c:
	Replace MAX_UID_T_LEN with calls to STRLEN_MAX_UNSIGNED.
	[94b80e3ad]

	* include/sudo_util.h, lib/eventlog/eventlog.c,
	lib/iolog/iolog_timing.c, lib/util/json.c, lib/util/lbuf.c,
	lib/util/sudo_debug.c, plugins/sudoers/cvtsudoers_ldif.c,
	plugins/sudoers/display.c, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/logging.c, src/exec_preload.c, src/limits.c:
	Add macros to determine the length of an integer type in string
	form.

	Adapted from answer #6 in:
	https://stackoverflow.com/questions/10536207/ansi-c-maximum-number-o
	f-characters-printing-a-decimal-int
	[d53bbb54b]

2023-09-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/visudo.c:
	visudo: use verbose and strict in parser_conf

	Where the sudoers_context is available we can use the values of
	verbose and strict instead of passing around quiet and strict flags.
	[221a10340]

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/find_path.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/resolve_cmnd.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Add resolve_cmnd(), a wrapper around find_path().

	This is a convenience function that sets PERM_RUNAS and calls
	find_path(). If the command is not found it will retry with
	PERM_USER instead.
	[6e75f2311]

	* plugins/sudoers/sudoers.h, plugins/sudoers/visudo.c:
	Promote strict field in sudoers_parser_config from bool to int.

	This will be used by visudo to indicate when "visudo -s" is run.
	[8fcb21b5c]

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/check_aliases.c, plugins/sudoers/defaults.c,
	plugins/sudoers/parse.h, plugins/sudoers/parser_warnx.c:
	Add parser_warnx() and parser_vwarnx() that displays file:line:col

	Used by defaults.c and check_aliases.c.
	[e28dc0f27]

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/visudo.c,
	plugins/sudoers/visudo_cb.c:
	Add a separate file for visudo callbacks.
	[3a7731437]

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/sudoers.h,
	plugins/sudoers/sudoers_cb.c:
	Rename callbacks.c -> sudoers_cb.c.
	[c277e55f4]

	* src/exec_monitor.c:
	Wait on a socketpair for the parent to grant child the controlling
	tty.

	This upgrades the error pipe to a bi-directional socketpair that the
	parent will write to after it has granted the child process the
	controlling terminal. That fixes an issue where the child could end
	up in a tight CPU loop waiting on the parent which may not be
	scheduled immediately.
	[0cb3e3344]

2023-09-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.h:
	Undefine AUTH_{SUCCESS,FAILURE,ERROR} before defining them.

	Quiets a warning on AIX where usersec.h defines AUTH_SUCCESS and
	AUTH_FAILURE. We avoided this problem in the past because the old
	values for AUTH_SUCCESS and AUTH_FAILURE match what AIX defines.
	[a127ddf6d]

	* config.h.in, configure, configure.ac, lib/util/term.c, m4/sudo.m4,
	src/exec_pty.c:
	Only cast TIOCSWINSZ to int on systems that might require it (AIX).

	Otherwise we end up with a -Wconversion warning on systems where the
	ioctl() request argument is unsigned long.
	[49c7c1f4d]

	* plugins/sudoers/display.c, plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h:
	Promote verbose flag to int for display_privs and display_cmnd.

	A negative verbosity will prevent non-error output from being
	displayed.
	[51d6b0f42]

2023-09-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/stubs.c:
	No need to include cvtsudoers.h here.
	[a9ee97580]

	* plugins/sudoers/match_command.c, plugins/sudoers/pivot.c,
	plugins/sudoers/pivot.h, plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/stubs.c, plugins/sudoers/testsudoers.c:
	Remove pivot_get_root() and pivot_get_cwd().

	They are unnecessary since struct sudoers_pivot is not opaque. The
	implementation details are private to match_command.c.
	[0011333f8]

	* plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/regress/parser/check_fill.c:
	Quiet some -Wconversion warnings in the tests.
	[2aae36f34]

	* plugins/sudoers/defaults.c, plugins/sudoers/defaults.h,
	plugins/sudoers/editor.c, plugins/sudoers/find_path.c,
	plugins/sudoers/regress/editor/check_editor.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.h:
	Make flag in union sudo_defs_val bool to match how it is used.

	Adjust find_path()'s ignore_dot function argument to match.
	[b8f2680cf]

	* plugins/sudoers/audit.c, plugins/sudoers/bsm_audit.c,
	plugins/sudoers/bsm_audit.h, plugins/sudoers/policy.c,
	plugins/sudoers/sudoers.h:
	Parse euid and egid from sudo front-end.

	These are needed by bsm_audit.c.
	[a9801cc99]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/timestamp.c:
	Parse pid and ppid from sudo front-end.

	We can now use the stored ppid in ts_init_key().
	[38ddbb14f]

	* plugins/sudoers/match_command.c, plugins/sudoers/pivot.c,
	plugins/sudoers/pivot.h, plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/stubs.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/testsudoers.c:
	Use struct sudoers_pivot instead of defining sudoers_pivot_t.

	We want to pass around a pointer, not the struct itself.
	[34990c0e0]

2023-09-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/pivot.h:
	Don't expose the implementation of the pivot_root state.
	[15b3d786d]

	* plugins/sudoers/match_command.c, plugins/sudoers/pivot.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c, plugins/sudoers/stubs.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	Don't expose the implementation of the pivot_root state.
	[0b52ffd1a]

	* src/exec_ptrace.c:
	Only call ptrace_verify_post_exec() for intercept, not log_subcmds.

	This fixes a logic goof introduced in sudo 1.9.14.
	[4117ad146]

2023-09-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/Makefile.in:
	tsgetusershell.c: don't rely on GNU sed extensions.
	[c0553cd38]

	* plugins/sudoers/testsudoers.c:
	testsudoers: add -S option to specify /etc/shells path.
	[0a8586928]

	* Makefile.in, lib/util/getusershell.c, plugins/sudoers/Makefile.in,
	plugins/sudoers/pwutil_impl.c, plugins/sudoers/tsgetgrpw.h:
	Add testsudoers_setshellfile() and use it in testsudoers.
	[034b2f3bd]

	* plugins/sudoers/Makefile.in:
	regen
	[62b92c7fb]

	* lib/util/Makefile.in, lib/util/getusershell.c:
	Remove unnecessary sudo_gettext.h include and add missing const.
	[166ef55aa]

2023-09-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/sudo_auth.h, plugins/sudoers/check.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/timestamp.h:
	Return AUTH_* flags from check_user() instead of 1/0/-1.
	[c54bdd799]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/pwutil.c,
	plugins/sudoers/pwutil.h, plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/testsudoers_pwutil.h:
	Wrap valid_shell and add to sudo_pwutil_set_backend().

	This will make it possible to support a different getusershell()
	implementation for testsudoers in the future.
	[2fdb4db33]

	* plugins/sudoers/check_util.c, plugins/sudoers/pwutil.c,
	plugins/sudoers/pwutil.h, plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	Move check_user_shell() to pwutil.c as user_shell_valid()

	This will make it possible to support a different backend which may
	be used by testsudoers in the future.
	[d18ee8e0e]

	* plugins/sudoers/auth/sudo_auth.c, plugins/sudoers/check.c,
	plugins/sudoers/timestamp.h:
	Merge check_user() and check_user_interactive(), move getpass
	callbacks.

	The getpass callbacks are now defined in sudo_auth.c, which
	implements auth_getpass(). As a result, struct getpass_closure is
	now public and defined in timestamp.h.
	[28a13501d]

	* plugins/sudoers/Makefile.in, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/auth/sudo_auth.h, plugins/sudoers/check.c,
	plugins/sudoers/timestamp.h:
	Make most sudo_auth functions return AUTH_{SUCCESS,FAILURE,FATAL}.
	[0495afac5]

	* plugins/sudoers/ldap.c, plugins/sudoers/lookup.c,
	plugins/sudoers/match.c, plugins/sudoers/match_addr.c,
	plugins/sudoers/match_command.c, plugins/sudoers/match_digest.c,
	plugins/sudoers/parse.h,
	plugins/sudoers/regress/parser/check_addr.c, plugins/sudoers/sssd.c:
	Make all match functions return ALLOW/DENY not true/false.
	[2ef90231a]

	* plugins/sudoers/auth/passwd.c, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/auth/sudo_auth.h, plugins/sudoers/lookup.c,
	plugins/sudoers/match.c, plugins/sudoers/parse.h:
	Try to make sudo less vulnerable to ROWHAMMER attacks.

	We now use ROWHAMMER-resistent values for ALLOW, DENY, AUTH_SUCCESS,
	AUTH_FAILURE, AUTH_ERROR and AUTH_NONINTERACTIVE. In addition, we
	explicitly test for expected values instead of using a negated test
	against an error value. In the parser match functions this means
	explicitly checking for ALLOW or DENY instead of accepting anything
	that is not set to UNSPEC.

	Thanks to Andrew J. Adiletta, M. Caner Tol, Yarkin Doroz, and Berk
	Sunar, all affiliated with the Vernam Applied Cryptography and
	Cybersecurity Lab at Worcester Polytechnic Institute, for the
	report. Paper preprint: https://arxiv.org/abs/2309.02545
	[7873f8334]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/toke.c, plugins/sudoers/toke.h,
	plugins/sudoers/toke.l:
	Honor ignore_perms plugin argument for @include and @includedir.
	[525803db2]

2023-09-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/check.c:
	Don't set on_suspend and on_resume twice.
	[499121229]

2023-09-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/cvtsudoers.c, plugins/sudoers/cvtsudoers.h,
	plugins/sudoers/policy.c, plugins/sudoers/sethost.c,
	plugins/sudoers/stubs.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	sudoers_sethost: refactor code to set host names in sudoers_context.

	The sudoers_sethost() function can be shared by the sudoers plugin,
	visudo, cvtsudoers and testsudoers.
	[956de5cbb]

2023-09-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	sudoers_trace_print: use debug_decl_vars instead of doing it by
	hand.
	[0c9ca88f5]

	* include/sudo_compat.h:
	sudo_realpath() returns char *, not void *.
	[080e08b0f]

2023-08-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.c:
	Only print "no valid sudoers sources found, quitting" for multiple
	sources.

	If there is only a single source (usually the sudoers file), the
	open function provide enough of an error message. Printing two error
	messages is just confusing.
	[d898d073b]

2023-08-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/pwutil.c:
	user_in_group: the user's group vector already includes the primary
	group.

	There's no need to look up the name of user's primary group
	(pw_gid), we always include the primary group ID in the group
	vector.
	[f5b3f9909]

2023-08-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.h, plugins/sudoers/sudoers_debug.h:
	Move sudoers_debug.c prototypes to sudoers_debug.h.
	[05f823df2]

	* plugins/sudoers/sudoers.h:
	sudo_conv, sudo_printf and plugin_event_alloc live in policy.c.
	[35a7283dd]

	* include/sudo_iolog.h, plugins/sudoers/defaults.c:
	Move default value for "iolog_file" to sudo_iolog.h.
	[68a9e9186]

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/auth/afs.c,
	plugins/sudoers/auth/dce.c, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/callbacks.c, plugins/sudoers/check.c,
	plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/regress/starttime/check_starttime.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/starttime.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/timestamp.c, plugins/sudoers/timestamp.h,
	plugins/sudoers/tsdump.c:
	Rename check.h -> timestamp.h and add remaining timestamp.c
	prototypes.
	[75209e271]

	* plugins/sudoers/auth/API, plugins/sudoers/auth/aix_auth.c,
	plugins/sudoers/auth/bsdauth.c, plugins/sudoers/auth/fwtk.c,
	plugins/sudoers/auth/pam.c, plugins/sudoers/auth/sia.c,
	plugins/sudoers/auth/sudo_auth.c, plugins/sudoers/auth/sudo_auth.h:
	Restore AUTH_INTR support, it is still needed.

	We still need AUTH_INTR to know when to break out of the password
	prompt loop.
	[8cd0d74fb]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in,
	plugins/sudoers/policy.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Add ignore_perms plugin argument to skip the sudoers file security
	checks.

	This is not intended to be used in a production environment.
	[3c05e748a]

2023-08-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, m4/sudo.m4:
	Fix test for unsetenv() returning void with clang 16.

	Clang has dropped support for K&R function definitions so rewrite
	the test to require a unsetenv() prototype in stdlib.h. Fixes GitHub
	issue #302.
	[1eb4392e1]

	* plugins/sudoers/defaults.c:
	Disable fast_glob and fdexec if SUDOERS_NAME_MATCH is defined.

	We use SUDOERS_NAME_MATCH for fuzzing when we want to avoid
	searching the file system for commands.
	[07003d902]

2023-08-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/API, plugins/sudoers/auth/aix_auth.c,
	plugins/sudoers/auth/bsdauth.c, plugins/sudoers/auth/fwtk.c,
	plugins/sudoers/auth/kerb5.c, plugins/sudoers/auth/pam.c,
	plugins/sudoers/auth/passwd.c, plugins/sudoers/auth/rfc1938.c,
	plugins/sudoers/auth/secureware.c, plugins/sudoers/auth/securid5.c,
	plugins/sudoers/auth/sia.c, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/auth/sudo_auth.h:
	Rename AUTH_FATAL -> AUTH_ERROR.
	[c858acc48]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/match.c:
	Do not rely on the definition of ALLOW/DENY being true/false.

	We now explicitly check for ALLOW and DENY when checking return
	values and negating values.
	[cf00568d8]

	* plugins/sudoers/auth/API, plugins/sudoers/auth/aix_auth.c,
	plugins/sudoers/auth/bsdauth.c, plugins/sudoers/auth/fwtk.c,
	plugins/sudoers/auth/pam.c, plugins/sudoers/auth/sia.c,
	plugins/sudoers/auth/sudo_auth.c, plugins/sudoers/auth/sudo_auth.h:
	Replace AUTH_INTR return with AUTH_FAILURE.

	The two were treated identically by the caller.
	[bae716642]

2023-08-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/audit.c:
	Call log_allowed() even when "log_allowed" is disabled.

	Otherwise, sudo will not send mail if "mail_always" or
	"mail_all_cmnds" is set.
	[b42cab112]

	* plugins/sudoers/defaults.c:
	Don't set defaults values for features that are not present.

	This means that lecture_status_dir and timestampdir are only set if
	_PATH_SUDO_LECTURE_DIR and _PATH_SUDO_TIMEDIR respectively are set.
	Also, the log server defaults are only set when SUDOERS_LOG_CLIENT
	is defined.
	[4cdee2e31]

	* plugins/sudoers/callbacks.c:
	Only set I/O logging callbacks if SESSID_MAX is defined.
	[993ee338d]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Move tty_present() into policy.c as sudoers_tty_present().

	This function is policy-dependent. For the modern sudo front-end it
	will simply check tcpgid and/or ttypath.
	[30fc28829]

2023-08-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/event_poll.c, lib/util/getentropy.c,
	plugins/sudoers/ldap.c:
	Silence a few remaining -Wconversion warnings.
	[df969d30b]

	* plugins/sudoers/sudoers.c:
	No need to inclue auth/sudo_auth.h
	[522ac12f2]

	* configure, m4/sudo.m4:
	--enable-pvs-studio: check for license file in the default location
	[18aba4984]

2023-08-23  ken  <41325712+rtczza@users.noreply.github.com>

	* plugins/sudoers/timestamp.c:
	modify ret type from int to bool (#298)

	* modify ret type from int to bool

	* change debug_return_int to debug_return_bool

	* modify ret type
	[60e584201]

2023-08-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/callbacks.c, plugins/sudoers/check.h,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/timestamp.c:
	Move timestampowner sudoers callback to timestamp.c.
	[091051125]

	* plugins/sudoers/set_perms.c:
	Quiet a PVS-Studio false positive about possible NULL dereference.

	set_perms() is only called with a NULL ctx for PERM_ROOT,
	PERM_SUDOERS and PERM_TIMESTAMP.
	[593998cb6]

2023-08-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/set_perms.c:
	set_perms: ctx may be NULL for PERM_ROOT, PERM_SUDOERS,
	PERM_TIMESTAMP.
	[821799d1f]

	* plugins/sudoers/audit.c, plugins/sudoers/iolog_path_escapes.c,
	plugins/sudoers/logging.c, plugins/sudoers/policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/sudoers_ctx_free.c:
	Move a few fields from sudoers_user_contect to sudoers_context.

	They are not really specific to the user or user-specified.
	[c7157ce0b]

	* plugins/sudoers/policy.c:
	Remove dead code dealing with unknown user and MODE_INVALIDATE.

	The timestamp unlink code does not need the user's struct passwd
	pointer, just the user name (which we already have). Found by
	PVS-Studio.
	[9aaba80a0]

	* lib/iolog/iolog_read.c, lib/iolog/iolog_write.c,
	lib/util/sudo_dso.c:
	Suppress some other PVS-Studio false positives.
	[df730dec5]

	* plugins/sudoers/set_perms.c:
	Quiet a PVS-Studio false positive about possible NULL dereference.

	set_perms() is only called with a NULL ctx for PERM_ROOT,
	PERM_SUDOERS and PERM_TIMESTAMP.
	[49cd7463c]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.h:
	MODE_KILL is never set in the sudoers plugin, remove it.
	[816120544]

	* plugins/sample/sample_plugin.c, plugins/sudoers/editor.c,
	plugins/sudoers/group_plugin.c, plugins/sudoers/policy.c,
	plugins/sudoers/sudoreplay.c, src/exec_ptrace.c:
	Cast int to size_t before adding instead of casting the result.

	Quiets PVS-Studio warning V1028.
	[c6987aa26]

	* plugins/sudoers/audit.c:
	Fix log_server_accept() definition for --disable-log-client builds.
	[9f05bfd29]

	* src/exec_pty.c:
	Use a global static struct exec_closure for the cleanup hook.

	This is safer than storing a pointer to a stack variable in the
	cleanup function since we don't need to worry about it ever going
	out of scope. Quiets a clang 15 analyzer warning.
	[e933fc7ba]

	* plugins/sudoers/logging.c:
	Plug memory leak if journal_parse_error() fails.

	Found by the clang 15 analyzer.
	[6fa478653]

	* lib/eventlog/eventlog.c, plugins/sudoers/testsudoers.c:
	Eliminate some clang analyzer false positives.
	[46e6955ba]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Move sudoedit_nfiles into struct sudoers_context.
	[ff5914d7f]

	* plugins/sudoers/audit.c, plugins/sudoers/auth/pam.c,
	plugins/sudoers/check.c, plugins/sudoers/env.c,
	plugins/sudoers/logging.c, plugins/sudoers/logging.h,
	plugins/sudoers/lookup.c, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	Move sudo_mode into struct sudoers_context.
	[3473bf936]

	* plugins/sudoers/audit.c, plugins/sudoers/auth/sia.c,
	plugins/sudoers/auth/sudo_auth.c, plugins/sudoers/logging.c,
	plugins/sudoers/logging.h, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/sudoers_ctx_free.c:
	Move NewArgv, NewArgc and saved_argv into struct sudoers_context.
	[837da1bef]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/file.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/parse.h, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	Add struct sudoers_conf to struct sudoers_plugin_context.

	There's now no need to pass this directly to init_parser() since we
	already pass in a pointer to a sudoers_context struct.
	[87571dab0]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/group_plugin.c,
	plugins/sudoers/ldap.c, plugins/sudoers/ldap_conf.c,
	plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/sudo_ldap_conf.h, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/visudo.c:
	Store policy paths in struct sudoers_context.

	This removes the need for the getters in policy.c.
	[9e53d903e]

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/stubs.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/sudoers_ctx_free.c,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	Add sudoers_ctx_free() and use it for freeing struct sudoers
	context.

	This replaces sudoers_user_ctx_free() and sudoers_runas_ctx_free().
	[bbaf29391]

	* plugins/sudoers/audit.c, plugins/sudoers/auth/afs.c,
	plugins/sudoers/auth/aix_auth.c, plugins/sudoers/auth/bsdauth.c,
	plugins/sudoers/auth/dce.c, plugins/sudoers/auth/fwtk.c,
	plugins/sudoers/auth/kerb5.c, plugins/sudoers/auth/pam.c,
	plugins/sudoers/auth/passwd.c, plugins/sudoers/auth/rfc1938.c,
	plugins/sudoers/auth/secureware.c, plugins/sudoers/auth/securid5.c,
	plugins/sudoers/auth/sia.c, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/auth/sudo_auth.h, plugins/sudoers/callbacks.c,
	plugins/sudoers/check.c, plugins/sudoers/check.h,
	plugins/sudoers/check_aliases.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers.h, plugins/sudoers/cvtsudoers_pwutil.c,
	plugins/sudoers/defaults.c, plugins/sudoers/defaults.h,
	plugins/sudoers/display.c, plugins/sudoers/env.c,
	plugins/sudoers/file.c, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.h,
	plugins/sudoers/gram.y, plugins/sudoers/group_plugin.c,
	plugins/sudoers/iolog.c, plugins/sudoers/iolog_path_escapes.c,
	plugins/sudoers/ldap.c, plugins/sudoers/locale.c,
	plugins/sudoers/logging.c, plugins/sudoers/logging.h,
	plugins/sudoers/lookup.c, plugins/sudoers/match.c,
	plugins/sudoers/match_command.c, plugins/sudoers/parse.h,
	plugins/sudoers/policy.c, plugins/sudoers/prompt.c,
	plugins/sudoers/pwutil.c, plugins/sudoers/pwutil.h,
	plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/solaris_audit.c,
	plugins/sudoers/solaris_audit.h, plugins/sudoers/sssd.c,
	plugins/sudoers/stubs.c, plugins/sudoers/sudo_nss.h,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/testsudoers_pwutil.h,
	plugins/sudoers/timestamp.c, plugins/sudoers/toke.c,
	plugins/sudoers/toke.h, plugins/sudoers/toke.l,
	plugins/sudoers/visudo.c:
	Make struct sudoers_context private to sudoers.c.

	We now pass a pointer to the context where necessary. There are a
	few cases where we need to request the context from sudoers via
	sudoers_get_context() for the plugin API functions. If the plugin
	API was able to pass around a closure pointer this would not be
	necessary.
	[244017495]

2023-08-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/audit.c, plugins/sudoers/auth/bsdauth.c,
	plugins/sudoers/auth/pam.c, plugins/sudoers/auth/passwd.c,
	plugins/sudoers/auth/sia.c, plugins/sudoers/callbacks.c,
	plugins/sudoers/check.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/defaults.c, plugins/sudoers/display.c,
	plugins/sudoers/env.c, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/iolog_path_escapes.c, plugins/sudoers/ldap.c,
	plugins/sudoers/logging.c, plugins/sudoers/lookup.c,
	plugins/sudoers/match.c, plugins/sudoers/match_command.c,
	plugins/sudoers/policy.c, plugins/sudoers/prompt.c,
	plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/solaris_audit.c,
	plugins/sudoers/sssd.c, plugins/sudoers/stubs.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/timestamp.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l,
	plugins/sudoers/visudo.c:
	Add a sudoers_context struct that embeds the user and runas structs.
	[2d2529a15]

2023-08-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y:
	free_parse_tree: clear the nss pointer when freeing.
	[1b9fb405a]

	* plugins/sudoers/parse_ldif.c:
	sudoers_parse_ldif: do not free parse_tree before using

	The user is expected to pass in an initialized and empty parse_tree
	so there is no need to free it first.
	[a712af5a2]

	* lib/zlib/adler32.c, lib/zlib/compress.c, lib/zlib/crc32.c,
	lib/zlib/deflate.c, lib/zlib/deflate.h, lib/zlib/gzclose.c,
	lib/zlib/gzguts.h, lib/zlib/gzlib.c, lib/zlib/gzread.c,
	lib/zlib/gzwrite.c, lib/zlib/infback.c, lib/zlib/inffast.c,
	lib/zlib/inffast.h, lib/zlib/inflate.c, lib/zlib/inftrees.c,
	lib/zlib/inftrees.h, lib/zlib/trees.c, lib/zlib/uncompr.c,
	lib/zlib/zconf.h.in, lib/zlib/zlib.h, lib/zlib/zutil.c,
	lib/zlib/zutil.h:
	Update embedded copy of zlib to version 1.3.
	[902453a82]

2023-08-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/pwutil_impl.c:
	We still need to clamp ngids if getgrouplist2() returns -1.

	Otherwise, we end up with ngids set to the number of gids the user
	belongs to which may be larger than what the front-end specified.
	Fixes a regression introduced in the last commit here.
	[cb01b90a5]

2023-08-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/policy.c:
	No need to clear errno when using sudo_strtonum().
	[f17aebe6a]

	* plugins/sudoers/policy.c, plugins/sudoers/pwutil.c,
	plugins/sudoers/pwutil_impl.c, plugins/sudoers/sudoers.h:
	Move max_groups out of sudoers_user_context and into pwutil.c.

	It is only used by the local password pwutil implementation.
	[20baa3900]

	* plugins/sudoers/check_util.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	Pass in directory to check_user_runchroot() and check_user_runcwd().

	This way we do not rely on the runas_ctx global.
	[737354390]

	* plugins/sudoers/regress/exptilde/check_exptilde.c:
	check_exptilde: don't need runas_ctx here
	[2e8648ea0]

	* plugins/sudoers/match.c, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c:
	Move RUNAS_{USER,GROUP}_SPECIFIED flags into struct
	sudoers_runas_context.
	[08afb5183]

2023-08-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/group_plugin.c, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c:
	Make path_plugin_dir private to policy.c and add getter.
	[392f0d61c]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/logging.c, plugins/sudoers/lookup.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	Move list_pw global into struct runas_context.
	[217b7b46f]

2023-08-12  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/auth/bsdauth.c, plugins/sudoers/callbacks.c,
	plugins/sudoers/check.c, plugins/sudoers/check_util.c,
	plugins/sudoers/cvtsudoers.c, plugins/sudoers/display.c,
	plugins/sudoers/env.c, plugins/sudoers/iolog_path_escapes.c,
	plugins/sudoers/ldap.c, plugins/sudoers/logging.c,
	plugins/sudoers/lookup.c, plugins/sudoers/match.c,
	plugins/sudoers/match_command.c, plugins/sudoers/policy.c,
	plugins/sudoers/prompt.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/sssd.c,
	plugins/sudoers/stubs.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/visudo.c:
	Add struct sudoers_runas_context and move runas-specific bits into
	it.
	[a321e6ced]

	* plugins/sudoers/auth/bsdauth.c, plugins/sudoers/auth/pam.c,
	plugins/sudoers/auth/passwd.c, plugins/sudoers/auth/sia.c,
	plugins/sudoers/callbacks.c, plugins/sudoers/check.c,
	plugins/sudoers/check_util.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/display.c, plugins/sudoers/env.c,
	plugins/sudoers/fmtsudoers.c, plugins/sudoers/iolog_path_escapes.c,
	plugins/sudoers/ldap.c, plugins/sudoers/logging.c,
	plugins/sudoers/lookup.c, plugins/sudoers/match.c,
	plugins/sudoers/match_command.c, plugins/sudoers/policy.c,
	plugins/sudoers/prompt.c, plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/solaris_audit.c,
	plugins/sudoers/sssd.c, plugins/sudoers/stubs.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/timestamp.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l,
	plugins/sudoers/visudo.c:
	Expand the user_* (and more) macros to user_ctx.foo.
	[d8b28dad9]

	* plugins/sudoers/check.h,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/timestamp.c:
	Pass explicit struct passwd * to create_admin_success_flag().
	[930ca0025]

	* plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h:
	Make sudoers_user_ctx_free() private to sudoers.c
	[30c49288f]

	* plugins/sudoers/audit.c, plugins/sudoers/callbacks.c,
	plugins/sudoers/check.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/defaults.c, plugins/sudoers/display.c,
	plugins/sudoers/logging.c, plugins/sudoers/lookup.c,
	plugins/sudoers/match.c, plugins/sudoers/policy.c,
	plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/sssd.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/timestamp.c, plugins/sudoers/visudo.c:
	Rename struct sudo_user -> struct sudo_user_context.

	Also rename the sudo_user global to user_ctx.
	[bd8cccb5d]

	* src/exec.c:
	fd_matches_tty: only zero out fd_sb if fstat(2) fails.

	We need to preserve the contents of the struct stat if the fd is
	some other type so the check for piped output works correctly. Bug
	#1057
	[d148e7d8f]

2023-08-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/callbacks.c:
	Leave the I/O log callbacks in iolog.c

	Otherwise, check_iolog_plugin will not link.
	[6f659e2de]

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/callbacks.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c:
	Move sudoers parser callbacks to callbacks.c.
	[603148e7f]

2023-08-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/sendlog.c:
	Bump info_msgs_size to make room for the source.
	[cc15f847a]

	* .circleci/config.yml:
	Update Xcode version from 13.2.1 to 13.4.1.
	[ee5cab977]

	* include/sudo_event.h, lib/util/event.c, lib/util/event_poll.c,
	lib/util/event_select.c, lib/util/util.exp.in:
	Use int, not short for events in the event API.

	This fixes some -Wconversion warnings and fixes an inconsistency
	between the libsudo_util event API and the plugin event API. The
	actual struct internals still use shorts to avoid changing the ABI.
	[811051d32]

	* plugins/sudoers/display.c, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/fmtsudoers_cvt.c, plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/testsudoers.c:
	Use const pointers where possible in the display code.
	[0f2e5dae9]

	* docs/sudo.man.in, docs/sudo.mdoc.in:
	Document "sudo -ll command" output.
	[6842dd1bf]

	* plugins/sudoers/display.c, plugins/sudoers/lookup.c,
	plugins/sudoers/parse.h, plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/testsudoers.c:
	Add verbose version of "sudo -l command" by using an extra -l.

	The output of "sudo -ll command" consists of the matching sudoers
	rule (in long form) with the addition of a "Matched" entry that
	shows the fully-qualfied path along with any arguments.
	[60eef27e6]

	* plugins/sudoers/display.c:
	Move code to display a cmndspec in long form to
	display_cmndspec_long().
	[f6291bf83]

	* plugins/sudoers/display.c:
	sudo -ll: display the sudoers file the rule came from.
	[5a1a3ff74]

2023-08-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/iolog.c, plugins/sudoers/log_client.c,
	plugins/sudoers/logging.c, plugins/sudoers/policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h:
	Store the source of the matching rule and store in the event log.

	The JSON logs will store the matching rule source.
	[e178b8582]

	* include/sudo_eventlog.h, lib/eventlog/eventlog.c,
	lib/eventlog/eventlog_free.c, lib/eventlog/parse_json.c,
	lib/eventlog/regress/eventlog_store/test1.json.in,
	lib/eventlog/regress/eventlog_store/test1.json.out.ok,
	lib/eventlog/regress/eventlog_store/test2.json.in,
	lib/eventlog/regress/eventlog_store/test2.json.out.ok,
	lib/eventlog/regress/eventlog_store/test3.json.in,
	lib/eventlog/regress/eventlog_store/test3.json.out.ok,
	lib/eventlog/regress/eventlog_store/test4.json.in,
	lib/eventlog/regress/eventlog_store/test4.json.out.ok,
	logsrvd/iolog_writer.c, logsrvd/sendlog.c:
	Log source in JSON logs

	This makes it possible to tell which rule resulted in a match.
	[0b03511b8]

2023-08-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/lookup.c, plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/testsudoers.c:
	Use a single callback for sudoers_lookup() and add a closure
	pointer.

	The single callback now receives all the match info (or UNSPEC if no
	match was attempted). This makes it possible to use the callback for
	more than just printing testsudoers output.
	[f6a9bb2e2]

2023-08-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/ssl_compat/ssl_compat.c, logsrvd/logsrvd.c,
	logsrvd/logsrvd_relay.c, logsrvd/sendlog.c,
	plugins/sudoers/log_client.c:
	Fix checking of SSL_{read,write}_ex() return value.

	These have a boolean-style return value. However, our emulated
	versions can return -1 on error, which we need to preserve for older
	versions of SSL_get_error() which expect it.
	[1e6c5f3e7]

2023-08-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/regress/digest/digest_test.c:
	Fix printf format string mismatch now that 'i' is size_t.
	[5f2a0a70e]

	* include/sudo_digest.h, lib/util/digest.c,
	lib/util/digest_gcrypt.c, lib/util/digest_openssl.c,
	lib/util/getentropy.c, lib/util/regress/digest/digest_test.c,
	lib/util/util.exp.in, plugins/sudoers/filedigest.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	sudo_digest_getlen: return size_t, and 0 on error instead of -1

	This is an API change, sudo_digest_getlen_v1 remains for binary
	compatibility.
	[77f94f291]

	* logsrvd/logsrvd_relay.c, logsrvd/sendlog.c,
	plugins/sudoers/log_client.c:
	ERR_get_error() returns unsigned long, not int.
	[184e03b4a]

	* plugins/sudoers/log_client.c:
	We now must pass "err" SSL_get_error(), not "nread".
	[861ed2b7d]

2023-08-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/hostcheck.h, lib/iolog/hostcheck.c:
	Move compat definition of ASN1_STRING_get0_data to hostcheck.c. It
	is not used anywhere else.
	[e5f2354c8]

2023-08-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/hostcheck.h, include/sudo_compat.h,
	include/sudo_ssl_compat.h:
	Move OpenSSL compat defines to sudo_ssl_compat.h
	[fc7bfd504]

	* MANIFEST, Makefile.in, configure, configure.ac,
	include/sudo_ssl_compat.h, lib/ssl_compat/Makefile.in,
	lib/ssl_compat/ssl_compat.c, logsrvd/Makefile.in,
	logsrvd/tls_common.h, m4/openssl.m4, plugins/sudoers/Makefile.in,
	plugins/sudoers/log_client.h, src/Makefile.in:
	Add implementation of SSL_read_ex/SSL_write_ex for those without.
	[d6d467b92]

	* config.h.in, configure, logsrvd/logsrvd.c,
	logsrvd/logsrvd_relay.c, logsrvd/sendlog.c, m4/openssl.m4,
	plugins/sudoers/log_client.c:
	Use SSL_read_ex() and SSL_write_ex() instead of SSL_read() and
	SSL_write().
	[e6d14c95b]

2023-08-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* etc/sudo-logsrvd.pp, etc/sudo-python.pp, etc/sudo.pp:
	Don't use sudo when building AIX packages

	PolyPkg uses "sudo installp -l" to list the built package by default
	but we may not have sudo privileges on the build host.
	[d404f544f]

	* scripts/mkpkg:
	Add --configure-only option to quit after the configure run.

	This will be used to avoid building the entire package when we just
	want the 32 or 64 bit sudo_intercept.so and sudo_noexec.so.
	[002e22f84]

	* scripts/mkpkg:
	Parse --disable-python in mkpkg and don't override -m32 for Solaris.

	We want to be able to build without python and to specify the memory
	model when building 32-bit .so's for Solaris.
	[8e22ede2a]

2023-07-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* INSTALL.md, Makefile.in, configure, configure.ac:
	Add --enable-postinstall, an optional phase when building packages.

	This makes it possible to run an arbitrary script between "make
	install" and the polypkg run. This will be used to copy different
	word size versions of sudo_intercept.so and sudo_noexec.so.
	[0a181849a]

	* INSTALL.md, config.h.in, configure, configure.ac,
	docs/sudo.conf.man.in, docs/sudo.conf.mdoc.in, src/exec_preload.c:
	Add basic support for 32-bit and 64-bit LD_PRELOAD equivalents.

	The noexec and intercept DSO settings may now include both a 32-bit
	DSO and a 64-bit DSO specified by a colon. For example:
	/usr/libexec/sudo/sudo_intercept.so:/usr/libexec/sudo/sudo_intercept
	_64.so.
	[980e0216a]

	* lib/util/term.c, src/exec_pty.c:
	Cast TIOCSWINSZ to int to avoid overflow warning on 64-bit AIX.
	[7cb1f7f3a]

2023-07-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/sudo_intercept_common.c:
	Read path section of sudo.conf for sudo_conf_intercept_path().
	[961f23af9]

2023-07-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/visudo.man.in, docs/visudo.mdoc.in:
	visudo: document that a new file is only created if the editor
	writes it.

	If visudo is used to create a new file, the file will only be
	created if the user writes to the file via the editor. Simply
	running visudo and exiting the editor will no longer cause the file
	to be created. There is an exception for file created due to the
	addition of a @include directive, which need to be present for the
	sudoers file to parse properly. GitHub issue #294.
	[bdde6dfa1]

	* plugins/sudoers/visudo.c:
	visudo: do not create a new file if the user made no changes

	This prevents visudo from creating a new zero-length sudoers file if
	the user exited the editor without making any changes. Files created
	via a @include directive are preserved, even if empty, to avoid a
	parse error. GitHub issue #294.
	[4f3786f70]

	* README.md, docs/CONTRIBUTING.md:
	Make the sections on bug reporting consistent with each other.

	GitHub issue #292
	[50fde5d81]

2023-07-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec.c:
	Remove unused variable introduced in last commit.
	[857653f9f]

	* src/exec.c, src/exec_nopty.c, src/exec_pty.c, src/sudo_exec.h:
	Don't assume that if std{in,out,err} is a tty, it is the user's tty.

	Previously, sudo only checked that the fd was a terminal, not that
	it matched sudo's idea of the user's terminal. This matters when
	input or output is redirected to a different terminal. In that case
	we want to interpose the fd with a pipe even if it refers to a
	terminal. Bug #1056.
	[760c9c110]

	* MANIFEST, plugins/sudoers/regress/testsudoers/test29.out.ok,
	plugins/sudoers/regress/testsudoers/test29.sh,
	plugins/sudoers/regress/testsudoers/test30.out.ok,
	plugins/sudoers/regress/testsudoers/test30.sh,
	plugins/sudoers/regress/testsudoers/test31.out.ok,
	plugins/sudoers/regress/testsudoers/test31.sh:
	testsudoers: add -L, -l and -v tests
	[14f1a12e2]

	* plugins/sudoers/regress/testsudoers/test1.out.ok,
	plugins/sudoers/regress/testsudoers/test10.out.ok,
	plugins/sudoers/regress/testsudoers/test11.out.ok,
	plugins/sudoers/regress/testsudoers/test15.out.ok,
	plugins/sudoers/regress/testsudoers/test16.out.ok,
	plugins/sudoers/regress/testsudoers/test17.out.ok,
	plugins/sudoers/regress/testsudoers/test18.out.ok,
	plugins/sudoers/regress/testsudoers/test19.out.ok,
	plugins/sudoers/regress/testsudoers/test2.out.ok,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/regress/testsudoers/test21.out.ok,
	plugins/sudoers/regress/testsudoers/test22.out.ok,
	plugins/sudoers/regress/testsudoers/test23.out.ok,
	plugins/sudoers/regress/testsudoers/test24.out.ok,
	plugins/sudoers/regress/testsudoers/test25.out.ok,
	plugins/sudoers/regress/testsudoers/test26.out.ok,
	plugins/sudoers/regress/testsudoers/test27.out.ok,
	plugins/sudoers/regress/testsudoers/test28.out.ok,
	plugins/sudoers/regress/testsudoers/test3.out.ok,
	plugins/sudoers/regress/testsudoers/test4.out.ok,
	plugins/sudoers/regress/testsudoers/test5.out.ok,
	plugins/sudoers/regress/testsudoers/test6.out.ok,
	plugins/sudoers/regress/testsudoers/test7.out.ok,
	plugins/sudoers/regress/testsudoers/test8.out.ok,
	plugins/sudoers/regress/testsudoers/test9.out.ok,
	plugins/sudoers/testsudoers.c:
	testsudoers: display when a password is required
	[d62d704e5]

	* plugins/sudoers/testsudoers.c:
	testsudoers: add -L, -l and -v options.

	This makes it possible to test "sudo -l" and "sudo -v" using
	testsudoers.
	[75256516b]

2023-07-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/lookup.c:
	sudoers_lookup_pseudo: sync with sudoers_lookup_check

	This makes sudoers_lookup_pseudo(), which is used for pseudo-command
	like "list" and "validate" a bit more like sudoers_lookup_check().
	Time of day checks are performed, and callbacks are supported. We
	cannot use the same code for regular commands and pseudo-commands
	due to the "pwcheck == all" case.
	[538be58ac]

	* plugins/sudoers/logging.c:
	Fix user warning message for "sudo -l command" when not allowed.
	Reported by the sudo-rs project.

	There was a missing space between "list" and the actual command.
	This also changes the output to include the command as specified by
	the user, not the path found in the path. Previously, if the command
	did not exist it would not be included in the message.
	[d486db46c]

	* plugins/python/python_convmessage.c,
	plugins/python/python_loghandler.c,
	plugins/python/python_plugin_common.c,
	plugins/python/sudo_python_module.c,
	plugins/python/sudo_python_module.h:
	Add free function for sudo Python module.

	This reduces the amount of memory leaked on unload.
	[1a00423af]

2023-07-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_14p3 for changeset 6902151970b6
	[efc6ab429]

	* configure, configure.ac:
	sudo 1.9.14p3
	[a06cbb8ef]

	* NEWS:
	Document bug fixes in 1.9.14p3.
	[e59c48743]

	* NEWS:
	Document bug fixes in 1.9.14p3.
	[01702afcf]

	* plugins/python/python_loghandler.c,
	plugins/python/python_plugin_common.c,
	plugins/python/sudo_python_module.c,
	plugins/python/sudo_python_module.h:
	Merge sudo_module_register_loghandler and
	sudo_module_set_default_loghandler.

	We now create the LogHandler class for each interpreter in
	python_plugin_init() instead of just once in sudo_module_init().
	This fixes the crash seen in Py_EndInterpreter() with Python 3.12
	and significantly reduces the number of leaked objects tracked by
	MemorySanitizer.
	[09b963269]

	* plugins/python/python_convmessage.c:
	sudo_module_register_conv_message: fix copy pasta in debug_decl
	[56b829f66]

2023-07-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_baseplugin.c,
	plugins/python/python_convmessage.c,
	plugins/python/python_loghandler.c,
	plugins/python/sudo_python_module.c:
	sudo_module_register_loghandler: clear sudo_type_LogHandler on error
	Also add comments about PyModule_AddObject stealing a ref on
	success.
	[0462a4ee8]

	* plugins/python/pyhelpers.c:
	Use Py_XDECREF instead of manual NULL check + Py_DECREF
	[b52c32f23]

2023-07-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_loghandler.c:
	Work around a crash with Python 3.12.

	In sudo_module_set_default_loghandler() if we don't leak the
	reference to py_loghandler we get a crash in Py_EndInterpreter()
	with Python 3.12. This probably indicates a reference counting bug
	elsewhere.
	[4e6254fea]

	* plugins/python/regress/check_python_examples.c:
	Unbuffer stdout so we don't miss output during a crash.
	[91ea59945]

	* plugins/python/python_loghandler.c:
	Use PyObject_CallNoArgs() where possible.
	[8c4cec148]

	* plugins/python/python_convmessage.c,
	plugins/python/python_loghandler.c,
	plugins/python/sudo_python_module.h:
	Make sudo_type_ConvMessage and sudo_type_LogHandler static.

	They are not used outside their respective compilation units.
	[ba5ef624f]

2023-07-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/eventlog/Makefile.in, lib/iolog/Makefile.in,
	lib/util/Makefile.in, plugins/python/Makefile.in,
	plugins/sudoers/Makefile.in:
	Pass TEST_VERBOSE to all test programs.
	[432ac1212]

	* lib/iolog/regress/host_port/host_port_test.c,
	plugins/sudoers/regress/check_symbols/check_symbols.c,
	plugins/sudoers/regress/editor/check_editor.c,
	plugins/sudoers/regress/env_match/check_env_pattern.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/regress/parser/check_addr.c,
	plugins/sudoers/regress/parser/check_base64.c,
	plugins/sudoers/regress/parser/check_digest.c,
	plugins/sudoers/regress/parser/check_fill.c,
	plugins/sudoers/regress/parser/check_gentime.c,
	plugins/sudoers/regress/serialize_list/check_serialize_list.c,
	plugins/sudoers/regress/starttime/check_starttime.c,
	plugins/sudoers/regress/unescape/check_unesc.c:
	All test programs should accept the -v option, even if it is
	ignored.
	[7499b2d27]

	* plugins/python/python_plugin_common.c:
	Revert last change, wrong diff committed.
	[e710f7942]

2023-07-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_plugin_common.c:
	We can rely on Py_FinalizeEx() to free sub-interpreters.
	[a12dbfe90]

2023-07-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/regress/testhelpers.c:
	Adapt to changed formatting of a rejected result in Python 3.12
	[2cb483578]

	* plugins/python/example_audit_plugin.py,
	plugins/python/pyhelpers.c,
	plugins/python/regress/testdata/check_example_audit_plugin_receives_
	accept.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_receives_
	error.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_receives_
	reject.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_version_d
	isplay.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_workflow_
	multiple.stdout,
	plugins/python/regress/testdata/check_example_debugging_c_calls@diag
	.log,
	plugins/python/regress/testdata/check_example_debugging_c_calls@info
	.log,
	plugins/python/regress/testdata/check_example_group_plugin_is_able_t
	o_debug.log,
	plugins/python/regress/testdata/check_example_policy_plugin_validate
	_invalidate.log:
	Remove trailing whitespace from test output.
	[adaba9c0f]

	* plugins/python/python_plugin_common.c:
	_python_plugin_new_interpreter switches to the new interpreter

	No need to do PyThreadState_Swap in the caller.
	[7a10cdc28]

2023-07-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_plugin_common.c:
	Call PyImport_AppendInittab after pre-initialization.

	Also remove redundant PyConfig settings.
	[cc939297a]

2023-07-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_plugin_common.c:
	Use Py_InitializeFromConfig() not Py_InitializeEx() for Python >=
	3.8.

	Avoids deprecation warnings on Python 3.12.
	[da60384ad]

	* NEWS:
	The sudoers option is "use_pty", not "log_pty"

	GitHub issue #291
	[7facc380a]

2023-07-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_loghandler.c,
	plugins/python/python_plugin_common.c,
	plugins/python/sudo_python_module.c,
	plugins/python/sudo_python_module.h:
	Merge sudo_module_register_loghandler and
	sudo_module_set_default_loghandler.

	We now create the LogHandler class for each interpreter in
	python_plugin_init() instead of just once in sudo_module_init().
	This fixes the crash seen in Py_EndInterpreter() with Python 3.12
	and significantly reduces the number of leaked objects tracked by
	MemorySanitizer.
	[aa7f77edd]

2023-07-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_baseplugin.c,
	plugins/python/python_convmessage.c,
	plugins/python/python_loghandler.c,
	plugins/python/sudo_python_module.c:
	sudo_module_register_loghandler: clear sudo_type_LogHandler on error
	Also add comments about PyModule_AddObject stealing a ref on
	success.
	[32ac7d4d6]

2023-07-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_loghandler.c:
	Work around a crash with Python 3.12.

	In sudo_module_set_default_loghandler() if we don't leak the
	reference to py_loghandler we get a crash in Py_EndInterpreter()
	with Python 3.12. This probably indicates a reference counting bug
	elsewhere.
	[2b0643f6a]

	* plugins/python/python_loghandler.c:
	Use PyObject_CallNoArgs() where possible.
	[28b05ea8f]

	* plugins/python/python_convmessage.c,
	plugins/python/python_loghandler.c,
	plugins/python/sudo_python_module.h:
	Make sudo_type_ConvMessage and sudo_type_LogHandler static.

	They are not used outside their respective compilation units.
	[114343142]

2023-07-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/regress/testhelpers.c:
	Adapt to changed formatting of a rejected result in Python 3.12
	[46159d284]

	* plugins/python/example_audit_plugin.py,
	plugins/python/pyhelpers.c,
	plugins/python/regress/testdata/check_example_audit_plugin_receives_
	accept.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_receives_
	error.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_receives_
	reject.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_version_d
	isplay.stdout,
	plugins/python/regress/testdata/check_example_audit_plugin_workflow_
	multiple.stdout,
	plugins/python/regress/testdata/check_example_debugging_c_calls@diag
	.log,
	plugins/python/regress/testdata/check_example_debugging_c_calls@info
	.log,
	plugins/python/regress/testdata/check_example_group_plugin_is_able_t
	o_debug.log,
	plugins/python/regress/testdata/check_example_policy_plugin_validate
	_invalidate.log:
	Remove trailing whitespace from test output.
	[58cd8e230]

2023-07-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/python_plugin_common.c:
	Use Py_InitializeFromConfig() not Py_InitializeEx() for Python >=
	3.8.

	Avoids deprecation warnings on Python 3.12.
	[8aeb76f7f]

	* NEWS:
	The sudoers option is "use_pty", not "log_pty"

	GitHub issue #291
	[0efdd7632]

2023-07-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/term.c:
	Quiet a warning false positive with older versions of gcc.
	[4b5480cf7]

	* plugins/sudoers/sudoers.c:
	sudoers_check_common: MODE_PRESERVE_ENV is not valid with
	MODE_CHECK.

	We should only check for MODE_PRESERVE_ENV when running a command.
	[fa66c1668]

2023-07-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_14p2 for changeset 47c0bf9a7ebb
	[5a6f0d5b1]

	* configure, configure.ac:
	sudo 1.9.14p2
	[2a3b848e4]

2023-07-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Document bug fixes in 1.9.14p2.
	[c29a27e84]

2023-07-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/match.c,
	plugins/sudoers/regress/testsudoers/test28.out.ok,
	plugins/sudoers/regress/testsudoers/test28.sh:
	runas_userlist_matches: fix matching a Runas_Spec with an empty
	runas user.

	We should only match a rule with an empty runas user if a group was
	specified on the command line (sudo -g) without a user (no -u
	option) or the user specified their own name on the command line.
	GitHub issue #290
	[db704c22e]

2023-07-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Document bug fixes in 1.9.14p2.
	[181b639fb]

2023-07-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match.c:
	runas_userlist_matches: fix matching a Runas_Spec with an empty
	runas user.

	We should only match a rule with an empty runas user if a group was
	specified on the command line (sudo -g) without a user (no -u
	option) or the user specified their own name on the command line.
	GitHub issue #290
	[23fc7abfa]

2023-07-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	Pass SUDO_TERM_OFLAG to sudo_term_raw() when sudo output is piped.

	This fixes a problem with "stair-stepped" output when the sudo-run
	command's output is piped to another program and the command reads
	input from the terminal.
	[78b712101]

	* src/exec_pty.c:
	Pass SUDO_TERM_OFLAG to sudo_term_raw() when sudo output is piped.

	This fixes a problem with "stair-stepped" output when the sudo-run
	command's output is piped to another program and the command reads
	input from the terminal.
	[d821e8da3]

	* src/exec_monitor.c, src/exec_pty.c:
	Simplify the exec_monitor() foreground flag.

	Add cmnd_foreground flag that is only true if sudo is the foreground
	process and the CD_EXEC_BG flag is not set and pass it to
	exec_monitor(). This means exec_monitor() no longer needs to check
	for CD_EXEC_BG.
	[db4bdb732]

	* src/exec_monitor.c, src/exec_pty.c:
	Simplify the exec_monitor() foreground flag.

	Add cmnd_foreground flag that is only true if sudo is the foreground
	process and the CD_EXEC_BG flag is not set and pass it to
	exec_monitor(). This means exec_monitor() no longer needs to check
	for CD_EXEC_BG.
	[9cdebcf90]

	* include/sudo_util.h, lib/util/term.c,
	plugins/sudoers/sudoreplay.c:
	sudo_term_raw: change the isig argument into a flags field

	There are current two flags: SUDO_TERM_ISIG (enable terminal
	signals) and SUDO_TERM_OFLAG (preserve output flags).
	[625653de0]

	* include/sudo_util.h, lib/util/term.c,
	plugins/sudoers/sudoreplay.c:
	sudo_term_raw: change the isig argument into a flags field

	There are current two flags: SUDO_TERM_ISIG (enable terminal
	signals) and SUDO_TERM_OFLAG (preserve output flags).
	[77f209e14]

2023-07-12  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_ptrace.c:
	Fix a crash in intercept mode running a command with NULL argv[0].

	Newer Linux kernels replace a NULL argv[0] with the empty string, we
	should as well.
	[ff6ddff39]

	* src/exec_ptrace.c:
	Fix a crash in intercept mode running a command with NULL argv[0].

	Newer Linux kernels replace a NULL argv[0] with the empty string, we
	should as well.
	[24cc3f4c9]

	* src/conversation.c:
	sudo_conversation_printf: simplify \n -> \r\n handling
	[b47f1799c]

	* src/conversation.c:
	sudo_conversation: zero out reply even if no password is requested.

	This avoids a potential invalid free in the err label and provides
	more predictable behavior when mixing message types in a
	conversation.
	[a014b0f2a]

2023-07-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_14p1 for changeset fc033946b1a9
	[8f3b92ee8]

	* configure, configure.ac:
	sudo 1.9.14p1
	[e1b4d21a2]

	* NEWS:
	Docume bug fixes in 1.9.14p1.
	[9afb1851b]

	* NEWS:
	Docume bug fixes in 1.9.14p1.
	[696094c0e]

	* plugins/sudoers/log_client.c:
	fmt_info_messages: don't include ttyname if it is NULL

	The NULL check was commented out for testing but should have been
	restored. Fixes a potential protocol error message from
	sudo_logsrvd.
	[56828f641]

	* plugins/sudoers/log_client.c:
	fmt_info_messages: don't include ttyname if it is NULL

	The NULL check was commented out for testing but should have been
	restored. Fixes a potential protocol error message from
	sudo_logsrvd.
	[ff5f68f2e]

	* logsrvd/iolog_writer.c:
	evlog_new: store a new copy of peeraddr, not a pointer to a buffer.

	Starting in sudo 1.9.14, eventlog_free() will free the peeraddr
	member too so it needs to be dynamically allocated.
	[2eee45ef9]

	* logsrvd/iolog_writer.c:
	evlog_new: store a new copy of peeraddr, not a pointer to a buffer.

	Starting in sudo 1.9.14, eventlog_free() will free the peeraddr
	member too so it needs to be dynamically allocated.
	[ac830c558]

2023-07-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* config.h.in, configure, configure.ac, include/sudo_compat.h,
	lib/util/realpath.c:
	realpath.c: include limits.h and use sysconf(_SC_SYMLOOP_MAX)

	This is more portable and eliminates the need to check for
	SYMLOOP_MAX (and provide it if missing) in configure. Also quiet
	some -Wconversion warnings.
	[a432aed4f]

	* plugins/sudoers/ldap_conf.c:
	sudo_krb5_ccname_path: avoid gcc false positive for ccname being
	NULL

	The callers all verify that they don't pass a NULL ccname so I'm not
	sure how the compiler is getting confused (and why now?).
	[dc1a5d7b4]

	* include/sudo_debug.h:
	Work around unused variable warning when fuzzing in enabled.
	[c6a11b4fe]

	* plugins/sudoers/check_util.c,
	plugins/sudoers/regress/testsudoers/test25.out.ok,
	plugins/sudoers/regress/testsudoers/test25.sh,
	plugins/sudoers/regress/testsudoers/test26.out.ok,
	plugins/sudoers/regress/testsudoers/test26.sh:
	Only allow the user to specify -D or -R for the special "*" value.

	The sudoers file must now explicitly allow the user to specify a
	directory (sudo -D) or chroot (sudo -R) by setting cwd or chroot to
	"*". If a specific cwd or chroot value is set in sudoers, the user
	may not use the -D or -R options, even if they match the value in
	sudoers.
	[d1625f9c8]

	* docs/sudo_plugin.man.in, docs/sudo_plugin.mdoc.in:
	Add restrict keyword to sudo_printf_t in plugin docs.
	[44cfa9e13]

	* include/sudo_debug.h, lib/util/sudo_debug.c:
	Convert sudo_debug_enter and sudo_debug_exit into macros.

	In most cases, these simply expand to a call to
	sudo_debug_printf2(). We need to keep the function versions around
	in libsudo_util for backwards compatibility.
	[db6baf2ca]

	* lib/util/sudo_debug.c:
	Fix sudo_debug_exit_uint_v1 declaration for fuzzers.
	[2d12a4194]

	* lib/util/sudo_debug.c:
	Add missing sudo_debug_exit_uint_v1 stub for fuzzers.
	[eff4e1c0c]

	* src/conversation.c, src/edit_open.c, src/exec_common.c,
	src/parse_args.c, src/selinux.c, src/sesh.c, src/sudo.c, src/sudo.h,
	src/sudo_edit.h, src/sudo_exec.h, src/tgetpass.c:
	sudo frontend: make more bit flags unsigned.
	[dbb95ad21]

	* plugins/sudoers/auth/API, plugins/sudoers/auth/sudo_auth.c,
	plugins/sudoers/auth/sudo_auth.h, plugins/sudoers/check.c,
	plugins/sudoers/check.h, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers.h, plugins/sudoers/logging.c,
	plugins/sudoers/logging.h, plugins/sudoers/lookup.c,
	plugins/sudoers/parse.h, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c:
	sudoers plugin: make more bit flags unsigned.
	[cbcb1d250]

	* include/sudo_debug.h, include/sudo_event.h, lib/util/event.c,
	lib/util/event_poll.c, lib/util/event_select.c,
	lib/util/sudo_debug.c, lib/util/util.exp.in:
	libsudo_util: make more bit flags unsigned.
	[4f097eebd]

2023-07-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/timeout.c:
	parse_timeout: move overflow check to the correct location

	It was not covering all cases in its original location. Fixes
	oss-fuzz issue 60454 with fuzz_sudoers.
	[9f7128fe8]

2023-07-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #287 from AtariDreams/restrict

	Give every printf-like function restrict qualifiers
	[fc02df111]

2023-07-07  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* include/sudo_compat.h, include/sudo_debug.h, include/sudo_fatal.h,
	include/sudo_lbuf.h, include/sudo_plugin.h, include/sudo_util.h,
	lib/eventlog/logwrap.c, lib/util/fatal.c, lib/util/inet_ntop.c,
	lib/util/lbuf.c, lib/util/snprintf.c, lib/util/strlcat.c,
	lib/util/strlcpy.c, lib/util/sudo_debug.c, lib/util/ttyname_dev.c,
	logsrvd/iolog_writer.c, logsrvd/logsrvd_journal.c,
	plugins/audit_json/audit_json.c, plugins/group_file/plugin_test.c,
	plugins/python/pyhelpers.c, plugins/python/regress/iohelpers.c,
	plugins/python/regress/iohelpers.h,
	plugins/python/regress/testhelpers.c,
	plugins/python/regress/testhelpers.h, plugins/sudoers/audit.c,
	plugins/sudoers/check_aliases.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers.h, plugins/sudoers/cvtsudoers_csv.c,
	plugins/sudoers/defaults.c, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/ldap_util.c,
	plugins/sudoers/logging.c, plugins/sudoers/logging.h,
	plugins/sudoers/parse.h, plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/sudo_ldap.h, plugins/sudoers/sudo_printf.c,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c,
	src/conversation.c, src/exec_preload.c, src/parse_args.c,
	src/sudo_plugin_int.h:
	Give every printf-like function restrict qualifiers

	The format value has to be a string literal, every time.

	Otherwise, you are not using these functions correctly. To reinforce
	this fact, I putrestrict over every non-contrib example of this I
	could find.
	[5d758264a]

2023-07-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_nopty.c, src/exec_pty.c, src/sudo_exec.h:
	struct exec_closure: make rows and cols int, not short

	There's no real space saved by using short and using int avoids a
	few casts.
	[92860c717]

	* plugins/sudoers/testsudoers.c:
	testsudoers: avoid extern definitions where possible
	[548e3e312]

	* plugins/sample/sample_plugin.c, src/conversation.c,
	src/copy_file.c, src/env_hooks.c, src/exec.c, src/exec_common.c,
	src/exec_intercept.c, src/exec_monitor.c, src/exec_nopty.c,
	src/exec_preload.c, src/exec_ptrace.c, src/exec_pty.c,
	src/net_ifs.c, src/parse_args.c, src/preserve_fds.c, src/sudo.c,
	src/sudo.h, src/sudo_edit.c, src/sudo_exec.h, src/sudo_intercept.c,
	src/sudo_intercept_common.c, src/tgetpass.c, src/ttyname.c:
	sudo frontend: silence most -Wconversion warnings.
	[32f4b98f6]

	* plugins/python/pyhelpers.c, plugins/python/python_convmessage.c,
	plugins/python/regress/iohelpers.c,
	plugins/python/regress/testhelpers.c,
	plugins/python/sudo_python_module.c:
	python plugin: silence -Wconversion warnings.
	[0c85f10c8]

	* plugins/sudoers/alias.c, plugins/sudoers/auth/pam.c,
	plugins/sudoers/auth/sudo_auth.c, plugins/sudoers/b64_encode.c,
	plugins/sudoers/check_aliases.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers.h, plugins/sudoers/cvtsudoers_csv.c,
	plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/cvtsudoers_ldif.c,
	plugins/sudoers/cvtsudoers_merge.c,
	plugins/sudoers/cvtsudoers_pwutil.c, plugins/sudoers/defaults.c,
	plugins/sudoers/defaults.h, plugins/sudoers/display.c,
	plugins/sudoers/editor.c, plugins/sudoers/env.c,
	plugins/sudoers/filedigest.c, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/fmtsudoers_cvt.c, plugins/sudoers/getdate.c,
	plugins/sudoers/getdate.y, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/group_plugin.c,
	plugins/sudoers/iolog.c, plugins/sudoers/iolog_path_escapes.c,
	plugins/sudoers/ldap.c, plugins/sudoers/ldap_conf.c,
	plugins/sudoers/ldap_innetgr.c, plugins/sudoers/ldap_util.c,
	plugins/sudoers/linux_audit.c, plugins/sudoers/log_client.c,
	plugins/sudoers/logging.c, plugins/sudoers/match_addr.c,
	plugins/sudoers/match_command.c, plugins/sudoers/parse.h,
	plugins/sudoers/parse_ldif.c, plugins/sudoers/policy.c,
	plugins/sudoers/pwutil.c, plugins/sudoers/pwutil_impl.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/parser/check_addr.c,
	plugins/sudoers/regress/parser/check_fill.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/sssd.c,
	plugins/sudoers/starttime.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoreplay.c, plugins/sudoers/testsudoers.c,
	plugins/sudoers/timeout.c, plugins/sudoers/timestamp.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.h,
	plugins/sudoers/toke.l, plugins/sudoers/toke_util.c,
	plugins/sudoers/tsgetgrpw.c, plugins/sudoers/visudo.c:
	sudoers plugin: silence most -Wconversion warnings.
	[a38b71466]

	* logsrvd/iolog_writer.c, logsrvd/logsrv_util.c, logsrvd/logsrvd.c,
	logsrvd/logsrvd_conf.c, logsrvd/logsrvd_journal.c,
	logsrvd/logsrvd_local.c, logsrvd/logsrvd_queue.c,
	logsrvd/logsrvd_relay.c, logsrvd/regress/fuzz/fuzz_logsrvd_conf.c,
	logsrvd/sendlog.c:
	sudo_logsrvd: silence most -Wconversion warnings.
	[4891f37a4]

	* include/sudo_iolog.h, lib/iolog/hostcheck.c,
	lib/iolog/iolog_filter.c, lib/iolog/iolog_legacy.c,
	lib/iolog/iolog_mkdirs.c, lib/iolog/iolog_mkdtemp.c,
	lib/iolog/iolog_read.c, lib/iolog/iolog_timing.c,
	lib/iolog/iolog_write.c,
	lib/iolog/regress/iolog_path/check_iolog_path.c,
	lib/iolog/regress/iolog_timing/check_iolog_timing.c:
	libiolog: silence -Wconversion warnings.
	[6734a99f8]

	* lib/fuzzstub/fuzzstub.c:
	libfuzzstub: silence -Wconversion warnings.
	[e93913e2b]

	* include/sudo_eventlog.h, lib/eventlog/eventlog.c,
	lib/eventlog/eventlog_conf.c, lib/eventlog/logwrap.c,
	lib/eventlog/parse_json.c,
	lib/eventlog/regress/eventlog_store/store_json_test.c,
	lib/eventlog/regress/eventlog_store/store_sudo_test.c,
	lib/eventlog/regress/logwrap/check_wrap.c,
	lib/eventlog/regress/parse_json/check_parse_json.c:
	libevent: silence -Wconversion warnings.
	[c95423a8f]

	* include/sudo_json.h, include/sudo_lbuf.h, lib/util/closefrom.c,
	lib/util/digest.c, lib/util/event_poll.c, lib/util/fatal.c,
	lib/util/getentropy.c, lib/util/getgrouplist.c, lib/util/gidlist.c,
	lib/util/json.c, lib/util/lbuf.c, lib/util/mkdir_parents.c,
	lib/util/parseln.c, lib/util/regex.c,
	lib/util/regress/fuzz/fuzz_sudo_conf.c,
	lib/util/regress/hexchar/hexchar_test.c,
	lib/util/regress/mktemp/mktemp_test.c,
	lib/util/regress/strtofoo/strtoid_test.c, lib/util/secure_path.c,
	lib/util/setgroups.c, lib/util/sig2str.c, lib/util/str2sig.c,
	lib/util/strlcat.c, lib/util/strlcpy.c, lib/util/strtoid.c,
	lib/util/strtonum.c, lib/util/sudo_conf.c, lib/util/sudo_debug.c,
	lib/util/ttysize.c:
	libsudo_util: silence most -Wconversion warnings.
	[5768d374c]

	* config.h.in, configure, configure.ac:
	Add configure check for restrict keyword.
	[f7801f216]

	* plugins/sudoers/sudoers.c:
	sudoers_check_common: remove extraneous return statement.
	[0205f6fc7]

2023-07-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_digest.h, lib/util/digest.c,
	lib/util/digest_gcrypt.c, lib/util/digest_openssl.c,
	lib/util/regress/digest/digest_test.c:
	Make the remaining instances of digest_type unsigned.
	[bced0a778]

2023-07-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/iolog_path_escapes.c:
	Copy, don't append group ID in fill_group() and fill_runas_group()

	This only affects the case where a group ID cannot be resolved.
	[43e914a5d]

	* lib/iolog/Makefile.in:
	Remove regress corpus directories correctly
	[17c09dfd2]

	* include/sudo_debug.h, include/sudo_util.h, lib/util/strtomode.c,
	lib/util/sudo_debug.c, lib/util/util.exp.in:
	Change sudo_strtomode() to return mode_t.
	[2d1b3c369]

2023-07-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/sudoreplay.c:
	Rename print_usage() to display_usage()
	[2848dddd8]

	* logsrvd/logsrvd.c, logsrvd/sendlog.c:
	Move display of usage text into display_usage() so usage() always
	exits.
	[f6d154241]

	* lib/util/parseln.c, logsrvd/logsrvd_journal.c:
	Fix some indentation.
	[1f0f6b7c7]

	* plugins/sudoers/Makefile.in, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers.h, plugins/sudoers/testsudoers.c:
	Include testsudoers_pwutil.h for testsudoers_pwutil.c prototypes.
	[fd061e4d6]

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/pwutil_impl.c, plugins/sudoers/testsudoers_pwutil.c,
	plugins/sudoers/testsudoers_pwutil.h, plugins/sudoers/tsgetgrpw.c,
	plugins/sudoers/tsgetgrpw.h:
	Fix wrapping of libc getpwnam/getpwuid/getgrnam/getgrgid on NetBSD.
	[f1d906347]

	* MANIFEST, aclocal.m4, config.h.in, configure, configure.ac,
	lib/util/roundup.c, m4/ax_gcc_builtin.m4:
	Add configure tests for __builtin_clz/__builtin_clzl
	[bfb6132d9]

	* lib/util/roundup.c:
	Add fallback for compilers without __builtin_clz/__builtin_clzl
	[0f69939d7]

	* lib/util/roundup.c:
	sudo_pow2_roundup: fix 64-bit version when shifting 31 or more
	places

	Shift 1UL instead of 1 to avoid overflowing an int.
	[3a7ca0a83]

	* :
	Merge pull request #286 from AtariDreams/one-more

	Optimize sudo_pow2_roundup_v1
	[d900e7a93]

2023-07-03  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/roundup.c:
	Optimize sudo_pow2_roundup_v1

	No need to call sudo_pow2_roundup_v2.
	[8c3e4a33c]

2023-07-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #285 from AtariDreams/bug

	Remove comment about algorithm being from bit-twiddling hacks
	[fa69ee5e1]

2023-07-03  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/roundup.c:
	Remove comment about algorithm being from bit-twiddling hacks

	Said comment no longer applies.
	[76d7aefb3]

2023-07-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #284 from AtariDreams/fix

	Fix fuzzing errors
	[f884514b3]

2023-07-03  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/parseln.c, lib/util/roundup.c, logsrvd/logsrvd_journal.c:
	Fix fuzzing errors

	We should be checking for integer overflow, rather than checking if
	size is 0.

	Additionally, we should set errno to ENOMEM when this overflow
	happens.

	Finally, the most efficient implementation of the round-up-to-2
	algorithm involves the clz intrinsic.
	[732110428]

2023-07-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #283 from AtariDreams/bug

	Fixed even more signedness and conversion issues
	[9266966ab]

2023-07-03  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/timestamp.c, plugins/sudoers/tsgetgrpw.c,
	src/sudo.c:
	Fixed even more signedness and conversion issues

	This should be the last of them.
	[cbed9daa4]

2023-07-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/lbuf.c:
	sudo_lbuf_expand: limit allocation to UINT_MAX
	[f5eb1e055]

	* lib/util/parseln.c:
	sudo_parseln: use sudo_pow2_roundup() instead of hand-rolling it.
	[d3dc70ab6]

	* logsrvd/logsrv_util.c, logsrvd/logsrv_util.h, logsrvd/logsrvd.c,
	logsrvd/logsrvd_relay.c, logsrvd/sendlog.c,
	plugins/sudoers/log_client.c, plugins/sudoers/log_client.h:
	Promote length/size/offset in struct connection_buffer to size_t.
	[e95bd883d]

	* include/sudo_util.h, lib/util/lbuf.c, lib/util/roundup.c,
	lib/util/util.exp.in, logsrvd/logsrv_util.c, logsrvd/logsrvd.c,
	plugins/sudoers/log_client.c:
	Make sudo_pow2_roundup() operate on size_t.
	[56a431f7e]

2023-07-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_debug.h, lib/util/sudo_debug.c,
	plugins/python/pyhelpers.c, plugins/python/pyhelpers.h,
	plugins/python/python_loghandler.c,
	plugins/python/sudo_python_debug.c,
	plugins/python/sudo_python_debug.h:
	Make the debug subsystem unsigned.

	It was already unsigned in sudoers but not in the front-end or the
	python plugin. Making this consistent resolves a lot of -Wconversion
	warnings. Also clean up some other -Wconversion warnings in
	sudo_debug.c.
	[b926df1df]

	* lib/eventlog/eventlog.c,
	lib/eventlog/regress/eventlog_store/store_json_test.c,
	lib/eventlog/regress/eventlog_store/store_sudo_test.c,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c,
	src/exec_monitor.c, src/sudo.c:
	Fix up indentation.
	[04c7e910e]

	* :
	Merge pull request #280 from AtariDreams/bug

	Mark functions not returning as sudo_noreturn
	[575e4ab2f]

2023-07-01  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/eventlog/eventlog.c,
	lib/eventlog/regress/eventlog_store/store_json_test.c,
	lib/eventlog/regress/eventlog_store/store_sudo_test.c,
	lib/eventlog/regress/logwrap/check_wrap.c,
	lib/eventlog/regress/parse_json/check_parse_json.c,
	lib/iolog/regress/iolog_path/check_iolog_path.c,
	lib/util/regress/hexchar/hexchar_test.c,
	lib/util/regress/strsplit/strsplit_test.c,
	lib/util/regress/sudo_conf/conf_test.c, logsrvd/logsrvd.c,
	logsrvd/regress/logsrvd_conf/logsrvd_conf_test.c, logsrvd/sendlog.c,
	plugins/group_file/plugin_test.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/regress/check_symbols/check_symbols.c,
	plugins/sudoers/regress/iolog_plugin/check_iolog_plugin.c,
	plugins/sudoers/regress/parser/check_addr.c,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c,
	src/exec_monitor.c, src/exec_nopty.c, src/exec_pty.c, src/sesh.c,
	src/sudo.c:
	Mark functions not returning as sudo_noreturn

	We also put NOTREACHED where it applies.
	[45fdfa18f]

2023-07-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/toke.c, plugins/sudoers/toke.l, src/limits.c:
	Avoid passing debug_return_size_t() a negative number.
	[97e574091]

	* :
	Merge pull request #279 from AtariDreams/bison

	Regenerate toke.c using updated flex
	[2a4939a1c]

2023-06-29  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	Regenerate toke.c using updated flex

	Use the current version of flex to generate toke.c
	[6ea68d208]

2023-06-30  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/testsudoers.c:
	Fix a few memory leaks in the tests.
	[5fbf431c4]

	* MANIFEST, plugins/sudoers/regress/testsudoers/group,
	plugins/sudoers/regress/testsudoers/passwd,
	plugins/sudoers/regress/testsudoers/test27.out.ok,
	plugins/sudoers/regress/testsudoers/test27.sh,
	plugins/sudoers/testsudoers.c:
	Add test for runas_check_shell and check_user_shell()
	[ac9b6c94d]

	* MANIFEST, plugins/sudoers/Makefile.in,
	plugins/sudoers/regress/testsudoers/test25.out.ok,
	plugins/sudoers/regress/testsudoers/test25.sh,
	plugins/sudoers/regress/testsudoers/test26.out.ok,
	plugins/sudoers/regress/testsudoers/test26.sh,
	plugins/sudoers/testsudoers.c:
	testsudoers: add -D and -R options to set cwd and chroot like sudo
	[bdc8a7f35]

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/check.c,
	plugins/sudoers/check_util.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h:
	Move check_user_* functions to check_util.c so testsudoers can use
	them.
	[01ad570e2]

2023-06-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/testsudoers.c:
	testsudoers: make lbuf private to dump_sudoers()

	It is no longer used directly in main.
	[689efe3cd]

	* plugins/sudoers/regress/testsudoers/test11.out.ok,
	plugins/sudoers/regress/testsudoers/test4.out.ok,
	plugins/sudoers/regress/testsudoers/test5.out.ok,
	plugins/sudoers/testsudoers.c:
	testsudoers: display "Parse error" if there was a parse error.

	Previously, we just printed "Command unmatched" which makes it
	harder to see that an error occurred.
	[260c2fb83]

	* plugins/sudoers/regress/testsudoers/test1.out.ok,
	plugins/sudoers/regress/testsudoers/test10.out.ok,
	plugins/sudoers/regress/testsudoers/test15.out.ok,
	plugins/sudoers/regress/testsudoers/test16.out.ok,
	plugins/sudoers/regress/testsudoers/test17.out.ok,
	plugins/sudoers/regress/testsudoers/test18.out.ok,
	plugins/sudoers/regress/testsudoers/test19.out.ok,
	plugins/sudoers/regress/testsudoers/test2.out.ok,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/regress/testsudoers/test21.out.ok,
	plugins/sudoers/regress/testsudoers/test22.out.ok,
	plugins/sudoers/regress/testsudoers/test23.out.ok,
	plugins/sudoers/regress/testsudoers/test24.out.ok,
	plugins/sudoers/regress/testsudoers/test3.out.ok,
	plugins/sudoers/regress/testsudoers/test6.out.ok,
	plugins/sudoers/regress/testsudoers/test7.out.ok,
	plugins/sudoers/regress/testsudoers/test8.out.ok,
	plugins/sudoers/regress/testsudoers/test9.out.ok,
	plugins/sudoers/testsudoers.c:
	testsudoers: use allowed/denied/unmatched instead of just
	matched/unmatched

	This makes it possible to tell whether an entry was rejected due to
	a negative match (explicitly denied) as opposed to a non-match. Also
	fixes a bug where the runas status was only printed for positive
	matches.
	[6a21aec0a]

	* plugins/sudoers/Makefile.in,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/testsudoers.c:
	testsudoers: use sudoers_lookup() instead of a custom loop.
	[fd25bfc89]

	* plugins/sudoers/lookup.c, plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.c:
	Add callbacks to sudoers_lookup() so we can use it in testsudoers.

	Also pass in the time to be used for NOTBEFORE/NOTAFTER checks.
	[e025cca44]

	* :
	Merge pull request #278 from AtariDreams/types

	Avoid compiler casting warnings Part 2
	[41b82006d]

	* plugins/sudoers/sudoers.c:
	check_user_runcwd: only allow sudo's -D option if sudoers specifies
	a runcwd.

	Previously, the user could specify the runas user's home dir for
	"sudo -i" or the user's existing cwd when -i is not specified. This
	behavior was never documented and is inconsistent with how the -R
	option is handled.
	[1c7a20d74]

	* MANIFEST, plugins/sudoers/regress/testsudoers/test24.out.ok,
	plugins/sudoers/regress/testsudoers/test24.sh,
	plugins/sudoers/testsudoers.c:
	testsudoers: add support for NOTBEFORE and NOTAFTER

	Also adds -T option to set the value of "now".
	[2c1a473dd]

2023-05-18  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/util/mktemp.c, lib/util/regress/tailq/hltq_test.c,
	lib/util/sudo_debug.c, lib/util/ttyname_dev.c,
	plugins/group_file/plugin_test.c, plugins/sudoers/editor.c,
	plugins/sudoers/filedigest.c, plugins/sudoers/match_addr.c,
	plugins/sudoers/match_digest.c,
	plugins/sudoers/regress/env_match/check_env_pattern.c,
	plugins/sudoers/regress/exptilde/check_exptilde.c,
	plugins/sudoers/sudoreplay.c, plugins/sudoers/testsudoers.c,
	plugins/sudoers/tsdump.c, plugins/sudoers/visudo.c,
	src/exec_monitor.c, src/limits.c, src/sesh.c, src/sudo.c,
	src/sudo.h, src/sudo_edit.c:
	Avoid compiler casting warnings Part 2

	This saves instructions that are related to casting as well as
	compiler warnings.
	[22079c307]

2023-06-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/lookup.c:
	Rename parse.c -> lookup.c now that it only contains sudoers_lookup.
	[f2a274b06]

	* MANIFEST, plugins/sudoers/Makefile.in, plugins/sudoers/display.c,
	plugins/sudoers/parse.c, plugins/sudoers/parse.h:
	Split display_privs() and display_cmnd() out of parse.c into
	display.c
	[8b640329d]

	* lib/util/snprintf.c:
	No need to round up to page size with sudo_mmap_alloc().
	[1ba61cd13]

	* :
	Merge pull request #265 from AtariDreams/types

	Avoid compiler casting warnings by assigning to variables of the
	same type where possible
	[f437c66a2]

	* :
	Merge pull request #277 from AtariDreams/debug_return_int(1);

	We should be returning 0, not 1, when logservd finishes without
	errors
	[e0238ab21]

2023-06-28  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* logsrvd/logsrvd.c:
	We should be returning 0, not 1, when logservd finishes without
	errors

	1 is for failure, 0 is for no failure, and this does not look like a
	failure.
	[2c13d7130]

2023-05-18  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/eventlog/eventlog.c, lib/eventlog/eventlog_free.c,
	lib/eventlog/parse_json.c, lib/iolog/hostcheck.c,
	lib/iolog/regress/iolog_path/check_iolog_path.c, lib/util/event.c,
	lib/util/explicit_bzero.c, lib/util/fatal.c, lib/util/getaddrinfo.c,
	lib/util/getentropy.c, lib/util/hexchar.c, lib/util/inet_ntop.c,
	lib/util/json.c, lib/util/lbuf.c, lib/util/mksiglist.c,
	lib/util/mksigname.c, lib/util/multiarch.c, lib/util/progname.c,
	lib/util/sig2str.c, lib/util/snprintf.c, lib/util/sudo_conf.c,
	lib/util/term.c, lib/util/uuid.c, logsrvd/iolog_writer.c,
	logsrvd/logsrvd.c, logsrvd/sendlog.c,
	plugins/audit_json/audit_json.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers_pwutil.c, plugins/sudoers/editor.c,
	plugins/sudoers/getdate.c, plugins/sudoers/getdate.y,
	plugins/sudoers/iolog.c, plugins/sudoers/parse.c,
	plugins/sudoers/policy.c, plugins/sudoers/pwutil.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/starttime/check_starttime.c,
	plugins/sudoers/sssd.c, plugins/sudoers/sudoreplay.c,
	plugins/sudoers/timestr.c, plugins/sudoers/tsdump.c,
	plugins/sudoers/visudo.c, src/conversation.c, src/exec_monitor.c,
	src/limits.c, src/parse_args.c, src/sesh.c, src/sudo.c, src/sudo.h:
	Avoid compiler casting warnings by assigning to the same type where
	possible

	This saves instructions that are related to casting as well as
	compiler warnings.
	[e54ba33ea]

2023-06-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* config.h.in, configure, configure.ac, src/sudo_intercept.c,
	src/sudo_intercept_common.c:
	Fix undefined symbol on macOS for intercept mode and log_subcmds.

	macOS does not support direct access to the environ pointer from a
	shared object. We need to redirect through _NSGetEnviron() instead.
	Fixes GitHub issue #276.
	[a0b074cc9]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c:
	check_user_runcwd: allow -D option if it matches the cwd in sudoers

	Previously, check_user_runcwd() would return true if the runcwd
	matched the user's cwd, even if sudoers specified a different one.
	The user-specified runcwd was ignored but it is better to error out
	in this case. It is now also possible to use "sudo -D" with the
	directory specified in sudoers.
	[e7d4c05ac]

2023-06-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_14 for changeset 8010d7515347
	[8fe76f441]

	* :
	Merge sudo 1.9.14 from tip.
	[26f1789b3]

2023-06-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #275 from AtariDreams/emergency

	Set command_info to NULL once it is freed
	[a2a87323e]

2023-06-26  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* plugins/sudoers/policy.c:
	Set command_info to NULL once it is freed

	The lack of setting to NULL is a holdover from when command_info was
	a local variable and not a global one. However, we given how other
	global variables are set to NULL, it is best that we do the same
	here to avoid potential issues should sudoers_policy_store_result be
	called again after the first time failed, otherwise we could get a
	double-free.
	[0bb41ed82]

2023-06-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #274 from bin-ly/main

	Modify the is_script function for match_command.c
	[676066e2a]

2023-06-25  binlingyu  <binlingyu@uniontech.com>

	* plugins/sudoers/match_command.c:
	Modify the is_script function for match_command.c
	[f8a45e8a5]

2023-06-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS:
	Mention C99 requirement.
	[7fb98a9a3]

2023-06-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Reference SETENV-related settings in the command environment
	section.

	Based on GitHub PR #273 from Ilya Kulakov.
	[e0ee845df]

	* INSTALL.md:
	Sudo requires a C99 compiler due to the use of flexible array
	members.
	[733d5291b]

	* :
	Merge pull request #266 from AtariDreams/c99

	Do variable length arrays the C99 way
	[3bdd2214a]

2023-06-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #269 from trackers-lover/main

	correct the return value type of function alias_find_used
	[69b486d46]

2023-06-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	Clarify that use_pty is on by default starting with 1.9.14.
	[5d2b1761f]

	* docs/sudo.man.in, docs/sudo.mdoc.in:
	Sudo runs the command in a pty by default in 1.9.14 and above.
	[afb09e004]

	* plugins/sudoers/sudoers.in:
	Add commented out example for disabling use_pty.
	[4da1f373d]

2023-05-18  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* include/sudo_event.h, lib/util/event.c, lib/util/rcstr.c,
	plugins/sudoers/canon_path.c, plugins/sudoers/ldap_conf.c,
	plugins/sudoers/sudo_ldap_conf.h:
	Do variable length arrays the C99 way

	Variable length arrays are supported by C99, but having it denoted
	as "1" confused the compiler and is not defined.

	Note that because we don't get the inferred NULL terminator, we have
	to increase the malloc size by one.
	[7fd680c98]

2023-06-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .circleci/config.yml:
	Update Xcode version from 13.2.1 to 13.4.1.
	[64b666471]

2023-06-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST:
	Add plugins/sudoers/regress/testsudoers/passwd to MANIFEST.
	[dc49e11fa]

	* plugins/sudoers/po/eo.mo, plugins/sudoers/po/eo.po,
	plugins/sudoers/po/pl.mo, plugins/sudoers/po/pl.po, po/eo.mo,
	po/eo.po, po/pl.mo, po/pl.po:
	Updated translations from translationproject.org
	[c5c589da0]

	* NEWS:
	Document recent bug fixes.
	[4f9185f4c]

	* MANIFEST, plugins/sudoers/regress/testsudoers/group,
	plugins/sudoers/regress/testsudoers/passwd,
	plugins/sudoers/regress/testsudoers/test22.out.ok,
	plugins/sudoers/regress/testsudoers/test22.sh,
	plugins/sudoers/regress/testsudoers/test23.out.ok,
	plugins/sudoers/regress/testsudoers/test23.sh:
	Add tests to exercise recent runas user and group bug fixes.
	[baf482763]

	* MANIFEST, plugins/sudoers/regress/testsudoers/passwd,
	plugins/sudoers/regress/testsudoers/test21.out.ok,
	plugins/sudoers/regress/testsudoers/test21.sh:
	Add test to exercise the bug that prevented the group specified via
	"sudo -g" from matching when a Runas_Alias was used in the user or
	group portion of a Runas_Spec.
	[0d1732503]

2023-06-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match.c:
	runaslist_matches: split out user_list and group_list matching.

	This makes it possible to call the appropriate runas user or group
	list match function when resolving aliases instead of calling
	runaslist_matches() itself. Fixes a bug that prevented the group
	specified via "sudo -g" from matching when a Runas_Alias was used in
	the user or group portion of a Runas_Spec.
	[78e65e14e]

	* plugins/sudoers/match.c:
	runaslist_matches: fix bug when no runas list is specified in
	sudoers.

	If a sudoers rule has no runas list, a user-specified runas group
	should only be allowed if it matches a group that the default runas
	user belongs to. Instead, a missing group check allowed the user run
	commands as the default runas user with an arbitrary group.

	This means that a rule like "somebody host = ALL", which should be
	equivalent to "somebody host = (root) ALL", had the same effect as
	"somebody host = (root:ALL) ALL".
	[471028351]

	* plugins/sudoers/match.c:
	runaslist_matches: remove special case to handle "sudo -g group"

	Now that we are guaranteed to have a runas user list for all sudoers
	rules that contain a runas list, we can remove support for the
	special case where user_matched is set in the runas group matching
	conditional. This fixes a bug where "sudo -u myuser -g mygroup" was
	permitted by a rule like "myuser ALL = (root) ALL".
	[8c1559e0e]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/regress/sudoers/test27.json.ok,
	plugins/sudoers/regress/sudoers/test27.ldif.ok,
	plugins/sudoers/regress/sudoers/test27.out.ok:
	Populate runasusers even when only a grouplist is specified.

	When a sudoers rule permits the user to run commands as a group, not
	a user, we should set the runasusers to single member with the
	special MYSELF token. This guarantees that the only time runasusers
	will be NULL is when no runaslist is present.
	[64ab8cd23]

2023-06-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/python/pyhelpers.h:
	Python may be built with 32-bit time_t support on 32-bit platforms.
	We need to undef the SIZEOF_TIME_T from pyconfig.h so it does not
	conflict with our own.
	[a28d2d412]

2023-06-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* :
	Merge pull request #272 from millert/main

	Avoid use of variable length arrays and add ctype(3) casts.
	[ac46157e9]

	* lib/util/lbuf.c:
	Avoid use of variable length arrays and add ctype(3) casts.
	[8fbdd414c]

	* :
	Merge pull request #270 from moehanabi/main

	Add %n$s support for sudo_lbuf_append_v1
	[ee4f210f3]

2023-06-09  Brilliant Hanabi  <130747944+moehanabi@users.noreply.github.com>

	* lib/util/lbuf.c:
	Add %n$s support for sudo_lbuf_append_v1
	[932339ed9]

2023-06-09  bianguangze  <bianguangze@uniontech.com>

	* plugins/sudoers/alias.c:
	correct the return value type of function alias_find_used
	[b4dcac650]

2023-06-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/po/cs.mo, plugins/sudoers/po/cs.po,
	plugins/sudoers/po/de.mo, plugins/sudoers/po/de.po,
	plugins/sudoers/po/eo.mo, plugins/sudoers/po/eo.po,
	plugins/sudoers/po/fr.mo, plugins/sudoers/po/fr.po,
	plugins/sudoers/po/hr.mo, plugins/sudoers/po/hr.po,
	plugins/sudoers/po/ko.mo, plugins/sudoers/po/ko.po,
	plugins/sudoers/po/ro.mo, plugins/sudoers/po/ro.po,
	plugins/sudoers/po/ru.mo, plugins/sudoers/po/ru.po,
	plugins/sudoers/po/sr.mo, plugins/sudoers/po/sr.po,
	plugins/sudoers/po/uk.mo, plugins/sudoers/po/uk.po, po/cs.mo,
	po/cs.po, po/de.mo, po/de.po, po/eo.mo, po/eo.po, po/fr.mo,
	po/fr.po, po/hr.mo, po/hr.po, po/ko.mo, po/ko.po, po/ro.mo,
	po/ro.po, po/ru.mo, po/ru.po, po/sr.mo, po/sr.po, po/uk.mo,
	po/uk.po, po/vi.mo, po/vi.po:
	Updated translations from translationproject.org
	[5baf817db]

	* plugins/sudoers/po/sudoers.pot, po/sudo.pot:
	Update .pot files for 1.9.14
	[2c58d8075]

	* NEWS:
	Mention Bug #1050 fix.
	[2077b5157]

2023-06-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, configure, configure.ac:
	sudo 1.9.14
	[c7070b047]

2023-06-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.ldap.man.in, docs/sudoers.ldap.mdoc.in,
	plugins/sudoers/ldap.c, plugins/sudoers/ldap_conf.c,
	plugins/sudoers/sudo_ldap_conf.h:
	Add NETGROUP_QUERY option for servers that can't match
	nisNetgroupTriple. This can be used to support netgroup queries on
	systems that lack the innetgr() function and where the LDAP server
	cannot query the nisNetgroup by nisNetgroupTriple.
	[3786654db]

2023-06-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/defaults.c, plugins/sudoers/ldap.c,
	plugins/sudoers/match.c, plugins/sudoers/parse.h:
	sudo_ldap_check_non_unix_group: pass nss pointer to netgr_matches()
	This allows us to use the LDAP-specific version of innetgr() when
	possible. Also enable "use_netgroups" by default even on systems
	without innetgr() since we can now query netgroups directly via
	LDAP.
	[6fddb2875]

2023-06-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_ptrace.c:
	Only call ptrace_verify_post_exec() for intercept, not log_subcmds.
	[245c56bac]

2023-06-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/visudo.c:
	run_command: back out changes to run editor in its own process
	group. It unnecessarily complicates things to work around bugs in an
	OS almost no one runs.
	[2392ee9d7]

	* MANIFEST, include/sudo_util.h, lib/util/Makefile.in,
	lib/util/util.exp.in, plugins/sudoers/Makefile.in, src/Makefile.in,
	src/sudo_exec.h, src/suspend_parent.c:
	Make suspend_parent.c out of lib/util and into src. Nothing else
	uses it now.
	[95cd40907]

2023-06-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/digestname.c, plugins/sudoers/filedigest.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/parse.h,
	plugins/sudoers/regress/parser/check_digest.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	Initialize digest_type to SUDO_DIGEST_INVALID, not -1 and make it
	unsigned. This makes the digest type consistently unsigned instead
	of a mix of signed (for the -1 value in the tokenizer) and unsigned.
	[1278e36ff]

2023-05-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudo_plugin_python.man.in, docs/sudo_plugin_python.mdoc.in,
	etc/codespell.exclude, etc/codespell.ignore,
	plugins/sudoers/getdate.c, plugins/sudoers/getdate.y,
	plugins/sudoers/pivot.c, plugins/sudoers/visudo.c:
	Fix typos and update excluded/ignored codespell lists.
	[d633d82f2]

2023-05-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/visudo.c:
	run_command: check that ttyfd is not -1 before using it
	[0986a8846]

2023-05-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/visudo.c:
	Work around a macOS a kernel bug where tcsetpgrp() does not restart.

	I reported this bug to Apple over 12 years ago.
	[4d417b46d]

	* plugins/sudoers/visudo.c:
	run_command: run editor in foreground if visudo is the foreground
	process

	The command is now always run in its own process group. If visudo is
	run in the foreground, the command is run in the foreground too.
	Otherwise, run the command in the background. There is a race
	between the tcsetpgrp() call in the parent and the execve() in the
	child. If we lose the race and the command needs the controlling
	terminal, it will be stopped with SIGTTOU or SIGTTIN, which the
	waitpid() loop will handle.
	[be20e1592]

	* plugins/sudoers/visudo.c:
	Accept carriage return for EOL in addition to newline.

	Since visudo doesn't alter the terminal settings it is possible for
	the terminal to have the ONLCR bit set in the output control flags.
	In that case, we will get a CR, not a NL when the user presses
	enter/return. One way this can happen is if visudo is run in the
	background from a shell that supports line editing and the editor
	restores the (cbreak-style) terminal mode when it finishes.
	[7e28e60b5]

2023-05-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/parser/check_fill.c:
	check_fill: sudoers_strict() is now a function, not a global
	variable
	[91f100f5b]

	* plugins/sudoers/parse.h, plugins/sudoers/sudoers.h,
	plugins/sudoers/toke.h:
	Move parser prototypes / externs from sudoers.h to parse.h or
	toke.h.
	[f352ef5d6]

	* plugins/sudoers/file.c, plugins/sudoers/sudoers.c:
	parse.h is already included by sudoers.h.
	[01ff7c476]

	* plugins/sudoers/policy.c, plugins/sudoers/testsudoers.c,
	plugins/sudoers/visudo.c:
	Rename parser_conf -> sudoers_conf in all but the parser itself.
	[bde363e06]

2023-05-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/file.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/parse.h, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/visudo.c:
	Move sudoers search path to struct sudoers_parser_config.

	That way we can avoid passing it to init_parser() directly. We still
	need sudoers_search_path to be shared between the lexer and the
	parser.
	[8cbd5462a]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/file.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/parse.h, plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l,
	plugins/sudoers/toke_util.c, plugins/sudoers/visudo.c:
	Add struct sudoers_parser_config and pass it to init_parser().

	This struct contains parser configuration such as the sudoers file
	uid/gid/mode and parse flags such as verbose, strict and recovery.
	[9d7c30c5a]

	* plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	push_include_int: Avoid passing close(2) a negative value on error.
	Coverity CID 314108
	[fb9d0d79a]

	* plugins/sudoers/ldap.c:
	Eliminate dead store. Coverity CID 315032.
	[f722272b7]

2023-05-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_iolog.h, lib/iolog/iolog_gets.c:
	iolog_gets: change size parameter to int to match fgets/gzgets

	Return an error, setting errno to EINVAL, for negative sizes.
	[2f4b40680]

2023-05-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Rename force_umask to override_umask and make it private to
	sudoers.c.

	Add getter for policy.c.
	[c0fa3a4d2]

	* plugins/sudoers/check.h,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/set_perms.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/timestamp.c:
	Make timestamp_uid and timestamp_gid private to timestamp.c.

	Add getter (for set_perms.c) and setter (for sudoers.c).
	[72489d7a8]

	* plugins/sudoers/auth/bsdauth.c, plugins/sudoers/auth/sudo_auth.h,
	plugins/sudoers/policy.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.h:
	Make login_style private to bsdauth.c

	Add a setter for policy.c to handle auth_type from the front-end.
	[d5de5890f]

2023-05-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/sudo_debug.c:
	Back out last change, len must be int, not size_t, for %.*s.
	[cda03ed13]

	* src/exec_pty.c:
	Use a "%s" format instead of using a translated string as the
	format.
	[27ea64bac]

	* :
	Merge pull request #260 from AtariDreams/size_t

	Prefer size_t over int, as casting can take extra instructions
	[16191bb3d]

2023-05-03  Rose  <83477269+AtariDreams@users.noreply.github.com>

	* lib/eventlog/parse_json.c, lib/util/sudo_debug.c,
	plugins/sudoers/fmtsudoers.c:
	Prefer size_t over int, as casting can take extra instructions
	[459a49b1f]

2023-05-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	Rename init_parser_ext() to init_parser() and remove old wrapper.

	There was only one consumer of the init_parser() wrapper now that
	reset_parser() has been introduced.
	[bbbaea5b2]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.c:
	Add reset_parser() and use in place of init_parser(NULL).
	[f258a15df]

	* plugins/sudoers/ldap.c, plugins/sudoers/ldap_conf.c,
	plugins/sudoers/policy.c, plugins/sudoers/sudoers.h:
	Make path_ldap_conf and path_ldap_secret private to policy.c.

	Add getters for both so the ldap code can access them.
	[80768ed3a]

	* plugins/sudoers/file.c, plugins/sudoers/policy.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/toke.c,
	plugins/sudoers/toke.l, plugins/sudoers/visudo.c:
	Make sudoers_file private to policy.c and visudo.c.

	We just need a way for the policy (and visudo) to override the
	default sudoers path. This adds a getter to be used in file.c when
	sudoers is first opened.
	[f553ddc43]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.h, plugins/sudoers/testsudoers.c,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l,
	plugins/sudoers/visudo.c:
	Support adminconfdir for relative include paths in sudoers.
	[5446b009e]

	* plugins/sudoers/visudo.c:
	Track the destination sudoers path for each parsed file.

	When adminconfdir is enabled, the destination pathh may be different
	from the path we opened. We always store an edited file in the
	adminconfdir (if enabled). This makes it possible to use visudo when
	/etc/sudoers is located on a read-only file system.
	[7a6ac5d26]

	* INSTALL.md, Makefile.in, configure, configure.ac,
	docs/Makefile.in, examples/Makefile.in, include/Makefile.in,
	lib/util/Makefile.in, lib/zlib/Makefile.in, logsrvd/Makefile.in,
	m4/sudo.m4, plugins/audit_json/Makefile.in,
	plugins/group_file/Makefile.in, plugins/python/Makefile.in,
	plugins/sample/Makefile.in, plugins/sample_approval/Makefile.in,
	plugins/sudoers/Makefile.in, plugins/system_group/Makefile.in,
	src/Makefile.in:
	Add adminconfdir and --enable-adminconf to set it. Configuration
	paths in sudo are now a colon-separated list of files with the
	adminconfdir instance first (if enabled), followed by a sysconfdir
	instance.
	[d4c6ef122]

2023-03-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_13p3 for changeset 0bdd0b8469e3
	[16504a6b1]

	* NEWS, configure, configure.ac:
	Sudo 1.9.13p3
	[4e0de8d55]

2023-03-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match.c, plugins/sudoers/parse.c,
	plugins/sudoers/parse.h:
	A user with "list" privs for root may not list all users. A user
	with "sudo ALL" for root _is_ allowed to list any user.
	[f2b94c987]

	* plugins/sudoers/policy.c:
	sudoers_policy_list: do not set runas_pw to list_pw when listing
	This change introduced in sudo 1.9.13 is not actually needed. The
	"list" pseudo-command checks are performed via runas_matches_pw()
	which does not use runas_pw. GitHub issue #248
	[ef7cc6ed0]

	* plugins/sudoers/logging.c, plugins/sudoers/parse.c,
	plugins/sudoers/sudoers.c:
	Fix "sudo -l command args", broken in sudo 1.9.13. The value of
	user_args should not contain the command to be run in "sudo -l
	command args", only the arguments of the command being checked. This
	restores the pre-1.9.13 behavior. GitHub issue #249
	[2d0e31933]

2023-03-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_nopty.c, src/exec_pty.c:
	write_callback: only enable /dev/tty reader if the command is
	running This fixes a hang when there is /dev/tty data in a buffer to
	be flushed by the final call to del_io_events(). We do not want to
	re-enable the reader when flushing the buffers as part of
	pty_finish(). See PR #247 for analysis of the problem and how to
	reproduce it.
	[6fe3afb18]

2023-02-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/testsudoers/test12.out.ok,
	plugins/sudoers/regress/testsudoers/test12.sh:
	Test non-fully qualified path name.
	[fa2ed7d34]

	* plugins/sudoers/Makefile.in:
	Fix removal of y.tab.[ch] when generating gram.[ch].
	[49971eaa2]

	* MANIFEST, plugins/sudoers/regress/sudoers/test30.in,
	plugins/sudoers/regress/sudoers/test30.json.ok,
	plugins/sudoers/regress/sudoers/test30.ldif.ok,
	plugins/sudoers/regress/sudoers/test30.ldif2sudo.ok,
	plugins/sudoers/regress/sudoers/test30.out.ok,
	plugins/sudoers/regress/sudoers/test30.sudo.ok,
	plugins/sudoers/regress/sudoers/test30.toke.ok:
	Add test for using "list" as user, runas and host.
	[fd5e5f6e5]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	Move handling of the "list" pseudo-command from lexer to parser. The
	special handling of "list" in the lexer meant it could not be used
	as a user, group or host, which was unintentional. GitHub issue
	#246.
	[d1c74778c]

2023-02-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_compat.h:
	Make the check for HAVE_DECL_NSIG consistent with other decl checks.
	[4ae14db77]

2023-02-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_13p2 for changeset 2db7cee1cb77
	[95e063b48]

	* NEWS, configure, configure.ac:
	Sudo 1.9.13p2.
	[dc7ad19cb]

2023-02-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/match_command.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/regress/testsudoers/test20.sh,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	Fix potential double free for rules that include a CHROOT= option.
	If a rule with a CHROOT= option matches the user, host and runas,
	the user_cmnd variable could be freed twice.
	[c16867c67]

2023-02-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/lbuf.c:
	Add missing include of errno.h.
	[ea2f22bc9]

	* lib/util/lbuf.c:
	sudo_lbuf_expand: check for overflow when rounding to the nearest
	power of 2. Problem deteced by oss-fuzz using the fuzz_sudoers
	fuzzer.
	[bd0d5d2f1]

	* src/load_plugins.c:
	Fix --enable-static-sudoers, broken in sudo 1.9.13.
	sudo_qualify_plugin() should not try to fully-qualify the path to a
	statically-compiled plugin. GitHub issue #245
	[3d98e3bdf]

2023-02-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .hgtags:
	Added tag SUDO_1_9_13p1 for changeset 49e64402924f
	[52ae07db4]

	* :
	Merge sudo 1.9.13p1 from tip.
	[05cab83b1]

	* NEWS, configure, configure.ac:
	Sudo 1.9.13p1
	[58382028a]

	* configure.ac:
	Use m4_bmatch, m4_case does not support shell-style globbing.
	[42163ac0a]

	* configure, configure.ac:
	Allow configure.ac to be processed by autoconf 2.69. AC_PROG_CC_STDC
	is deprecated in autoconf 2.70 and above but it is necessary for
	autoconf 2.69.
	[2feea9b2f]

	* configure.ac:
	Only use AC_SYS_YEAR2038 if it is defined. Otherwise, use the method
	from 1.9.12. GitHub issue #242
	[d7080afe0]

2023-02-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* scripts/mkpkg:
	Sudo-specific executables moved to /usr/libexec/sudo starting in
	Debian 12 (Bookworm) and Ubuntu 22.04 (Jammy Jellyfish). Previously,
	they were stored in /usr/lib/sudo.
	[439f0734f]

	* lib/eventlog/Makefile.in, lib/iolog/Makefile.in,
	lib/util/Makefile.in, logsrvd/Makefile.in,
	plugins/python/Makefile.in, plugins/sudoers/Makefile.in,
	src/Makefile.in:
	Handle "locale -a" returning both C.UTF-8 and C.utf8. It is possible
	to have mutiple matches from the output of "locale -a". Just take
	the first one. Fixes GitHub issue #241.
	[2845ceafb]

	* lib/util/Makefile.in, logsrvd/Makefile.in,
	plugins/sudoers/Makefile.in, src/Makefile.in:
	Add some missing files to the clean and distclean targets.
	[4f50692ac]

	* :
	Merge pull request #240 from thesamesam/c23

	sudo_fatal: Fix build where compiler recognises [[noreturn]]
	attribut…
	[a845039de]

2023-02-15  Sam James  <sam@gentoo.org>

	* include/sudo_fatal.h:
	sudo_fatal: Fix build where compiler recognises [[noreturn]]
	attribute (C23)

	If the compiler supports [[noreturn]] as a attribute as in C23, then
	we define sudo_noreturn to be it. When that's the case, we must
	place it at the beginning of the declaration, before any other
	*extension* attributes (__attribute(...)).

	A bug has been filed with GCC regarding rejecting/accepting mixed
	attribute styles.

	sudo_dso_public is always an extension attribute, while
	sudo_noreturn only might be, so put it first.

	This only shows up with GCC 13 so far (see the linked GCC bug for a
	bit more exploration). Clang 16 does support the attribute but
	doesn't let you use it for earlier language versions (need to pass
	explicit -std=c2x, unlike with GCC here).

	This is essentially a followup to
	e707ffe58b3ccfe5c72f54c38eac1d7069d5021e.

	Tested with GCC 13.0.1 20230212 (unreleased), GCC 12.2.1 20230211,
	Clang 16.0.0_rc2, and Clang 15.0.7.

	Bug: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=108796 Closes:
	https://github.com/sudo-project/sudo/issues/239 Fixes:
	e707ffe58b3ccfe5c72f54c38eac1d7069d5021e Fixes:
	16ae61dcd7d3cd8bf6eb10a22fa742d4505da4e9
	[66359c2bc]

2023-02-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac:
	Add missing '[' to AS_IF() call. Fixes GitHub issue #238.
	[defec5d46]

	* .hgtags:
	Added tag SUDO_1_9_13 for changeset 813f6addf7cf
	[fe7e5d3b5]

	* :
	Merge sudo 1.9.13 from tip.
	[effed9ecb]

	* MANIFEST, plugins/sudoers/po/ka.mo:
	Add compiled version of the sudoers Georgian translation.
	[a80dcc6ac]

	* .gitignore, .hgignore:
	Do not ignore .mo files. Otherwise we are likely to miss uncommitted
	changes in them.
	[5eed6adb6]

	* plugins/sudoers/po/ru.mo, plugins/sudoers/po/zh_CN.mo,
	po/zh_CN.mo:
	Regenerate .mo files.
	[f1b07aed4]

2023-02-09  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/fuzz/fuzz_sudoers.c:
	No longer need to define sudoers_recovery here.
	[bdef2ad6d]

	* NEWS:
	Mention that a missing include file is no longer fatal.
	[0008d1f71]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.h,
	plugins/sudoers/gram.y, plugins/sudoers/policy.c:
	Recover from missing include file unless error_recovery is disabled.
	It is still treated as an error from a logging perspective, and mail
	is still sent.
	[26385b45c]

2023-02-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac, m4/sudo.m4, pathnames.h.in,
	plugins/sudoers/visudo.c:
	Substitute for _PATH_SUDO* variables in pathnames.h. Previously
	these were hard-coded with Makefile overrides.
	[9ad6dfa37]

2023-05-02  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/file.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/toke.c,
	plugins/sudoers/toke.l, plugins/sudoers/visudo.c:
	Support sudoers_file being a colon-separated path of files. The
	first file found is used.
	[f17b35471]

	* configure, configure.ac, include/sudo_util.h,
	lib/util/Makefile.in, lib/util/secure_path.c, lib/util/sudo_conf.c,
	lib/util/util.exp.in, logsrvd/Makefile.in, logsrvd/logsrvd.c,
	logsrvd/logsrvd_conf.c, plugins/sudoers/Makefile.in,
	plugins/sudoers/cvtsudoers.c, plugins/sudoers/sudoers.c,
	src/Makefile.in:
	Convert config file paths to colon-separated path list. This means
	that _PATH_SUDO_CONF, _PATH_SUDOERS, _PATH_SUDO_LOGSRVD_CONF, and
	_PATH_CVTSUDOERS_CONF can now specify multiple files. The first file
	that exists is used.
	[4363d03ef]

2023-05-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* config.h.in, configure:
	Regenerate with latest autoconf from git.
	[a7e906ff6]

2023-04-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/logsrvd_conf.c:
	No longer need to set AI_NUMERICSERV while fuzzing.

	Now that getaddrinfo() is stubbed out while fuzzing we can remove
	the hack that set AI_NUMERICSERV.
	[978aa9002]

2023-04-26  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/regress/fuzz/fuzz_logsrvd_conf.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c:
	getaddrinfo stub: set sin_port
	[d1f2452c0]

	* logsrvd/regress/fuzz/fuzz_logsrvd_conf.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c:
	Avoid NULL deref in stub getaddrinfo() when nodename is NULL. Also
	add support for parsing servname. We only need to support a subset
	of getaddrinfo() functionality in the fuzzer.
	[2898c8511]

	* configure, m4/hardening.m4:
	Add missing stdio.h include for the _FORTIFY_SOURCE=2 check.
	Implementations of _FORTIFY_SOURCE require the header file to be
	included. Also remove the useless test of an empty program with
	_FORTIFY_SOURCE defined. Pointed out by Florian Weimer.
	[075ee0f9d]

	* configure, m4/ldap.m4:
	Use ldap_msgfree() instead of ldap_init() for the lber.h test. The
	ldap_init() function is marked as deprecated and not defined by
	default on some systems. This can cause an error for compilers that
	do not support implicit function declarations. From Florian Weimer.
	[b83140e0f]

2023-04-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/regress/fuzz/fuzz_logsrvd_conf.c:
	Include arpa/inet.h for inet_pton() prototype.
	[47ae92d03]

	* logsrvd/regress/fuzz/fuzz_logsrvd_conf.c:
	Add netdb.h for struct addrinfo and EAI_* error codes.
	[3d4dc19ec]

	* logsrvd/regress/fuzz/fuzz_logsrvd_conf.c:
	Stub out getaddrinfo() and freeaddrinfo(). We may not be able have
	access to DNS in the fuzzing environment.
	[64f6d6fdb]

	* lib/eventlog/regress/eventlog_store/store_sudo_test.c:
	Plug memory leaks in store_sudo_test found by LSAN.
	[8c85fefae]

2023-04-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/limits.c:
	disable_coredump: only change the soft limit, leave the hard limit
	as-is This should avoid problems on Linux in cases where sudo does
	not have CAP_SYS_RESOURCE which may be the case in an unprivileged
	container. GitHub issue #42
	[b1deffbe5]

2023-04-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* scripts/build_pkgs:
	Add basic support for remote power on/off via net-snmp.
	[e2243e373]

	* src/exec.c:
	More accurate description of what happens for "sudo -b".
	[6c3c8acba]

2023-04-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_nopty.c, src/exec_pty.c, src/selinux.c, src/sudo.h,
	src/ttyname.c:
	Avoid calling isatty()/ttyname() on std{in,out,err} if not a char
	dev.

	The user controls these fds so we should avoid calling ioctl(2) on
	them unless they correspond to actual character device files.
	[ab0f8dda3]

2023-04-19  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	Better support for "sudo -b" when running the command in a pty.

	When a command is run via "sudo -b" it has no access to terminal
	input. In non-pty mode, the command runs in an orphaned process
	group and reads from the controlling terminal fail with EIO. We
	cannot do the same while running in a pty but if we set stdin to a
	half-closed pipe, reads from it will get EOF. That is close enough.
	[fe80c27de]

2023-04-18  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/parse_args.c, src/sudo_usage.h.in:
	Hard-code usage() and help() for an 80-column terminal.

	Trying to tailor the help and usage output to the terminal width is
	simply not worth it and could be abused to mark a socket as
	"trusted" on Linux if there are additional kernel bugs like
	CVE-2023-2002.
	[b24af7b3e]

	* config.h.in, configure, configure.ac, src/sudo.c,
	src/sudo_usage.h.in:
	Move CONFIGURE_ARGS from sudo_usage.h.in to config.h.in.
	[65c0b5a08]

2023-04-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/util/ttysize.c, src/sudo.c:
	get_user_info: call sudo_get_ttysize() even if no /dev/tty We still
	want to initialize rows and cols based on the environment if
	possible.
	[80b85bdd5]

2023-04-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/parse_args.c:
	Get the tty size using stdout, not stderr, when printing help
	output. While usage() prints to stderr, help() prints to stdout.
	[4ac994179]

	* src/sudo.c:
	get_user_info: pass sudo_get_ttysize() the fd of /dev/tty, not
	stderr. Both the plugin API and the main event loop expect
	lines/cols to refer to the user's terminal, so using /dev/tty is
	better here.
	[d1912957a]

	* include/sudo_util.h, lib/util/ttysize.c, lib/util/util.exp.in,
	plugins/sudoers/sudoreplay.c, src/parse_args.c, src/sudo.c:
	Add an fd argument to sudo_get_ttysize() instead of always using
	stderr.

	For sudoreplay we open /dev/tty, so use that instead of stderr when
	determining the terminal size.
	[cc22cca34]

	* lib/util/ttysize.c:
	Check whether stderr is a tty before trying TIOCGWINSZ.
	[5650b436e]

2023-04-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, configure.ac:
	Use -no-undefined on macOS to avoid "-undefined dynamic_lookup"
	warnings.

	Starting with macOS 13, the linker warns when "-undefined
	dynamic_lookup" is used. This is added by libtool by default on
	macOS but we can suppress it by passing -no-undefined to libtool.
	[ae12d18ff]

2023-04-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docker/debian/latest/Dockerfile, docker/debian/testing/Dockerfile,
	docker/fedora/latest/Dockerfile, docker/fedora/rawhide/Dockerfile,
	docker/ubuntu/devel/Dockerfile, docker/ubuntu/latest/Dockerfile,
	docker/ubuntu/rolling/Dockerfile:
	Add make to Dockerfile and sort packages.
	[62a2d9f94]

2023-04-06  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/UPGRADE.md, docs/sudoers.man.in, docs/sudoers.mdoc.in,
	plugins/sudoers/defaults.c:
	Enable the use_pty option by default for sudo 1.9.14.

	GitHub issue #258
	[894daa88f]

2023-04-05  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c,
	plugins/sudoers/sudoers.h:
	Split up the monolithic sudoers_policy_main() function.

	This splits the code to find the command, perform a sudoers lookup,
	ask for a password as needed, and perform post-lokup checks out into
	sudoers_check_common(). The old sudoers_policy_main() has been
	replaced by sudoers_check_cmnd() (called by sudoers_policy_check()),
	sudoers_validate_user() (called by sudoers_policy_validate()) and
	sudoers_list() (called by sudoers_policy_list()). The list_user
	lookup is now performed in sudoers_list().
	[d7b8f3ffb]

	* plugins/sudoers/sudoers.c:
	Move the root_sudo check until after we apply per-command Defaults.

	It is possible, though unlikely, for "root_sudo" to be used in a
	per-command Defaults statement.
	[859a81ad2]

2023-04-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.c:
	sudoers_policy_main: restore locale if sudoers_lookup() fails.

	Previously, if sudoers_lookup() set VALIDATE_ERROR, the sudoers
	locale would still be in effect instead of the original locale.
	[ab4b94716]

	* plugins/sudoers/parse.c:
	sudoers_lookup_pseudo: remove validated function argument

	This was always set to FLAG_NO_USER|FLAG_NO_HOST which are cleared
	at the top of the fuction. Make validated a local variables,
	initialized to 0, instead. No change in behavior.
	[fb0a36c1a]

2023-03-31  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/audit.c, plugins/sudoers/iolog.c:
	The I/O log file name is not just the basename of the full
	iolog_path. The audit plugin already has the correct value for
	iolog_file, don't overwrite it with basename(iolog_path). In the
	future we may wish to pass in iolog_file and iolog_dir in addition
	to iolog_path. Fixes Bug #1046.
	[0a4c8872a]

2023-03-29  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/sudoers.c:
	Warn with "unknown user" not "unknown uid" if user cannot be
	resolved. Prior to sudo 1.8 this was after a getpwuid() but now we
	use getpwnam().
	[ac12f82d8]

	* plugins/sudoers/sudoers.c:
	Set timestamp_uid and timestamp_gid via a callback. This also makes
	it possible to include the location of the line in the sudoers file
	in the warning message (and mail).
	[ad890acf6]

2023-03-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.ldap.man.in, docs/sudoers.ldap.mdoc.in:
	Fix display of escape sequencees in ldapsearch example.
	[493b2441d]

	* docs/sudoers.man.in, docs/sudoers.mdoc.in:
	White space is not allowed between Defaults and '@', ':', '!', '>'.
	The EBNF made it appear that this is allowed when it really is not.
	[3b55de4e8]

2023-03-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/edit_open.c, src/exec.c, src/exec_intercept.c,
	src/exec_intercept.h, src/exec_monitor.c, src/exec_nopty.c,
	src/exec_pty.c, src/sudo.c, src/sudo.h, src/sudo_edit.c,
	src/sudo_edit.h, src/sudo_exec.h, src/tgetpass.c:
	Make struct {command,user}_details pointers const where possible.
	[f0030cf30]

	* src/sudo.c, src/sudo.h, src/sudo_edit.c, src/tgetpass.c:
	Make user_details private to main.
	[554397eae]

	* src/exec.c, src/exec_nopty.c, src/exec_pty.c, src/parse_args.c,
	src/sudo.c, src/sudo.h, src/sudo_edit.c, src/sudo_exec.h,
	src/tgetpass.c:
	Make user_details private to sudo.c.
	[5108c279a]

2023-03-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/parse_args.c:
	Use sudo_get_ttysize() in help() and usage(). This eliminates a
	dependency on the user_details global.
	[e435b158b]

2023-03-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* configure, scripts/config.sub:
	Regenerate with the autoconf 2.72c snapshot.
	[f95c9f839]

2023-03-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec.c, src/sudo.c, src/sudo.h:
	Store submitcwd (from user_details) in struct command_details. This
	eliminates use of the user_details global from exec_setup().
	[86002226b]

2023-03-24  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/utmp.c:
	utmp_fill: user is now always non-NULL, no need for user_details.
	[51453c4f2]

	* src/parse_args.c, src/sudo.c, src/sudo.h:
	Remove list_user global.
	[fa5a28f34]

	* src/conversation.c:
	No need to declare tgetpass_flags, it is already in sudo.h.
	[a5b11a58b]

	* src/sudo.c:
	No need for sudo_mode to be global anymore.
	[9fd787343]

	* src/sudo.c:
	Make command_details private to main().
	[11277bb92]

	* src/exec_iolog.c, src/exec_nopty.c, src/exec_pty.c,
	src/sudo_exec.h:
	Make iobufs private to exec_iolog.c.
	[8d2b9a434]

	* src/sudo_exec.h:
	Remove ttymode and its associated values.
	[ee3f99c88]

	* src/exec.c, src/exec_pty.c, src/get_pty.c, src/sudo.h,
	src/sudo_exec.h:
	Move ptyname to struct exec_closure
	[f9b1beced]

	* src/exec_monitor.c, src/exec_pty.c, src/sudo_exec.h:
	Move pty_make_controlling() to exec_monitor.c where it is called. We
	can use details->tty to access the pty follower path.
	[22776b0be]

	* src/exec_pty.c, src/sudo.c:
	Eliminate utmp_user global, just use the value in struct command
	details.
	[7ac9ce001]

	* src/exec_iolog.c, src/exec_nopty.c, src/exec_pty.c,
	src/sudo_exec.h:
	Replace tty_mode global with term_raw flag in struct exec_closure.

	The pty_cleanup hook needs access to the closure so add
	pty_cleanup_init() to store a pointer to the closure for use by
	pty_cleanup_hook().
	[778688d4f]

	* src/exec_monitor.c, src/exec_pty.c, src/sudo_exec.h:
	Register pty cleanup function in exec_pty(), not exec_cmnd_pty(). We
	want it to execute in the main sudo process, not the monitor.
	[b81c5e8da]

	* src/exec_iolog.c:
	Make ttyblock private to exec_iolog.c
	[11739e3de]

2023-03-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c, src/sudo_exec.h:
	exec_pty.c: move foreground flag to struct exec_closure. Also make
	pipeline flag private to exec_pty() and remove the unneeded
	check_foreground() prototype.
	[3303dd98c]

	* src/exec_pty.c:
	On resume, always sync the pty terminal settings with /dev/tty.

	Changes made to the terminal settings while the command is suspended
	are now reflected in the pty when the command is resumed. This is
	more consistent with the non-pty behavior and allows for the removal
	of the "tty_initialized" global. One downside to this change is that
	if a terminal-based program using the pty is stopped with SIGSTOP it
	may have the wrong terminal settings on resume. However, this is no
	different from the non-pty case.
	[51cdb194b]

	* lib/util/suspend_parent.c, lib/util/term.c:
	Correct a comment.
	[3e734fa51]

2023-03-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* .github/FUNDING.yml:
	GitHub sponsor settings.
	[2a5d8bfea]

	* config.h.in, configure, configure.ac:
	Use built-in tests for bit types instead of using AC_CHECK_TYPES.
	This should be more portable as it handles the quirks of some older
	systems.
	[f0f5e1b5b]

	* plugins/sudoers/visudo.c, src/regress/intercept/test_ptrace.c:
	Quiet compiler warnings on systems where pid_t is not an int.
	Historically, pid_t was a long on some 32-bit systems like Solaris.
	[a17491972]

	* plugins/sudoers/visudo.c:
	Silence "used uninitialized" false positives with older gcc
	versions.
	[775059156]

	* src/exec_pty.c:
	exec_pty: always copy the terminal settings from /dev/tty the pty.
	Previously, we only did this when running in the foreground but this
	can cause problems when running a program that reads the terminal
	settings or window size in the background. If sudo is running in the
	background, the terminal settings will be updated if it transitions
	to the foreground process. Based on a suggestion from From Duncan
	Overbruck.
	[9d55ae892]

	* src/exec_pty.c:
	check_foreground: use SFD_LEADER not SFD_FOLLOWER (which was
	closed). Also use SFD_LEADER for sudo_term_copy() in exec_pty() for
	consistency. From Duncan Overbruck.
	[98ec786b4]

	* src/exec_pty.c:
	suspend_sudo_pty: fix cut & pasto in last commit to catch SIGCONT.
	Also set sa.sa_handler to SIG_DFL instead of SIG_IGN. There is no
	difference for SIGCONT but it means we can re-use sa as-is later.
	[acbe617fb]

2023-03-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* src/exec_pty.c:
	Catch SIGCONT and restore terminal settings on resume from SIGSTOP.
	While we cannot catch SIGSTOP, we _can_ catch SIGCONT and set
	/dev/tty to raw mode when running in the foreground. Ignore SIGCONT
	in suspend_sudo_pty() so we don't call resume_terminal() twice.
	[0fcbcaede]

	* src/exec_monitor.c, src/exec_pty.c:
	Only convert a signal number to a name if we are going to use it. It
	is mostly used for debug logging.
	[1772fc7b6]

	* src/exec_monitor.c, src/exec_pty.c, src/sudo.h:
	Move updating of the window size back to the main sudo process. We
	can use the leader file descriptor with TIOCGWINSZ to set the window
	size of the pty. Thanks to Duncan Overbruck for the hint.
	[adb84293a]

	* plugins/sudoers/visudo.c:
	visudo: restore controlling terminal after running the editor.
	Otherwise, visudo will get SIGTTOU if it tries to write to the
	terminal after the editor finishes. Also avoid races by setting the
	process group ID in both the parent and child, and grant the
	controlling terminal in the parent, not the child.
	[c64993a0b]

2023-03-20  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/visudo.man.in, docs/visudo.mdoc.in, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/sudoers.h,
	plugins/sudoers/toke.c, plugins/sudoers/toke.h,
	plugins/sudoers/toke.l:
	Warn about ignored files in sudoers.d in visudo.
	[28ecbe4d5]

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/gram.c,
	plugins/sudoers/gram.y, plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/sudoers.c, plugins/sudoers/sudoers.h,
	plugins/sudoers/testsudoers.c, plugins/sudoers/toke.c,
	plugins/sudoers/toke.l, plugins/sudoers/visudo.c:
	Replace sudoers_warnings with sudoers_verbose. This is now an int,
	with values > 1 reserved for visudo.
	[8049e4e32]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/toke.c, plugins/sudoers/toke.h,
	plugins/sudoers/toke.l:
	Split push_include() into push_include() and push_includedir(). This
	moves the "isdir" function argument to the internal version.
	[738387aa4]

2023-03-17  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/file.c, plugins/sudoers/ldap.c,
	plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/regress/fuzz/fuzz_stubs.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c, plugins/sudoers/sssd.c,
	plugins/sudoers/sudo_nss.c, plugins/sudoers/sudo_nss.h:
	Pass around const struct sudo_nss pointers where possible.
	[4b563ea44]

	* plugins/sudoers/alias.c, plugins/sudoers/cvtsudoers.c,
	plugins/sudoers/cvtsudoers.h, plugins/sudoers/cvtsudoers_csv.c,
	plugins/sudoers/cvtsudoers_json.c,
	plugins/sudoers/cvtsudoers_ldif.c, plugins/sudoers/defaults.c,
	plugins/sudoers/defaults.h, plugins/sudoers/fmtsudoers.c,
	plugins/sudoers/fmtsudoers_cvt.c, plugins/sudoers/match.c,
	plugins/sudoers/parse.h:
	Pass around const struct sudoers_parse_tree pointers where possible.
	[1f19a6b72]

	* plugins/sudoers/sudo_ldap.h, plugins/sudoers/sudo_ldap_conf.h:
	Move non-config-related macros to from sudo_ldap_conf.h to
	sudo_ldap.h.
	[70c533ec7]

2023-03-16  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, config.h.in, configure, configure.ac,
	include/sudo_compat.h, lib/util/Makefile.in, lib/util/getcwd.c,
	scripts/mkdep.pl:
	Remove portable getcwd.c, nothing uses it anymore. Any operating
	system supported by sudo already includes getcwd(3).
	[f5d0b7abf]

	* src/Makefile.in:
	Use LIBPROTOBUF_C and LIBUTIL variables and use them.
	[f2f233336]

2023-03-15  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_util.h:
	Remove now-unused sudo_timeval* macros.
	[14dd995b8]

	* lib/util/nanosleep.c:
	nanosleep: clear remainder on successful completion Also switch to
	doing everything in terms of struct timespec except for the actual
	select(2) call.
	[708cdc61b]

	* lib/eventlog/Makefile.in, lib/iolog/Makefile.in:
	Add lib dependencies for fuzzer and test targets.
	[3f5e7df3c]

	* lib/eventlog/eventlog_free.c:
	eventlog_free: free peeraddr
	[7683ba1b8]

	* plugins/sudoers/ldap_innetgr.c:
	sudo_ldap_netgroup_match_str: "-" in a netgroup can never match. We
	already check for a NULL value above so "str == NULL" is always
	false. Found by PVS-Studio.
	[b965d222d]

2023-03-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/iolog/Makefile.in:
	Fix static compilation.
	[027b42d5a]

	* MANIFEST:
	Replace eventlog_json.h with parse_json.h.
	[33cb885cf]

2023-03-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, lib/eventlog/Makefile.in,
	lib/eventlog/regress/eventlog_store/store_json_test.c,
	lib/eventlog/regress/eventlog_store/store_sudo_test.c,
	lib/eventlog/regress/eventlog_store/test1.json.in,
	lib/eventlog/regress/eventlog_store/test1.json.out.ok,
	lib/eventlog/regress/eventlog_store/test1.sudo.out.ok,
	lib/eventlog/regress/eventlog_store/test2.json.in,
	lib/eventlog/regress/eventlog_store/test2.json.out.ok,
	lib/eventlog/regress/eventlog_store/test2.sudo.out.ok,
	lib/eventlog/regress/eventlog_store/test3.json.in,
	lib/eventlog/regress/eventlog_store/test3.json.out.ok,
	lib/eventlog/regress/eventlog_store/test3.sudo.out.ok,
	lib/eventlog/regress/eventlog_store/test4.json.in,
	lib/eventlog/regress/eventlog_store/test4.json.out.ok,
	lib/eventlog/regress/eventlog_store/test4.sudo.out.ok,
	lib/eventlog/regress/parse_json/check_parse_json.c:
	Add tests for JSON and sudo-style log output.
	[1b3991b71]

2023-03-14  Todd C. Miller  <Todd.Miller@sudo.ws>

	* lib/eventlog/eventlog_free.c, lib/eventlog/parse_json.c:
	Add support for parsing all fields of struct eventlog.
	[0f46ffa9f]

2023-03-13  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match.c:
	Declare domain even if the system lacks innetgr(). Fixes a build
	error on musl-based systems like Alpine.
	[d8e6396c5]

	* lib/eventlog/Makefile.in:
	Add missing definition of $(SED).
	[918af413f]

	* MANIFEST, include/sudo_eventlog.h, lib/eventlog/Makefile.in,
	lib/eventlog/parse_json.c, lib/eventlog/parse_json.h,
	lib/eventlog/regress/parse_json/check_parse_json.c,
	lib/eventlog/regress/parse_json/test1.in,
	lib/eventlog/regress/parse_json/test2.in,
	lib/eventlog/regress/parse_json/test2.out.ok,
	lib/eventlog/regress/parse_json/test3.in,
	lib/eventlog/regress/parse_json/test3.out.ok, lib/iolog/Makefile.in,
	lib/iolog/iolog_json.c, lib/iolog/regress/fuzz/fuzz_iolog_json.c:
	Move JSON log parsing from libsudo_iolog.la to libsudo_eventlog.la
	It will be used in the upcoming log output tests.
	[86ab362fd]

	* lib/eventlog/eventlog.c:
	Add missing " ; " separator between environment variables and
	command. This is a regression introduced in sudo 1.9.13. GitHub
	issue #254.
	[12648b4e0]

2023-03-12  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.ldap.man.in, docs/sudoers.ldap.mdoc.in:
	Add example to verify support for searching by nisNetgroupTriple.
	[24f04c8cb]

2023-03-11  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/gc.c:
	Remove unused sudoers_gc_init() function.
	[34933ef9d]

2023-03-10  Todd C. Miller  <Todd.Miller@sudo.ws>

	* docs/sudoers.ldap.man.in, docs/sudoers.ldap.mdoc.in:
	Sudo now does its own netgroup lookups if NETGROUP_BASE is set.
	Previously, it only performed netgroup queries to determine the list
	of netgroups a user was a member of.
	[916d8b47c]

	* plugins/sudoers/regress/fuzz/fuzz_policy.c,
	plugins/sudoers/sudoers.c:
	sudoers_cleanup: free cached environment before running g/c. Avoids
	a double free in fuzz_policy.
	[c76ac1cab]

	* plugins/sudoers/policy.c, plugins/sudoers/sudoers.c:
	sudoers_cleanup: run the garbage collector at the end
	[cd5cd4533]

	* plugins/sudoers/sudoers.c:
	Plugin a memory leak in intercept mode.
	[c09aabecd]

	* src/exec_intercept.c:
	Sync non-intercept version of intercept_cleanup() declaration.
	[d5a784442]

	* plugins/sudoers/ldap_innetgr.c:
	Plug memory leak if ldap_get_option() fails with LDAP_NO_MEMORY.
	[33c385a78]

	* src/exec.c, src/exec_intercept.c, src/sudo_exec.h:
	Plug a memory leak with ptrace-based intercept.
	[c61306e58]

	* src/exec_intercept.c:
	Plug memory leak when log_subcmds is enabled.
	[31dad6b17]

	* lib/util/suspend_parent.c:
	Pass closure to callback, not the callback pointer itself.
	[cb7b1dd89]

	* MANIFEST, configure, m4/ldap.m4, plugins/sudoers/Makefile.in,
	plugins/sudoers/ldap.c, plugins/sudoers/ldap_innetgr.c,
	plugins/sudoers/sudo_ldap.h, scripts/mkdep.pl:
	Add LDAP-specific innetgr() implementation. Wheh netgroup_base is
	set we now do out own netgroup lookups using LDAP. Previously, LDAP
	was queried directly to get a list of the netgroups the user belongs
	to but other netgroups queries went through innetgr(3). This makes
	it possible to use netgroups in LDAP sudoers on systems that don't
	have an innetgr() function. GitHub issue #251.
	[fc253048f]

	* plugins/sudoers/ldap.c, plugins/sudoers/ldap_conf.c,
	plugins/sudoers/ldap_util.c, plugins/sudoers/sudo_ldap.h:
	Move some functions from ldap.c to ldap_util.c. These will be used
	by the LDAP innetgr() implementation.
	[554df8d93]

2023-03-08  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/cvtsudoers.c, plugins/sudoers/file.c,
	plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/ldap.c, plugins/sudoers/match.c,
	plugins/sudoers/parse.h,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers_ldif.c,
	plugins/sudoers/sssd.c, plugins/sudoers/sudo_nss.h:
	Add per-source innetgr function pointer and use it in
	netgr_matches(). This will be used to implement LDAP-specific
	netgroup lookups when netgroup_base is set in ldap.conf.
	[0aad96bba]

	* lib/zlib/Makefile.in:
	fix typo in uninstall target
	[d2582c2cd]

	* :
	Merge pull request #252 from bin-ly/main

	fix typo in uninstall target
	[954980b56]

2023-03-09  bin-ly  <binlingyu@uniontech.com>

	* lib/util/Makefile.in:
	fix command error for lib/util/Makefile.in
	[ec255dca1]

2023-03-07  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, lib/util/Makefile.in,
	lib/util/regress/digest/digest_test.c:
	Add tests for SHA2 digest support. This uses the NIST byte-oriented
	short message test vectors.
	[dea110a84]

2023-03-04  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, configure, configure.ac:
	Sudo 1.9.13p3
	[0df56634c]

2023-03-03  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/match.c, plugins/sudoers/parse.c,
	plugins/sudoers/parse.h:
	A user with "list" privs for root may not list all users. A user
	with "sudo ALL" for root _is_ allowed to list any user.
	[689022978]

	* plugins/sudoers/policy.c:
	sudoers_policy_list: do not set runas_pw to list_pw when listing
	This change introduced in sudo 1.9.13 is not actually needed. The
	"list" pseudo-command checks are performed via runas_matches_pw()
	which does not use runas_pw. GitHub issue #248
	[452d63d6c]

	* plugins/sudoers/logging.c, plugins/sudoers/parse.c,
	plugins/sudoers/sudoers.c:
	Fix "sudo -l command args", broken in sudo 1.9.13. The value of
	user_args should not contain the command to be run in "sudo -l
	command args", only the arguments of the command being checked. This
	restores the pre-1.9.13 behavior. GitHub issue #249
	[d9e9307d9]

2023-03-01  Todd C. Miller  <Todd.Miller@sudo.ws>

	* logsrvd/logsrv_util.c, logsrvd/logsrvd.c,
	logsrvd/logsrvd_journal.c, logsrvd/sendlog.c,
	plugins/sudoers/log_client.c:
	Check for sudo_pow2_roundup() overflow. Calling
	sudo_pow2_roundup(INT_MAX+2) will return since there is no power of
	2 larger than INT_MAX+1 that fits in an unsigned int. This is not an
	issue in practice since we restrict messages to 2Mib.
	[b013711e4]

	* src/exec_nopty.c, src/exec_pty.c:
	write_callback: only enable /dev/tty reader if the command is
	running This fixes a hang when there is /dev/tty data in a buffer to
	be flushed by the final call to del_io_events(). We do not want to
	re-enable the reader when flushing the buffers as part of
	pty_finish(). See PR #247 for analysis of the problem and how to
	reproduce it.
	[19a660612]

2023-02-28  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/regress/testsudoers/test12.out.ok,
	plugins/sudoers/regress/testsudoers/test12.sh:
	Test non-fully qualified path name.
	[43378de75]

	* plugins/sudoers/Makefile.in:
	Fix removal of y.tab.[ch] when generating gram.[ch].
	[7356a7796]

	* MANIFEST, plugins/sudoers/regress/sudoers/test30.in,
	plugins/sudoers/regress/sudoers/test30.json.ok,
	plugins/sudoers/regress/sudoers/test30.ldif.ok,
	plugins/sudoers/regress/sudoers/test30.ldif2sudo.ok,
	plugins/sudoers/regress/sudoers/test30.out.ok,
	plugins/sudoers/regress/sudoers/test30.sudo.ok,
	plugins/sudoers/regress/sudoers/test30.toke.ok:
	Add test for using "list" as user, runas and host.
	[172515c94]

	* plugins/sudoers/gram.c, plugins/sudoers/gram.y,
	plugins/sudoers/toke.c, plugins/sudoers/toke.l:
	Move handling of the "list" pseudo-command from lexer to parser. The
	special handling of "list" in the lexer meant it could not be used
	as a user, group or host, which was unintentional. GitHub issue
	#246.
	[0197491e9]

2023-02-27  Todd C. Miller  <Todd.Miller@sudo.ws>

	* include/sudo_compat.h:
	Make the check for HAVE_DECL_NSIG consistent with other decl checks.
	[6c97b84c0]

	* plugins/sudoers/match_command.c:
	Plug memory leak with multiple matching CHROOT= entries. Found by
	oss-fuzz.
	[a4f31cff2]

2023-02-25  Todd C. Miller  <Todd.Miller@sudo.ws>

	* NEWS, configure, configure.ac:
	Sudo 1.9.13p2.
	[f4d241262]

2023-02-21  Todd C. Miller  <Todd.Miller@sudo.ws>

	* MANIFEST, plugins/sudoers/match_command.c,
	plugins/sudoers/regress/fuzz/fuzz_sudoers.c,
	plugins/sudoers/regress/testsudoers/test20.out.ok,
	plugins/sudoers/regress/testsudoers/test20.sh,
	plugins/sudoers/testsudoers.c, plugins/sudoers/visudo.c:
	Fix potential double free for rules that include a CHROOT= option.
	If a rule with a CHROOT= option matches the user, host and runas,
	the user_cmnd variable could be freed twice.
	[87ce69246]

2023-02-23  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/logging.c:
	Include error string when formatting a SLOG_PARSE_ERROR message if
	present.
	[6c52056d3]

	* lib/util/lbuf.c:
	Add missing include of errno.h.
	[0be5a5191]

	* lib/util/lbuf.c:
	sudo_lbuf_expand: check for overflow when rounding to the nearest
	power of 2. Problem deteced by oss-fuzz using the fuzz_sudoers
	fuzzer.
	[3281d0eec]

	* src/load_plugins.c:
	Fix --enable-static-sudoers, broken in sudo 1.9.13.
	sudo_qualify_plugin() should not try to fully-qualify the path to a
	statically-compiled plugin. GitHub issue #245
	[91814990a]

2023-02-22  Todd C. Miller  <Todd.Miller@sudo.ws>

	* plugins/sudoers/logging.c, plugins/sudoers/logging.h,
	plugins/sudoers/sudoers.c:
